/*********** Preprocessed module -- do not edit ***************/
/*********** Preprocessed module -- do not edit ***************/
/*********** Preprocessed module -- do not edit ***************/
/*********** Preprocessed module -- do not edit ***************/
/*********** Preprocessed module -- do not edit ***************/
/***************** gpre version LI-V3.0.6.33328 Firebird 3.0 **********************/
/*
 *	PROGRAM:	JRD Backup and Restore Program
 *	MODULE:		backup.epp
 *	DESCRIPTION:	Backup routine
 *
 * The contents of this file are subject to the Interbase Public
 * License Version 1.0 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy
 * of the License at http://www.Inprise.com/IPL.html
 *
 * Software distributed under the License is distributed on an
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code was created by Inprise Corporation
 * and its predecessors. Portions created by Inprise Corporation are
 * Copyright (C) Inprise Corporation.
 *
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 *
 * Toni Martir: Added verbose backup records as BACKUP_VERBOSE_INTERVAL
 * 2001.07.06 Sean Leyne - Code Cleanup, removed "#ifdef READONLY_DATABASE"
 *                         conditionals, as the engine now fully supports
 *                         readonly databases.
 * 2001.11.20 Claudio Valderrama: fix problem with embedded blanks in
 * generators and use symbol_length effective length calculation from put_text.
 * This minimizes code redundancy and fixes SF Bug #483276.
 * 2001.12.15 Claudio Valderrama: copy should run through symbol_length instead
 * of using just another length calculation algorithm. Callers of put_text, copy
 * and symbol_length (if used directly) should use sizeof. Changed all callers
 * and sizeof() works because the strings are local to the functions. This
 * eliminates the problem with harcoded limits in each call.
 * 2002.10.29 Mike Nordell: UINT64 backup message.
 * 2003.08.17 Claudio Valderrama: Fix SF Bug #750659.
 * 2005.04.29 Claudio Valderrama: Moved symbol_length to misc.cpp.
 */


#include "firebird.h"
#include <stdio.h>
#include <memory.h>
#include <string.h>
#include "../burp/burp.h"
#include "../jrd/ods.h"
#include "../jrd/align.h"
#include "../common/gdsassert.h"
#include "../jrd/constants.h"
#include "../common/stuff.h"
#include "../burp/backu_proto.h"
#include "../burp/burp_proto.h"
#include "../burp/canon_proto.h"
#include "../burp/mvol_proto.h"
#include "../remote/protocol.h"
#ifdef DEBUG
#include "../common/prett_proto.h"
#endif

#include "../common/classes/UserBlob.h"
#include "../common/classes/MsgPrint.h"
#include "../burp/OdsDetection.h"

using MsgFormat::SafeArg;


// For service APIs the follow DB handle is a value stored
// in thread data.  This is also done for other statics generated by
// GPRE.  This is to avoid multiple threading problems with module
// level statics.

/*DATABASE DB = STATIC FILENAME "yachts.lnk" RUNTIME * dbb_file;*/
/**** GDS Preprocessor Definitions ****/
#ifndef JRD_IBASE_H
#include <ibase.h>
#endif

static const ISC_QUAD
   isc_blob_null = {0, 0};	/* initializer for blobs */
static isc_db_handle
   DB = 0;		/* database handle */

static isc_tr_handle
   gds_trans = 0;		/* default transaction handle */
static ISC_STATUS
   isc_status [20],	/* status vector */
   isc_status2 [20];	/* status vector */
static ISC_LONG
   isc_array_length, 	/* array return size */
   SQLCODE;		/* SQL status code */
static const char
   isc_tpb_3 [4] = {1,9,2,6};

static const char
   isc_tpb_2 [5] = {1,9,2,6,20};

static const char
   isc_tpb_1 [4] = {1,9,2,6};

static const char
   isc_tpb_0 [5] = {1,9,2,6,20};

static const short
   isc_4l = 283;
static const unsigned char
   isc_4 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 10,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring2, 0,0, 7,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 19, 'R','D','B','$','U','S','E','R','_','P','R','I','V','I','L','E','G','E','S', 0, 
		  blr_boolean, 
		     blr_not, 
			blr_missing, 
			   blr_field, 0, 11, 'R','D','B','$','G','R','A','N','T','O','R', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','O','B','J','E','C','T','_','T','Y','P','E', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','U','S','E','R','_','T','Y','P','E', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','G','R','A','N','T','_','O','P','T','I','O','N', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 8, 'R','D','B','$','U','S','E','R', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 11, 'R','D','B','$','G','R','A','N','T','O','R', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','P','R','I','V','I','L','E','G','E', 
			blr_parameter, 0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			blr_parameter2, 0, 9,0, 3,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 0,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_4 */

static const short
   isc_16l = 222;
static const unsigned char
   isc_16 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 6,0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 9, 'R','D','B','$','T','Y','P','E','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 8, 'R','D','B','$','T','Y','P','E', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','T','Y','P','E','_','N','A','M','E', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			blr_parameter, 0, 5,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 1,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_16 */

static const short
   isc_24l = 250;
static const unsigned char
   isc_24 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 4,0, 
	    blr_cstring2, 0,0, 0,4, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 2, 
		  blr_relation, 12, 'R','D','B','$','T','R','I','G','G','E','R','S', 0, 
		  blr_relation, 20, 'R','D','B','$','T','R','I','G','G','E','R','_','M','E','S','S','A','G','E','S', 1, 
		  blr_boolean, 
		     blr_and, 
			blr_eql, 
			   blr_field, 1, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','N','A','M','E', 
			   blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','N','A','M','E', 
			blr_or, 
			   blr_neq, 
			      blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			      blr_literal, blr_long, 0, 1,0,0,0,
			   blr_missing, 
			      blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 1, 11, 'R','D','B','$','M','E','S','S','A','G','E', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 1, 18, 'R','D','B','$','M','E','S','S','A','G','E','_','N','U','M','B','E','R', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 1, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','N','A','M','E', 
			blr_parameter, 0, 3,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 1,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_24 */

static const short
   isc_30l = 379;
static const unsigned char
   isc_30 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 13,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_int64, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 12, 'R','D','B','$','T','R','I','G','G','E','R','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','T','R','I','G','G','E','R','_','S','O','U','R','C','E', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','T','R','I','G','G','E','R','_','B','L','R', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','T','Y','P','E', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 9, 'R','D','B','$','F','L','A','G','S', 
			blr_parameter2, 0, 6,0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','T','R','I','G','G','E','R','_','I','N','A','C','T','I','V','E', 
			blr_parameter, 0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','T','R','I','G','G','E','R','_','S','E','Q','U','E','N','C','E', 
			blr_parameter, 0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','N','A','M','E', 
			blr_parameter, 0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter2, 0, 12,0, 10,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 4,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_30 */

static const short
   isc_45l = 495;
static const unsigned char
   isc_45 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 21,0, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_int64, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 12, 'R','D','B','$','T','R','I','G','G','E','R','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','E','N','T','R','Y','P','O','I','N','T', 
			blr_parameter2, 0, 0,0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','D','E','B','U','G','_','I','N','F','O', 
			blr_parameter2, 0, 1,0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','T','R','I','G','G','E','R','_','S','O','U','R','C','E', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','T','R','I','G','G','E','R','_','B','L','R', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','T','Y','P','E', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','V','A','L','I','D','_','B','L','R', 
			blr_parameter2, 0, 11,0, 10,0, 
		     blr_assignment, 
			blr_field, 0, 9, 'R','D','B','$','F','L','A','G','S', 
			blr_parameter2, 0, 13,0, 12,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','T','R','I','G','G','E','R','_','I','N','A','C','T','I','V','E', 
			blr_parameter, 0, 14,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 15,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','T','R','I','G','G','E','R','_','S','E','Q','U','E','N','C','E', 
			blr_parameter, 0, 16,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','N','A','M','E', 
			blr_parameter, 0, 18,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter2, 0, 19,0, 17,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','E','N','G','I','N','E','_','N','A','M','E', 
			blr_parameter2, 0, 20,0, 8,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 6,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_45 */

static const short
   isc_68l = 114;
static const unsigned char
   isc_68 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 5,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 15, 'R','D','B','$','D','B','_','C','R','E','A','T','O','R','S', 0, 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','U','S','E','R','_','T','Y','P','E', 
			blr_parameter2, 0, 3,0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 8, 'R','D','B','$','U','S','E','R', 
			blr_parameter2, 0, 4,0, 1,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 0,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_68 */

static const short
   isc_75l = 114;
static const unsigned char
   isc_75 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 2,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 9, 'R','D','B','$','R','O','L','E','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 13, 'R','D','B','$','R','O','L','E','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_parameter, 1, 1,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_75 */

static const short
   isc_81l = 327;
static const unsigned char
   isc_81 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 15,0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 5,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 253,3, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 16, 'R','D','B','$','A','U','T','H','_','M','A','P','P','I','N','G', 0, 
		  blr_boolean, 
		     blr_eql, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_literal, blr_long, 0, 0,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter2, 0, 0,0, 2,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','M','A','P','_','T','O','_','T','Y','P','E', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 12, 'R','D','B','$','M','A','P','_','N','A','M','E', 
			blr_parameter, 0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','M','A','P','_','U','S','I','N','G', 
			blr_parameter, 0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','M','A','P','_','P','L','U','G','I','N', 
			blr_parameter2, 0, 10,0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 10, 'R','D','B','$','M','A','P','_','D','B', 
			blr_parameter2, 0, 11,0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','M','A','P','_','F','R','O','M','_','T','Y','P','E', 
			blr_parameter, 0, 12,0, 
		     blr_assignment, 
			blr_field, 0, 12, 'R','D','B','$','M','A','P','_','F','R','O','M', 
			blr_parameter2, 0, 13,0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 10, 'R','D','B','$','M','A','P','_','T','O', 
			blr_parameter2, 0, 14,0, 3,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 1,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_81 */

static const short
   isc_98l = 107;
static const unsigned char
   isc_98 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 3,0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 9, 'R','D','B','$','R','O','L','E','S', 0, 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','R','O','L','E','_','N','A','M','E', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter, 0, 2,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 0,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_98 */

static const short
   isc_103l = 183;
static const unsigned char
   isc_103 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 5,0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 9, 'R','D','B','$','R','O','L','E','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_eql, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 0,0,0,0,
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter2, 0, 0,0, 2,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','R','O','L','E','_','N','A','M','E', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter, 0, 4,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 1,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_103 */

static const short
   isc_110l = 263;
static const unsigned char
   isc_110 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 7,0, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_long, 0, 
	    blr_long, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 9, 'R','D','B','$','F','I','L','E','S', 0, 
		  blr_boolean, 
		     blr_and, 
			blr_not, 
			   blr_missing, 
			      blr_field, 0, 17, 'R','D','B','$','S','H','A','D','O','W','_','N','U','M','B','E','R', 
			blr_neq, 
			   blr_field, 0, 17, 'R','D','B','$','S','H','A','D','O','W','_','N','U','M','B','E','R', 
			   blr_literal, blr_long, 0, 0,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','F','I','L','E','_','N','A','M','E', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','F','I','L','E','_','L','E','N','G','T','H', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','L','E','_','S','T','A','R','T', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','S','H','A','D','O','W','_','N','U','M','B','E','R', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','L','E','_','F','L','A','G','S', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','I','L','E','_','S','E','Q','U','E','N','C','E', 
			blr_parameter, 0, 6,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 3,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_110 */

static const short
   isc_119l = 172;
static const unsigned char
   isc_119 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 4,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 20, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S','E','S', 0, 
		  blr_boolean, 
		     blr_not, 
			blr_starting, 
			   blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			   blr_literal, blr_text, 4,0, 'S','Q','L','$',
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 7, 'R','D','B','$','A','C','L', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter, 0, 3,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 2,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_119 */

static const short
   isc_125l = 408;
static const unsigned char
   isc_125 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 15,0, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 13, 'R','D','B','$','R','E','L','A','T','I','O','N','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','E','X','T','E','R','N','A','L','_','F','I','L','E', 
			blr_parameter2, 0, 0,0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 24, 'R','D','B','$','E','X','T','E','R','N','A','L','_','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','V','I','E','W','_','S','O','U','R','C','E', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 12, 'R','D','B','$','V','I','E','W','_','B','L','R', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','R','E','L','A','T','I','O','N','_','I','D', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 9, 'R','D','B','$','F','L','A','G','S', 
			blr_parameter2, 0, 10,0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 12,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 13,0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter, 0, 14,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 5,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_125 */

static const short
   isc_142l = 443;
static const unsigned char
   isc_142 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 18,0, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 13, 'R','D','B','$','R','E','L','A','T','I','O','N','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','E','X','T','E','R','N','A','L','_','F','I','L','E', 
			blr_parameter2, 0, 0,0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 24, 'R','D','B','$','E','X','T','E','R','N','A','L','_','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','V','I','E','W','_','S','O','U','R','C','E', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 12, 'R','D','B','$','V','I','E','W','_','B','L','R', 
			blr_parameter2, 0, 4,0, 14,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','R','E','L','A','T','I','O','N','_','I','D', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','T','Y','P','E', 
			blr_parameter2, 0, 8,0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 9, 'R','D','B','$','F','L','A','G','S', 
			blr_parameter2, 0, 12,0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 13,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 15,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 16,0, 10,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter, 0, 17,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 5,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_142 */

static const short
   isc_162l = 359;
static const unsigned char
   isc_162 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 8,0, 
	    blr_cstring2, 0,0, 4,0, 
	    blr_cstring2, 0,0, 4,0, 
	    blr_cstring2, 0,0, 12,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 2, 
		  blr_relation, 24, 'R','D','B','$','R','E','L','A','T','I','O','N','_','C','O','N','S','T','R','A','I','N','T','S', 0, 
		  blr_relation, 13, 'R','D','B','$','R','E','L','A','T','I','O','N','S', 1, 
		  blr_boolean, 
		     blr_and, 
			blr_eql, 
			   blr_field, 1, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			   blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			blr_or, 
			   blr_missing, 
			      blr_field, 1, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_neq, 
			      blr_field, 1, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			      blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 22, 'R','D','B','$','I','N','I','T','I','A','L','L','Y','_','D','E','F','E','R','R','E','D', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','D','E','F','E','R','R','A','B','L','E', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','C','O','N','S','T','R','A','I','N','T','_','T','Y','P','E', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','C','O','N','S','T','R','A','I','N','T','_','N','A','M','E', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','I','N','D','E','X','_','N','A','M','E', 
			blr_parameter2, 0, 7,0, 4,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 3,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_162 */

static const short
   isc_172l = 211;
static const unsigned char
   isc_172 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 6,0, 
	    blr_cstring2, 0,0, 8,0, 
	    blr_cstring2, 0,0, 12,0, 
	    blr_cstring2, 0,0, 12,0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 19, 'R','D','B','$','R','E','F','_','C','O','N','S','T','R','A','I','N','T','S', 0, 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','M','A','T','C','H','_','O','P','T','I','O','N', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','L','E','T','E','_','R','U','L','E', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','U','P','D','A','T','E','_','R','U','L','E', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','C','O','N','S','T','R','A','I','N','T','_','N','A','M','E', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','C','O','N','S','T','_','N','A','M','E','_','U','Q', 
			blr_parameter, 0, 5,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 3,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_172 */

static const short
   isc_180l = 248;
static const unsigned char
   isc_180 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 6,0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 24, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','P','A','R','A','M','E','T','E','R','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 18, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 1,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','P','A','R','A','M','E','T','E','R','_','T','Y','P','E', 
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_field, 0, 20, 'R','D','B','$','P','A','R','A','M','E','T','E','R','_','N','U','M','B','E','R', 
			   blr_parameter, 1, 3,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','P','A','R','A','M','E','T','E','R','_','N','A','M','E', 
			   blr_parameter, 1, 4,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','S','O','U','R','C','E', 
			   blr_parameter, 1, 5,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 1,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_180 */

static const short
   isc_190l = 497;
static const unsigned char
   isc_190 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 18,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 2,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 24, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','P','A','R','A','M','E','T','E','R','S', 0, 
		     blr_boolean, 
			blr_and, 
			   blr_eql, 
			      blr_field, 0, 18, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','N','A','M','E', 
			      blr_parameter, 0, 0,0, 
			   blr_equiv, 
			      blr_field, 0, 16, 'R','D','B','$','P','A','C','K','A','G','E','_','N','A','M','E', 
			      blr_value_if, 
				 blr_eql, 
				    blr_parameter, 0, 1,0, 
				    blr_literal, blr_text, 0,0, 
				 blr_null, 
				 blr_parameter, 0, 1,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','D','E','F','A','U','L','T','_','S','O','U','R','C','E', 
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','D','E','F','A','U','L','T','_','V','A','L','U','E', 
			   blr_parameter, 1, 1,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 3,0, 
			blr_assignment, 
			   blr_field, 0, 23, 'R','D','B','$','P','A','R','A','M','E','T','E','R','_','M','E','C','H','A','N','I','S','M', 
			   blr_parameter2, 1, 7,0, 6,0, 
			blr_assignment, 
			   blr_field, 0, 13, 'R','D','B','$','N','U','L','L','_','F','L','A','G', 
			   blr_parameter2, 1, 9,0, 8,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','I','D', 
			   blr_parameter2, 1, 11,0, 10,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','P','A','R','A','M','E','T','E','R','_','T','Y','P','E', 
			   blr_parameter, 1, 12,0, 
			blr_assignment, 
			   blr_field, 0, 20, 'R','D','B','$','P','A','R','A','M','E','T','E','R','_','N','U','M','B','E','R', 
			   blr_parameter, 1, 13,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','P','A','R','A','M','E','T','E','R','_','N','A','M','E', 
			   blr_parameter, 1, 14,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','S','O','U','R','C','E', 
			   blr_parameter, 1, 15,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_parameter2, 1, 16,0, 5,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			   blr_parameter2, 1, 17,0, 4,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 3,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_190 */

static const short
   isc_213l = 340;
static const unsigned char
   isc_213 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 10,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 14, 'R','D','B','$','P','R','O','C','E','D','U','R','E','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','B','L','R', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','S','O','U','R','C','E', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 21, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','O','U','T','P','U','T','S', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','I','N','P','U','T','S', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','N','A','M','E', 
			blr_parameter, 0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 8,0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter, 0, 9,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 3,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_213 */

static const short
   isc_225l = 557;
static const unsigned char
   isc_225 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 26,0, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 14, 'R','D','B','$','P','R','O','C','E','D','U','R','E','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','E','N','T','R','Y','P','O','I','N','T', 
			blr_parameter2, 0, 0,0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','D','E','B','U','G','_','I','N','F','O', 
			blr_parameter2, 0, 1,0, 10,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','B','L','R', 
			blr_parameter2, 0, 2,0, 17,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','S','O','U','R','C','E', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','P','R','I','V','A','T','E','_','F','L','A','G', 
			blr_parameter2, 0, 7,0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','V','A','L','I','D','_','B','L','R', 
			blr_parameter2, 0, 12,0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','T','Y','P','E', 
			blr_parameter2, 0, 14,0, 13,0, 
		     blr_assignment, 
			blr_field, 0, 21, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','O','U','T','P','U','T','S', 
			blr_parameter, 0, 18,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','I','N','P','U','T','S', 
			blr_parameter, 0, 19,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','P','A','C','K','A','G','E','_','N','A','M','E', 
			blr_parameter2, 0, 21,0, 20,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','N','A','M','E', 
			blr_parameter, 0, 22,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 23,0, 16,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter2, 0, 24,0, 15,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','E','N','G','I','N','E','_','N','A','M','E', 
			blr_parameter2, 0, 25,0, 9,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 5,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_225 */

static const short
   isc_253l = 315;
static const unsigned char
   isc_253 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 14,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 12, 'R','D','B','$','P','A','C','K','A','G','E','S', 0, 
		  blr_boolean, 
		     blr_neq, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter2, 0, 0,0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 23, 'R','D','B','$','P','A','C','K','A','G','E','_','B','O','D','Y','_','S','O','U','R','C','E', 
			blr_parameter2, 0, 1,0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 25, 'R','D','B','$','P','A','C','K','A','G','E','_','H','E','A','D','E','R','_','S','O','U','R','C','E', 
			blr_parameter2, 0, 2,0, 10,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','V','A','L','I','D','_','B','O','D','Y','_','F','L','A','G', 
			blr_parameter2, 0, 8,0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','P','A','C','K','A','G','E','_','N','A','M','E', 
			blr_parameter, 0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 12,0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter2, 0, 13,0, 5,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 3,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_253 */

static const short
   isc_269l = 864;
static const unsigned char
   isc_269 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 36,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_cstring2, 0,0, 128,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 10, 'R','D','B','$','F','I','E','L','D','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','M','I','S','S','I','N','G','_','S','O','U','R','C','E', 
			blr_parameter2, 0, 0,0, 16,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','D','E','F','A','U','L','T','_','S','O','U','R','C','E', 
			blr_parameter2, 0, 1,0, 17,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','C','O','M','P','U','T','E','D','_','S','O','U','R','C','E', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','C','O','M','P','U','T','E','D','_','B','L','R', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 21, 'R','D','B','$','V','A','L','I','D','A','T','I','O','N','_','S','O','U','R','C','E', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','V','A','L','I','D','A','T','I','O','N','_','B','L','R', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','D','E','F','A','U','L','T','_','V','A','L','U','E', 
			blr_parameter, 0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','M','I','S','S','I','N','G','_','V','A','L','U','E', 
			blr_parameter, 0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','Q','U','E','R','Y','_','H','E','A','D','E','R', 
			blr_parameter, 0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','E','D','I','T','_','S','T','R','I','N','G', 
			blr_parameter2, 0, 10,0, 32,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','I','D', 
			blr_parameter2, 0, 13,0, 12,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			blr_parameter2, 0, 15,0, 14,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','L','E','N','G','T','H', 
			blr_parameter2, 0, 19,0, 18,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','N','U','L','L','_','F','L','A','G', 
			blr_parameter2, 0, 21,0, 20,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','D','I','M','E','N','S','I','O','N','S', 
			blr_parameter, 0, 22,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','E','X','T','E','R','N','A','L','_','S','C','A','L','E', 
			blr_parameter, 0, 23,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','E','X','T','E','R','N','A','L','_','T','Y','P','E', 
			blr_parameter, 0, 24,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','E','X','T','E','R','N','A','L','_','L','E','N','G','T','H', 
			blr_parameter, 0, 25,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 26,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','G','M','E','N','T','_','L','E','N','G','T','H', 
			blr_parameter, 0, 27,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','F','I','E','L','D','_','S','C','A','L','E', 
			blr_parameter, 0, 28,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T','Y','P','E', 
			blr_parameter, 0, 29,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','L','E','N','G','T','H', 
			blr_parameter, 0, 30,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','T','Y','P','E', 
			blr_parameter, 0, 31,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			blr_parameter, 0, 34,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
			blr_parameter2, 0, 35,0, 33,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 11,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_269 */

static const short
   isc_307l = 897;
static const unsigned char
   isc_307 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 38,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_cstring2, 0,0, 128,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 10, 'R','D','B','$','F','I','E','L','D','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','M','I','S','S','I','N','G','_','S','O','U','R','C','E', 
			blr_parameter2, 0, 0,0, 18,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','D','E','F','A','U','L','T','_','S','O','U','R','C','E', 
			blr_parameter2, 0, 1,0, 19,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','C','O','M','P','U','T','E','D','_','S','O','U','R','C','E', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','C','O','M','P','U','T','E','D','_','B','L','R', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 21, 'R','D','B','$','V','A','L','I','D','A','T','I','O','N','_','S','O','U','R','C','E', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','V','A','L','I','D','A','T','I','O','N','_','B','L','R', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','D','E','F','A','U','L','T','_','V','A','L','U','E', 
			blr_parameter, 0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','M','I','S','S','I','N','G','_','V','A','L','U','E', 
			blr_parameter, 0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','Q','U','E','R','Y','_','H','E','A','D','E','R', 
			blr_parameter, 0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','E','D','I','T','_','S','T','R','I','N','G', 
			blr_parameter2, 0, 10,0, 34,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','F','I','E','L','D','_','P','R','E','C','I','S','I','O','N', 
			blr_parameter2, 0, 13,0, 12,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','I','D', 
			blr_parameter2, 0, 15,0, 14,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			blr_parameter2, 0, 17,0, 16,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','L','E','N','G','T','H', 
			blr_parameter2, 0, 21,0, 20,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','N','U','L','L','_','F','L','A','G', 
			blr_parameter2, 0, 23,0, 22,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','D','I','M','E','N','S','I','O','N','S', 
			blr_parameter, 0, 24,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','E','X','T','E','R','N','A','L','_','S','C','A','L','E', 
			blr_parameter, 0, 25,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','E','X','T','E','R','N','A','L','_','T','Y','P','E', 
			blr_parameter, 0, 26,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','E','X','T','E','R','N','A','L','_','L','E','N','G','T','H', 
			blr_parameter, 0, 27,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 28,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','G','M','E','N','T','_','L','E','N','G','T','H', 
			blr_parameter, 0, 29,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','F','I','E','L','D','_','S','C','A','L','E', 
			blr_parameter, 0, 30,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T','Y','P','E', 
			blr_parameter, 0, 31,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','L','E','N','G','T','H', 
			blr_parameter, 0, 32,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','T','Y','P','E', 
			blr_parameter, 0, 33,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			blr_parameter, 0, 36,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
			blr_parameter2, 0, 37,0, 35,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 11,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_307 */

static const short
   isc_347l = 939;
static const unsigned char
   isc_347 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 42,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_cstring2, 0,0, 128,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 10, 'R','D','B','$','F','I','E','L','D','S', 0, 
		  blr_boolean, 
		     blr_neq, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','M','I','S','S','I','N','G','_','S','O','U','R','C','E', 
			blr_parameter2, 0, 0,0, 20,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','D','E','F','A','U','L','T','_','S','O','U','R','C','E', 
			blr_parameter2, 0, 1,0, 21,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','C','O','M','P','U','T','E','D','_','S','O','U','R','C','E', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','C','O','M','P','U','T','E','D','_','B','L','R', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 21, 'R','D','B','$','V','A','L','I','D','A','T','I','O','N','_','S','O','U','R','C','E', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','V','A','L','I','D','A','T','I','O','N','_','B','L','R', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','D','E','F','A','U','L','T','_','V','A','L','U','E', 
			blr_parameter, 0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','M','I','S','S','I','N','G','_','V','A','L','U','E', 
			blr_parameter, 0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','Q','U','E','R','Y','_','H','E','A','D','E','R', 
			blr_parameter, 0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','E','D','I','T','_','S','T','R','I','N','G', 
			blr_parameter2, 0, 10,0, 36,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','F','I','E','L','D','_','P','R','E','C','I','S','I','O','N', 
			blr_parameter2, 0, 15,0, 14,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','I','D', 
			blr_parameter2, 0, 17,0, 16,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			blr_parameter2, 0, 19,0, 18,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','L','E','N','G','T','H', 
			blr_parameter2, 0, 23,0, 22,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','N','U','L','L','_','F','L','A','G', 
			blr_parameter2, 0, 25,0, 24,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','D','I','M','E','N','S','I','O','N','S', 
			blr_parameter, 0, 26,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','E','X','T','E','R','N','A','L','_','S','C','A','L','E', 
			blr_parameter, 0, 27,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','E','X','T','E','R','N','A','L','_','T','Y','P','E', 
			blr_parameter, 0, 28,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','E','X','T','E','R','N','A','L','_','L','E','N','G','T','H', 
			blr_parameter, 0, 29,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 30,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','G','M','E','N','T','_','L','E','N','G','T','H', 
			blr_parameter, 0, 31,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','F','I','E','L','D','_','S','C','A','L','E', 
			blr_parameter, 0, 32,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T','Y','P','E', 
			blr_parameter, 0, 33,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','L','E','N','G','T','H', 
			blr_parameter, 0, 34,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','T','Y','P','E', 
			blr_parameter, 0, 35,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			blr_parameter, 0, 38,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
			blr_parameter2, 0, 39,0, 37,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 40,0, 13,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter2, 0, 41,0, 12,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 11,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_347 */

static const short
   isc_391l = 139;
static const unsigned char
   isc_391 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 2,0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 14, 'R','D','B','$','G','E','N','E','R','A','T','O','R','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','G','E','N','E','R','A','T','O','R','_','N','A','M','E', 
			blr_parameter, 0, 1,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 0,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_391 */

static const short
   isc_395l = 168;
static const unsigned char
   isc_395 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 4,0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 14, 'R','D','B','$','G','E','N','E','R','A','T','O','R','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter2, 0, 0,0, 2,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','G','E','N','E','R','A','T','O','R','_','N','A','M','E', 
			blr_parameter, 0, 3,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 1,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_395 */

static const short
   isc_401l = 299;
static const unsigned char
   isc_401 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 12,0, 
	    blr_int64, 0, 
	    blr_quad, 0, 
	    blr_long, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 14, 'R','D','B','$','G','E','N','E','R','A','T','O','R','S', 0, 
		  blr_boolean, 
		     blr_neq, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','I','N','I','T','I','A','L','_','V','A','L','U','E', 
			blr_parameter2, 0, 0,0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter2, 0, 1,0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 23, 'R','D','B','$','G','E','N','E','R','A','T','O','R','_','I','N','C','R','E','M','E','N','T', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','G','E','N','E','R','A','T','O','R','_','N','A','M','E', 
			blr_parameter, 0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 10,0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter2, 0, 11,0, 5,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 3,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_401 */

static const short
   isc_415l = 325;
static const unsigned char
   isc_415 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 10,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 22, 'R','D','B','$','F','U','N','C','T','I','O','N','_','A','R','G','U','M','E','N','T','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			   blr_parameter2, 1, 2,0, 1,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T','Y','P','E', 
			   blr_parameter, 1, 3,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','L','E','N','G','T','H', 
			   blr_parameter, 1, 4,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','F','I','E','L','D','_','S','C','A','L','E', 
			   blr_parameter, 1, 5,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','T','Y','P','E', 
			   blr_parameter, 1, 6,0, 
			blr_assignment, 
			   blr_field, 0, 13, 'R','D','B','$','M','E','C','H','A','N','I','S','M', 
			   blr_parameter, 1, 7,0, 
			blr_assignment, 
			   blr_field, 0, 21, 'R','D','B','$','A','R','G','U','M','E','N','T','_','P','O','S','I','T','I','O','N', 
			   blr_parameter, 1, 8,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 1, 9,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_415 */

static const short
   isc_429l = 358;
static const unsigned char
   isc_429 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 12,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 22, 'R','D','B','$','F','U','N','C','T','I','O','N','_','A','R','G','U','M','E','N','T','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 19, 'R','D','B','$','F','I','E','L','D','_','P','R','E','C','I','S','I','O','N', 
			   blr_parameter2, 1, 2,0, 1,0, 
			blr_assignment, 
			   blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			   blr_parameter2, 1, 4,0, 3,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T','Y','P','E', 
			   blr_parameter, 1, 5,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','L','E','N','G','T','H', 
			   blr_parameter, 1, 6,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','F','I','E','L','D','_','S','C','A','L','E', 
			   blr_parameter, 1, 7,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','T','Y','P','E', 
			   blr_parameter, 1, 8,0, 
			blr_assignment, 
			   blr_field, 0, 13, 'R','D','B','$','M','E','C','H','A','N','I','S','M', 
			   blr_parameter, 1, 9,0, 
			blr_assignment, 
			   blr_field, 0, 21, 'R','D','B','$','A','R','G','U','M','E','N','T','_','P','O','S','I','T','I','O','N', 
			   blr_parameter, 1, 10,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 1, 11,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_429 */

static const short
   isc_445l = 737;
static const unsigned char
   isc_445 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 34,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 2,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 22, 'R','D','B','$','F','U','N','C','T','I','O','N','_','A','R','G','U','M','E','N','T','S', 0, 
		     blr_boolean, 
			blr_and, 
			   blr_eql, 
			      blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			      blr_parameter, 0, 0,0, 
			   blr_equiv, 
			      blr_field, 0, 16, 'R','D','B','$','P','A','C','K','A','G','E','_','N','A','M','E', 
			      blr_value_if, 
				 blr_eql, 
				    blr_parameter, 0, 1,0, 
				    blr_literal, blr_text, 0,0, 
				 blr_null, 
				 blr_parameter, 0, 1,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			   blr_parameter2, 1, 0,0, 4,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','D','E','F','A','U','L','T','_','S','O','U','R','C','E', 
			   blr_parameter2, 1, 1,0, 13,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','D','E','F','A','U','L','T','_','V','A','L','U','E', 
			   blr_parameter2, 1, 2,0, 14,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 3,0, 
			blr_assignment, 
			   blr_field, 0, 22, 'R','D','B','$','A','R','G','U','M','E','N','T','_','M','E','C','H','A','N','I','S','M', 
			   blr_parameter2, 1, 8,0, 7,0, 
			blr_assignment, 
			   blr_field, 0, 13, 'R','D','B','$','N','U','L','L','_','F','L','A','G', 
			   blr_parameter2, 1, 10,0, 9,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','I','D', 
			   blr_parameter2, 1, 12,0, 11,0, 
			blr_assignment, 
			   blr_field, 0, 19, 'R','D','B','$','F','I','E','L','D','_','P','R','E','C','I','S','I','O','N', 
			   blr_parameter2, 1, 18,0, 17,0, 
			blr_assignment, 
			   blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			   blr_parameter2, 1, 20,0, 19,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T','Y','P','E', 
			   blr_parameter, 1, 21,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','L','E','N','G','T','H', 
			   blr_parameter, 1, 22,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','F','I','E','L','D','_','S','C','A','L','E', 
			   blr_parameter, 1, 23,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','T','Y','P','E', 
			   blr_parameter, 1, 24,0, 
			blr_assignment, 
			   blr_field, 0, 13, 'R','D','B','$','M','E','C','H','A','N','I','S','M', 
			   blr_parameter, 1, 25,0, 
			blr_assignment, 
			   blr_field, 0, 21, 'R','D','B','$','A','R','G','U','M','E','N','T','_','P','O','S','I','T','I','O','N', 
			   blr_parameter, 1, 26,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','P','A','C','K','A','G','E','_','N','A','M','E', 
			   blr_parameter2, 1, 28,0, 27,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 1, 29,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','A','R','G','U','M','E','N','T','_','N','A','M','E', 
			   blr_parameter2, 1, 30,0, 16,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','S','O','U','R','C','E', 
			   blr_parameter2, 1, 31,0, 15,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_parameter2, 1, 32,0, 6,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			   blr_parameter2, 1, 33,0, 5,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 3,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_445 */

static const short
   isc_484l = 298;
static const unsigned char
   isc_484 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 8,0, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 13, 'R','D','B','$','F','U','N','C','T','I','O','N','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','E','N','T','R','Y','P','O','I','N','T', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','M','O','D','U','L','E','_','N','A','M','E', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','T','Y','P','E', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','R','E','T','U','R','N','_','A','R','G','U','M','E','N','T', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
			blr_parameter, 0, 7,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 3,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_484 */

static const short
   isc_494l = 622;
static const unsigned char
   isc_494 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 32,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 13, 'R','D','B','$','F','U','N','C','T','I','O','N','S', 0, 
		  blr_boolean, 
		     blr_neq, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','D','E','B','U','G','_','I','N','F','O', 
			blr_parameter2, 0, 0,0, 13,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','F','U','N','C','T','I','O','N','_','S','O','U','R','C','E', 
			blr_parameter2, 0, 1,0, 16,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','F','U','N','C','T','I','O','N','_','B','L','R', 
			blr_parameter2, 0, 2,0, 17,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','E','N','T','R','Y','P','O','I','N','T', 
			blr_parameter2, 0, 3,0, 21,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','M','O','D','U','L','E','_','N','A','M','E', 
			blr_parameter2, 0, 4,0, 22,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 22, 'R','D','B','$','D','E','T','E','R','M','I','N','I','S','T','I','C','_','F','L','A','G', 
			blr_parameter2, 0, 8,0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','L','E','G','A','C','Y','_','F','L','A','G', 
			blr_parameter2, 0, 10,0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','V','A','L','I','D','_','B','L','R', 
			blr_parameter2, 0, 15,0, 14,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','P','R','I','V','A','T','E','_','F','L','A','G', 
			blr_parameter2, 0, 19,0, 18,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','T','Y','P','E', 
			blr_parameter, 0, 23,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','R','E','T','U','R','N','_','A','R','G','U','M','E','N','T', 
			blr_parameter, 0, 24,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','P','A','C','K','A','G','E','_','N','A','M','E', 
			blr_parameter2, 0, 26,0, 25,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 27,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
			blr_parameter, 0, 28,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','E','N','G','I','N','E','_','N','A','M','E', 
			blr_parameter2, 0, 29,0, 20,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 30,0, 12,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter2, 0, 31,0, 11,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 6,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_494 */

static const short
   isc_528l = 272;
static const unsigned char
   isc_528 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 7,0, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 11, 'R','D','B','$','F','I','L','T','E','R','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','E','N','T','R','Y','P','O','I','N','T', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','M','O','D','U','L','E','_','N','A','M','E', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','O','U','T','P','U','T','_','S','U','B','_','T','Y','P','E', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','I','N','P','U','T','_','S','U','B','_','T','Y','P','E', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 6,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 3,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_528 */

static const short
   isc_537l = 167;
static const unsigned char
   isc_537 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 5,0, 
	    blr_long, 0, 
	    blr_long, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 20, 'R','D','B','$','F','I','E','L','D','_','D','I','M','E','N','S','I','O','N','S', 0, 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','U','P','P','E','R','_','B','O','U','N','D', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','L','O','W','E','R','_','B','O','U','N','D', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','D','I','M','E','N','S','I','O','N', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			blr_parameter, 0, 4,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 2,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_537 */

static const short
   isc_544l = 188;
static const unsigned char
   isc_544 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 4,0, 
	    blr_quad, 0, 
	    blr_cstring2, 0,0, 0,4, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 14, 'R','D','B','$','E','X','C','E','P','T','I','O','N','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 11, 'R','D','B','$','M','E','S','S','A','G','E', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','E','X','C','E','P','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 3,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 2,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_544 */

static const short
   isc_550l = 230;
static const unsigned char
   isc_550 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 8,0, 
	    blr_quad, 0, 
	    blr_cstring2, 0,0, 0,4, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 14, 'R','D','B','$','E','X','C','E','P','T','I','O','N','S', 0, 
		  blr_boolean, 
		     blr_neq, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 11, 'R','D','B','$','M','E','S','S','A','G','E', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','E','X','C','E','P','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 6,0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter2, 0, 7,0, 3,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 2,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_550 */

static const short
   isc_560l = 156;
static const unsigned char
   isc_560 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 6,0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 12, 'R','D','B','$','D','A','T','A','B','A','S','E', 0, 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 4,0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 22, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','N','A','M','E', 
			blr_parameter2, 0, 5,0, 2,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 1,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_560 */

static const short
   isc_568l = 180;
static const unsigned char
   isc_568 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 8,0, 
	    blr_quad, 0, 
	    blr_long, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 12, 'R','D','B','$','D','A','T','A','B','A','S','E', 0, 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 10, 'R','D','B','$','L','I','N','G','E','R', 
			blr_parameter2, 0, 1,0, 3,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 6,0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 22, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','N','A','M','E', 
			blr_parameter2, 0, 7,0, 4,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 2,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_568 */

static const short
   isc_578l = 315;
static const unsigned char
   isc_578 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 10,0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 14, 'R','D','B','$','C','O','L','L','A','T','I','O','N','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter2, 0, 0,0, 3,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 24, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','A','T','T','R','I','B','U','T','E','S', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','I','D', 
			blr_parameter, 0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			blr_parameter2, 0, 9,0, 2,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 1,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_578 */

static const short
   isc_590l = 390;
static const unsigned char
   isc_590 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 14,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 14, 'R','D','B','$','C','O','L','L','A','T','I','O','N','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 23, 'R','D','B','$','S','P','E','C','I','F','I','C','_','A','T','T','R','I','B','U','T','E','S', 
			blr_parameter2, 0, 0,0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter2, 0, 1,0, 6,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 24, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','A','T','T','R','I','B','U','T','E','S', 
			blr_parameter, 0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			blr_parameter, 0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','I','D', 
			blr_parameter, 0, 10,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			blr_parameter2, 0, 12,0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 23, 'R','D','B','$','B','A','S','E','_','C','O','L','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter2, 0, 13,0, 4,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 2,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_590 */

static const short
   isc_606l = 432;
static const unsigned char
   isc_606 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 18,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 14, 'R','D','B','$','C','O','L','L','A','T','I','O','N','S', 0, 
		  blr_boolean, 
		     blr_neq, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 23, 'R','D','B','$','S','P','E','C','I','F','I','C','_','A','T','T','R','I','B','U','T','E','S', 
			blr_parameter2, 0, 0,0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter2, 0, 1,0, 8,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 24, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','A','T','T','R','I','B','U','T','E','S', 
			blr_parameter, 0, 10,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			blr_parameter, 0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','I','D', 
			blr_parameter, 0, 12,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 13,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			blr_parameter2, 0, 14,0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 23, 'R','D','B','$','B','A','S','E','_','C','O','L','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter2, 0, 15,0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 16,0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter2, 0, 17,0, 3,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 2,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_606 */

static const short
   isc_626l = 131;
static const unsigned char
   isc_626 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 4,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 21, 'R','D','B','$','C','H','E','C','K','_','C','O','N','S','T','R','A','I','N','T','S', 0, 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','C','O','N','S','T','R','A','I','N','T','_','N','A','M','E', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','N','A','M','E', 
			blr_parameter2, 0, 3,0, 1,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 0,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_626 */

static const short
   isc_632l = 457;
static const unsigned char
   isc_632 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 15,0, 
	    blr_quad, 0, 
	    blr_long, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 18, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_or, 
			   blr_neq, 
			      blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			      blr_literal, blr_long, 0, 1,0,0,0,
			   blr_neq, 
			      blr_field, 0, 24, 'R','D','B','$','D','E','F','A','U','L','T','_','C','O','L','L','A','T','E','_','N','A','M','E', 
			      blr_field, 0, 22, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','N','A','M','E', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter2, 0, 0,0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 24, 'R','D','B','$','N','U','M','B','E','R','_','O','F','_','C','H','A','R','A','C','T','E','R','S', 
			blr_parameter2, 0, 1,0, 7,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 23, 'R','D','B','$','B','Y','T','E','S','_','P','E','R','_','C','H','A','R','A','C','T','E','R', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter2, 0, 10,0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 22, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','N','A','M','E', 
			blr_parameter, 0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','F','O','R','M','_','O','F','_','U','S','E', 
			blr_parameter2, 0, 12,0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			blr_parameter2, 0, 13,0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 24, 'R','D','B','$','D','E','F','A','U','L','T','_','C','O','L','L','A','T','E','_','N','A','M','E', 
			blr_parameter, 0, 14,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 2,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_632 */

static const short
   isc_649l = 495;
static const unsigned char
   isc_649 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 18,0, 
	    blr_quad, 0, 
	    blr_long, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 18, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
			blr_neq, 
			   blr_field, 0, 24, 'R','D','B','$','D','E','F','A','U','L','T','_','C','O','L','L','A','T','E','_','N','A','M','E', 
			   blr_field, 0, 22, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','N','A','M','E', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter2, 0, 0,0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 24, 'R','D','B','$','N','U','M','B','E','R','_','O','F','_','C','H','A','R','A','C','T','E','R','S', 
			blr_parameter2, 0, 1,0, 9,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 23, 'R','D','B','$','B','Y','T','E','S','_','P','E','R','_','C','H','A','R','A','C','T','E','R', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			blr_parameter, 0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 22, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','N','A','M','E', 
			blr_parameter, 0, 12,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','F','O','R','M','_','O','F','_','U','S','E', 
			blr_parameter2, 0, 13,0, 10,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			blr_parameter2, 0, 14,0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 15,0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter2, 0, 16,0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 24, 'R','D','B','$','D','E','F','A','U','L','T','_','C','O','L','L','A','T','E','_','N','A','M','E', 
			blr_parameter, 0, 17,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 2,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_649 */

static const short
   isc_669l = 179;
static const unsigned char
   isc_669 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 4,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 253,3, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 18, 'R','D','B','$','V','I','E','W','_','R','E','L','A','T','I','O','N','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 13, 'R','D','B','$','V','I','E','W','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','V','I','E','W','_','C','O','N','T','E','X','T', 
			   blr_parameter, 1, 1,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','C','O','N','T','E','X','T','_','N','A','M','E', 
			   blr_parameter, 1, 3,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_669 */

static const short
   isc_677l = 240;
static const unsigned char
   isc_677 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 8,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 253,3, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 18, 'R','D','B','$','V','I','E','W','_','R','E','L','A','T','I','O','N','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 13, 'R','D','B','$','V','I','E','W','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','C','O','N','T','E','X','T','_','T','Y','P','E', 
			   blr_parameter2, 1, 3,0, 2,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','V','I','E','W','_','C','O','N','T','E','X','T', 
			   blr_parameter, 1, 4,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 1, 5,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','C','O','N','T','E','X','T','_','N','A','M','E', 
			   blr_parameter, 1, 6,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','P','A','C','K','A','G','E','_','N','A','M','E', 
			   blr_parameter2, 1, 7,0, 1,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_677 */

static const short
   isc_689l = 148;
static const unsigned char
   isc_689 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 2,0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 18, 'R','D','B','$','I','N','D','E','X','_','S','E','G','M','E','N','T','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 14, 'R','D','B','$','I','N','D','E','X','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_sort, 1, 
			blr_ascending, 
			   blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','P','O','S','I','T','I','O','N', 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_parameter, 1, 1,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_689 */

static const short
   isc_695l = 186;
static const unsigned char
   isc_695 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 1,0, 
	    blr_short, 0, 
	 blr_message, 0, 2,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 2, 
		     blr_relation, 18, 'R','D','B','$','I','N','D','E','X','_','S','E','G','M','E','N','T','S', 0, 
		     blr_relation, 19, 'R','D','B','$','R','E','L','A','T','I','O','N','_','F','I','E','L','D','S', 1, 
		     blr_boolean, 
			blr_and, 
			   blr_eql, 
			      blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			      blr_field, 1, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_and, 
			      blr_eql, 
				 blr_field, 0, 14, 'R','D','B','$','I','N','D','E','X','_','N','A','M','E', 
				 blr_parameter, 0, 0,0, 
			      blr_eql, 
				 blr_field, 1, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
				 blr_parameter, 0, 1,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_695 */

static const short
   isc_701l = 346;
static const unsigned char
   isc_701 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 13,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 11, 'R','D','B','$','I','N','D','I','C','E','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','E','X','P','R','E','S','S','I','O','N','_','B','L','R', 
			   blr_parameter2, 1, 0,0, 5,0, 
			blr_assignment, 
			   blr_field, 0, 21, 'R','D','B','$','E','X','P','R','E','S','S','I','O','N','_','S','O','U','R','C','E', 
			   blr_parameter2, 1, 1,0, 6,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 3,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','I','N','D','E','X','_','T','Y','P','E', 
			   blr_parameter, 1, 7,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','U','N','I','Q','U','E','_','F','L','A','G', 
			   blr_parameter, 1, 8,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','I','N','D','E','X','_','I','N','A','C','T','I','V','E', 
			   blr_parameter, 1, 9,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','S','E','G','M','E','N','T','_','C','O','U','N','T', 
			   blr_parameter, 1, 10,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','I','N','D','E','X','_','N','A','M','E', 
			   blr_parameter, 1, 11,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','F','O','R','E','I','G','N','_','K','E','Y', 
			   blr_parameter2, 1, 12,0, 4,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 3,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_701 */

static const short
   isc_718l = 193;
static const unsigned char
   isc_718 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 4,0, 
	    blr_long, 0, 
	    blr_long, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 20, 'R','D','B','$','F','I','E','L','D','_','D','I','M','E','N','S','I','O','N','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_sort, 1, 
			blr_ascending, 
			   blr_field, 0, 13, 'R','D','B','$','D','I','M','E','N','S','I','O','N', 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','U','P','P','E','R','_','B','O','U','N','D', 
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','L','O','W','E','R','_','B','O','U','N','D', 
			   blr_parameter, 1, 1,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_field, 0, 13, 'R','D','B','$','D','I','M','E','N','S','I','O','N', 
			   blr_parameter, 1, 3,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 2,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_718 */

static const short
   isc_726l = 840;
static const unsigned char
   isc_726 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 35,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_cstring2, 0,0, 128,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 2, 
		     blr_relation, 19, 'R','D','B','$','R','E','L','A','T','I','O','N','_','F','I','E','L','D','S', 0, 
		     blr_relation, 10, 'R','D','B','$','F','I','E','L','D','S', 1, 
		     blr_boolean, 
			blr_and, 
			   blr_eql, 
			      blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','S','O','U','R','C','E', 
			      blr_field, 1, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_eql, 
			      blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			      blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','D','E','F','A','U','L','T','_','S','O','U','R','C','E', 
			   blr_parameter2, 1, 0,0, 11,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','D','E','F','A','U','L','T','_','V','A','L','U','E', 
			   blr_parameter2, 1, 1,0, 12,0, 
			blr_assignment, 
			   blr_field, 1, 16, 'R','D','B','$','C','O','M','P','U','T','E','D','_','B','L','R', 
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','E','D','I','T','_','S','T','R','I','N','G', 
			   blr_parameter, 1, 3,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','Q','U','E','R','Y','_','H','E','A','D','E','R', 
			   blr_parameter2, 1, 4,0, 22,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			   blr_parameter2, 1, 5,0, 23,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 6,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','I','D', 
			   blr_parameter2, 1, 8,0, 7,0, 
			blr_assignment, 
			   blr_field, 1, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			   blr_parameter2, 1, 10,0, 9,0, 
			blr_assignment, 
			   blr_field, 0, 13, 'R','D','B','$','N','U','L','L','_','F','L','A','G', 
			   blr_parameter2, 1, 14,0, 13,0, 
			blr_assignment, 
			   blr_field, 1, 14, 'R','D','B','$','D','I','M','E','N','S','I','O','N','S', 
			   blr_parameter, 1, 15,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_parameter, 1, 16,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','U','P','D','A','T','E','_','F','L','A','G', 
			   blr_parameter2, 1, 18,0, 17,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','V','I','E','W','_','C','O','N','T','E','X','T', 
			   blr_parameter, 1, 19,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','P','O','S','I','T','I','O','N', 
			   blr_parameter2, 1, 21,0, 20,0, 
			blr_assignment, 
			   blr_field, 0, 12, 'R','D','B','$','F','I','E','L','D','_','I','D', 
			   blr_parameter, 1, 24,0, 
			blr_assignment, 
			   blr_field, 1, 15, 'R','D','B','$','F','I','E','L','D','_','S','C','A','L','E', 
			   blr_parameter, 1, 25,0, 
			blr_assignment, 
			   blr_field, 1, 16, 'R','D','B','$','F','I','E','L','D','_','L','E','N','G','T','H', 
			   blr_parameter, 1, 26,0, 
			blr_assignment, 
			   blr_field, 1, 18, 'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T','Y','P','E', 
			   blr_parameter, 1, 27,0, 
			blr_assignment, 
			   blr_field, 1, 14, 'R','D','B','$','F','I','E','L','D','_','T','Y','P','E', 
			   blr_parameter, 1, 28,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_parameter, 1, 29,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','S','O','U','R','C','E', 
			   blr_parameter, 1, 30,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','B','A','S','E','_','F','I','E','L','D', 
			   blr_parameter, 1, 31,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
			   blr_parameter, 1, 32,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','C','O','M','P','L','E','X','_','N','A','M','E', 
			   blr_parameter, 1, 33,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			   blr_parameter, 1, 34,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 6,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_726 */

static const short
   isc_765l = 900;
static const unsigned char
   isc_765 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 38,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_cstring2, 0,0, 128,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 2, 
		     blr_relation, 19, 'R','D','B','$','R','E','L','A','T','I','O','N','_','F','I','E','L','D','S', 0, 
		     blr_relation, 10, 'R','D','B','$','F','I','E','L','D','S', 1, 
		     blr_boolean, 
			blr_and, 
			   blr_eql, 
			      blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','S','O','U','R','C','E', 
			      blr_field, 1, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_eql, 
			      blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			      blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','D','E','F','A','U','L','T','_','S','O','U','R','C','E', 
			   blr_parameter2, 1, 0,0, 13,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','D','E','F','A','U','L','T','_','V','A','L','U','E', 
			   blr_parameter2, 1, 1,0, 14,0, 
			blr_assignment, 
			   blr_field, 1, 16, 'R','D','B','$','C','O','M','P','U','T','E','D','_','B','L','R', 
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','E','D','I','T','_','S','T','R','I','N','G', 
			   blr_parameter, 1, 3,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','Q','U','E','R','Y','_','H','E','A','D','E','R', 
			   blr_parameter2, 1, 4,0, 24,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			   blr_parameter2, 1, 5,0, 25,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 6,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','I','D','E','N','T','I','T','Y','_','T','Y','P','E', 
			   blr_parameter, 1, 7,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','I','D', 
			   blr_parameter2, 1, 10,0, 9,0, 
			blr_assignment, 
			   blr_field, 1, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			   blr_parameter2, 1, 12,0, 11,0, 
			blr_assignment, 
			   blr_field, 0, 13, 'R','D','B','$','N','U','L','L','_','F','L','A','G', 
			   blr_parameter2, 1, 16,0, 15,0, 
			blr_assignment, 
			   blr_field, 1, 14, 'R','D','B','$','D','I','M','E','N','S','I','O','N','S', 
			   blr_parameter, 1, 17,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_parameter, 1, 18,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','U','P','D','A','T','E','_','F','L','A','G', 
			   blr_parameter2, 1, 20,0, 19,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','V','I','E','W','_','C','O','N','T','E','X','T', 
			   blr_parameter, 1, 21,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','P','O','S','I','T','I','O','N', 
			   blr_parameter2, 1, 23,0, 22,0, 
			blr_assignment, 
			   blr_field, 0, 12, 'R','D','B','$','F','I','E','L','D','_','I','D', 
			   blr_parameter, 1, 26,0, 
			blr_assignment, 
			   blr_field, 1, 15, 'R','D','B','$','F','I','E','L','D','_','S','C','A','L','E', 
			   blr_parameter, 1, 27,0, 
			blr_assignment, 
			   blr_field, 1, 16, 'R','D','B','$','F','I','E','L','D','_','L','E','N','G','T','H', 
			   blr_parameter, 1, 28,0, 
			blr_assignment, 
			   blr_field, 1, 18, 'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T','Y','P','E', 
			   blr_parameter, 1, 29,0, 
			blr_assignment, 
			   blr_field, 1, 14, 'R','D','B','$','F','I','E','L','D','_','T','Y','P','E', 
			   blr_parameter, 1, 30,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_parameter, 1, 31,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','S','O','U','R','C','E', 
			   blr_parameter, 1, 32,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','B','A','S','E','_','F','I','E','L','D', 
			   blr_parameter, 1, 33,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
			   blr_parameter, 1, 34,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','C','O','M','P','L','E','X','_','N','A','M','E', 
			   blr_parameter, 1, 35,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			   blr_parameter, 1, 36,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','G','E','N','E','R','A','T','O','R','_','N','A','M','E', 
			   blr_parameter2, 1, 37,0, 8,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 6,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_765 */


#define gds_blob_null	isc_blob_null	/* compatibility symbols */
#define gds_status	isc_status
#define gds_status2	isc_status2
#define gds_array_length	isc_array_length
#define gds_count	isc_count
#define gds_slack	isc_slack
#define gds_utility	isc_utility	/* end of compatibility symbols */

#ifndef isc_version4
    Generate a compile-time error.
    Picking up a V3 include file after preprocessing with V4 GPRE.
#endif

/**** end of GPRE definitions ****/


#define DB			tdgbl->db_handle
#define gds_trans	tdgbl->tr_handle
#define isc_status	tdgbl->status_vector

namespace // unnamed, private
{

#define PUT_MESSAGE(attrib, attrib2, message) put_message((attrib), (attrib2), (message), sizeof(message))
#define PUT_TEXT(attribute, text)	put_text ((attribute), (text), sizeof(text))
#define COPY(source, target)       copy ((source), (target), sizeof(target))

inline void put(BurpGlobals* tdgbl, const UCHAR c)
{
	if (--(tdgbl->io_cnt) >= 0)
		*(tdgbl->io_ptr)++ = c;
	else
		MVOL_write(c, &tdgbl->io_cnt, &tdgbl->io_ptr);
}

inline void put(BurpGlobals* tdgbl, const att_type c)
{
	if (--tdgbl->io_cnt >= 0)
		*(tdgbl->io_ptr)++ = UCHAR(c);
	else
		MVOL_write(UCHAR(c), &tdgbl->io_cnt, &tdgbl->io_ptr);
}

inline const UCHAR* put_block(BurpGlobals* tdgbl, const UCHAR* p, ULONG n)
{
	return MVOL_write_block (tdgbl, p, n);
}


void compress(const UCHAR*, ULONG);
int copy(const TEXT*, TEXT*, ULONG);
burp_fld* get_fields(burp_rel*);
SINT64 get_gen_id(const TEXT*, SSHORT);
void get_ranges(burp_fld*);
void put_array(burp_fld*, burp_rel*, ISC_QUAD*);
void put_asciz(const att_type, const TEXT*);
void put_blob(burp_fld*, ISC_QUAD&);
bool put_blr_blob(att_type, ISC_QUAD&);
void put_data(burp_rel*);
void put_index(burp_rel*);
int put_message(att_type, att_type, const TEXT*, const ULONG);
void put_int32(att_type, SLONG);
void put_int64( att_type attribute, SINT64 value);
void put_relation(burp_rel*);
bool put_source_blob(att_type, att_type, ISC_QUAD&);
int put_text(att_type, const TEXT*, SSHORT);
void write_character_sets();
void write_check_constraints();
void write_collations();
void write_database(const TEXT*);
void write_exceptions();
void write_field_dimensions();
void write_filters();
void write_functions();
void write_function_args(const GDS_NAME, GDS_NAME);
void write_global_fields();
void write_generators();
void write_sql_roles();
void write_mapping();
void write_db_creators();
void write_packages();
void write_procedures();
void write_procedure_prms(const GDS_NAME, const GDS_NAME);
void write_ref_constraints();
void write_rel_constraints();
void write_relations();
void write_secclasses();
void write_shadow_files();
void write_triggers();
void write_trigger_messages();
void write_types();
void write_user_privileges();
void general_on_error();


#ifdef DEBUG
UCHAR debug_on = 0;		// able to turn this on in debug mode
#endif


const UCHAR blob_items[] =
{
	isc_info_blob_max_segment,
	isc_info_blob_num_segments,
	isc_info_blob_type,
	isc_info_blob_total_length
};
const UCHAR blr_items[] =
{
	isc_info_blob_max_segment,
	isc_info_blob_total_length
};
const UCHAR source_items[] =
{
	isc_info_blob_max_segment,
	isc_info_blob_total_length,
	isc_info_blob_num_segments
};
const SCHAR db_info_items[] =
{
	isc_info_db_sql_dialect,
	isc_info_page_size,
	isc_info_sweep_interval,
	isc_info_forced_writes,
	isc_info_no_reserve,
	isc_info_set_page_buffers,
	isc_info_db_read_only,
	isc_info_end
};
const SCHAR limbo_tpb[] =
{
	isc_tpb_version1,
	isc_tpb_ignore_limbo
};
const SCHAR limbo_nau_tpb[] =
{
	isc_tpb_version1,
	isc_tpb_ignore_limbo,
	isc_tpb_no_auto_undo
};

} // namespace


int BACKUP_backup(const TEXT* dbb_file, const TEXT* file_name)
{
/**************************************
 *
 *	B A C K U P _ b a c k u p
 *
 **************************************
 *
 * Functional description
 *	Backup a database.
 *
 **************************************/
	ISC_STATUS_ARRAY status_vector;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	tdgbl->gbl_database_file_name = dbb_file;

	tdgbl->io_ptr = NULL;
	tdgbl->io_cnt = 0;
	tdgbl->relations = NULL;
	tdgbl->runtimeODS = 0;

	gds_trans = 0;

	BURP_verbose(130);
	// msg 130 starting transaction

	if (tdgbl->gbl_sw_ignore_limbo)
	{
		if (isc_start_transaction(status_vector, &gds_trans, 1, &DB,
								  sizeof(limbo_nau_tpb), limbo_nau_tpb))
		{
			isc_start_transaction(status_vector, &gds_trans, 1, &DB, sizeof(limbo_tpb), limbo_tpb);
		}
	}
	else
	{
		/*EXEC SQL SET TRANSACTION NO_AUTO_UNDO;*/
		{
		isc_start_transaction (isc_status, (FB_API_HANDLE*) &gds_trans, (short) 1, &DB, (short) 5, isc_tpb_0);
		SQLCODE = isc_sqlcode(isc_status);
		}
		if (isc_status[1])
			/*EXEC SQL SET TRANSACTION;*/
			{
			isc_start_transaction (isc_status, (FB_API_HANDLE*) &gds_trans, (short) 1, &DB, (short) 4, isc_tpb_1);
			SQLCODE = isc_sqlcode(isc_status);
			}
	}

	if (!gds_trans)
	{
		/*EXEC SQL SET TRANSACTION NAME gds_trans NO_AUTO_UNDO;*/
		{
		isc_start_transaction (isc_status, (FB_API_HANDLE*) &gds_trans, (short) 1, &DB, (short) 5, isc_tpb_2);
		SQLCODE = isc_sqlcode(isc_status);
		}
		if (isc_status[1])
			/*EXEC SQL SET TRANSACTION NAME gds_trans;*/
			{
			isc_start_transaction (isc_status, (FB_API_HANDLE*) &gds_trans, (short) 1, &DB, (short) 4, isc_tpb_3);
			SQLCODE = isc_sqlcode(isc_status);
			}
	}


	// decide what type of database we've got

	detectRuntimeODS();
	if (tdgbl->runtimeODS < DB_VERSION_OLDEST_SUPPORTED)
	{
		BURP_error(348, true, SafeArg() << tdgbl->runtimeODS);
		// msg 348 database format @1 is too old to backup
	}

	// Write burp record first with other valuable information
	// In case of split operation, write a 'split' header first to all the files

	if (tdgbl->action->act_action == ACT_backup_split)
	{
		for (burp_fil* fil = tdgbl->gbl_sw_files; fil; fil = fil->fil_next)
		{
			tdgbl->action->act_file = fil;
			if (!MVOL_split_hdr_write())
			{
				BURP_error(269, true, tdgbl->action->act_file->fil_name.c_str());
				// msg 269 can't write a header record to file %s
			}
		}
		tdgbl->action->act_file = tdgbl->gbl_sw_files;
	}

	MVOL_init_write(file_name, &tdgbl->io_cnt, &tdgbl->io_ptr);

	// Write database record

	write_database(dbb_file);

	// Write global fields

	BURP_verbose(150);
	// msg 150  writing global fields
	write_global_fields();

	write_field_dimensions();

	BURP_verbose(162);
	// msg 162  writing shadow files
	write_shadow_files();

	// Write Character Sets
	BURP_verbose(msgVerbose_write_charsets);
	write_character_sets();

	// Write Collations
	BURP_verbose(msgVerbose_write_collations);
	write_collations();

	// Write relations

	BURP_verbose(154);
	// msg 154 writing tables

	write_relations();

	// Write types
	BURP_verbose(161);
	// msg 161  writing types
	write_types();

	// Write filters
	BURP_verbose(146);
	// msg 146 writing filters
	write_filters();

	// Write generators
	BURP_verbose(164);
	// msg 164  writing id generators
	write_generators();

	// Write exceptions
	BURP_verbose(197);
	// msg 197 writing exceptions
	write_exceptions();

	// Write functions
	BURP_verbose(148);
	// msg 148 writing functions
	write_functions();

	// Write procedures
	BURP_verbose(192);
	// msg 192 writing stored procedures
	write_procedures();

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		// Write packages
		BURP_verbose(336);	// msg 336 writing packages
		write_packages();
	}

	// Now go back and write all data

	for (burp_rel* relation = tdgbl->relations; relation; relation = relation->rel_next)
	{
		put(tdgbl, (UCHAR) rec_relation_data);
		PUT_TEXT(att_relation_name, relation->rel_name);
		put(tdgbl, att_end);

		if (!(relation->rel_flags & REL_view) && !(relation->rel_flags & REL_external))
		{
			put_index(relation);
			if (!(tdgbl->gbl_sw_meta || tdgbl->skipRelation(relation->rel_name)))
				put_data(relation);
		}

		put(tdgbl, (UCHAR) rec_relation_end);
	}

	// now for the new triggers in rdb$triggers
	BURP_verbose(159);
	// msg 159  writing triggers
	write_triggers();
	BURP_verbose(158);
	// msg 158 writing trigger messages
	write_trigger_messages();
	write_user_privileges();

	// Last, but not least, go back and add any access control lists

	BURP_verbose(347); // msg 347 writing security classes
	write_secclasses();

	// Write relation constraints
	BURP_verbose(206);
	// msg 206 writing relation constraints
	write_rel_constraints();

	// Write referential constraints
	BURP_verbose(209);
	// msg 209 writing referential constraints
	write_ref_constraints();

	// Write check constraints
	BURP_verbose(210);
	// msg 210 writing check constraints
	write_check_constraints();

	if (tdgbl->runtimeODS >= DB_VERSION_DDL9)
	{
		// Write SQL roles
		BURP_verbose(248);
		// msg 248 writing SQL roles
		write_sql_roles();
	}

	if (tdgbl->runtimeODS >= DB_VERSION_DDL11)
	{
		// Write names mapping
		BURP_verbose(296);
		// msg 296 writing mapping
		write_mapping();
	}

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		// Write database creators
		BURP_verbose(391);
		// msg 391 writing database creators
		write_db_creators();
	}

	// Finish up

	put(tdgbl, (UCHAR) rec_end);
	FB_UINT64 cumul_count = MVOL_fini_write(&tdgbl->io_cnt, &tdgbl->io_ptr);
	tdgbl->action->act_action = ACT_backup_fini;
	BURP_verbose(176, SafeArg() << cumul_count);
	// msg 176 closing file, committing, and finishing.  %ld bytes written

	/*COMMIT;*/
	{
	isc_commit_transaction (isc_status, (FB_API_HANDLE*) &gds_trans);;
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	if (gds_trans)
		/*COMMIT gds_trans;*/
		{
		isc_commit_transaction (isc_status, (FB_API_HANDLE*) &gds_trans);;
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	if (tdgbl->gbl_stat_flags)
		BURP_verbose(369);
	// msg 369 total statistics

	/*FINISH*/
	{
	if (DB)
	   isc_detach_database (isc_status, &DB);;
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	return FINI_OK;
}

namespace // unnamed, private
{

void compress(const UCHAR* data, ULONG length)
{
/**************************************
 *
 *	c o m p r e s s
 *
 **************************************
 *
 * Functional description
 *	Write out data in compressed form.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	const UCHAR* p = data;
	const UCHAR* end = p + length;
	const UCHAR* q = NULL;

	while (p < end)
	{
		for (q = p + 2; q < end && (q[-2] != q[-1] || q[-1] != q[0]); q++)
			;
		USHORT run = (q < end) ? q - p - 2 : end - p;
		if (run)
		{
			for (; run > 127; run -= 127)
			{
				USHORT len = 127;
				put(tdgbl, (UCHAR) len);
				p = put_block(tdgbl, p, len);
			}
			if (run)
			{
				put(tdgbl, (UCHAR) run);
				p = put_block(tdgbl, p, run);
			}
		}
		for (q = p; q < end && *q == *p; q++)
			;
		if ((run = q - p) != 0)
		{
			for (; run > 127; run -= 127)
			{
				put(tdgbl, (UCHAR) (-127));
				put(tdgbl, (UCHAR) (*p));
			}
			if (run)
			{
				put(tdgbl, (UCHAR) (-run));
				put(tdgbl, (UCHAR) (*p));
			}
			p = q;
		}
	}
}


int copy( const TEXT* from, TEXT* to, ULONG size_len)
{
/**************************************
 *
 *	c o p y
 *
 **************************************
 *
 * Functional description
 *	Copy a blank or null terminated string into a null terminated
 *	string. It assumes there's enough room in the target.
 *
 **************************************/

	const ULONG len = (ULONG) MISC_symbol_length(from, size_len);

	memcpy(to, from, len);
	to[len] = '\0';

	return (int) len;
}


void general_on_error()
{
/**************************************
 *
 *	g e n e r a l _ o n _ e r r o r
 *
 **************************************
 *
 * Functional description
 *	Handle any general ON_ERROR clause during backup.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	BURP_print_status(true, isc_status);
	BURP_abort();
}


burp_fld* get_fields( burp_rel* relation)
{
   struct isc_729_struct {
          ISC_QUAD isc_730;	/* RDB$DEFAULT_SOURCE */
          ISC_QUAD isc_731;	/* RDB$DEFAULT_VALUE */
          ISC_QUAD isc_732;	/* RDB$COMPUTED_BLR */
          char  isc_733 [128];	/* RDB$EDIT_STRING */
          ISC_QUAD isc_734;	/* RDB$QUERY_HEADER */
          ISC_QUAD isc_735;	/* RDB$DESCRIPTION */
          short isc_736;	/* isc_utility */
          short isc_737;	/* gds__null_flag */
          short isc_738;	/* RDB$COLLATION_ID */
          short isc_739;	/* gds__null_flag */
          short isc_740;	/* RDB$CHARACTER_SET_ID */
          short isc_741;	/* gds__null_flag */
          short isc_742;	/* gds__null_flag */
          short isc_743;	/* gds__null_flag */
          short isc_744;	/* RDB$NULL_FLAG */
          short isc_745;	/* RDB$DIMENSIONS */
          short isc_746;	/* RDB$SYSTEM_FLAG */
          short isc_747;	/* gds__null_flag */
          short isc_748;	/* RDB$UPDATE_FLAG */
          short isc_749;	/* RDB$VIEW_CONTEXT */
          short isc_750;	/* gds__null_flag */
          short isc_751;	/* RDB$FIELD_POSITION */
          short isc_752;	/* gds__null_flag */
          short isc_753;	/* gds__null_flag */
          short isc_754;	/* RDB$FIELD_ID */
          short isc_755;	/* RDB$FIELD_SCALE */
          short isc_756;	/* RDB$FIELD_LENGTH */
          short isc_757;	/* RDB$FIELD_SUB_TYPE */
          short isc_758;	/* RDB$FIELD_TYPE */
          char  isc_759 [125];	/* RDB$FIELD_NAME */
          char  isc_760 [125];	/* RDB$FIELD_SOURCE */
          char  isc_761 [125];	/* RDB$BASE_FIELD */
          char  isc_762 [125];	/* RDB$QUERY_NAME */
          char  isc_763 [125];	/* RDB$COMPLEX_NAME */
          char  isc_764 [125];	/* RDB$SECURITY_CLASS */
   } isc_729;
   struct isc_727_struct {
          char  isc_728 [125];	/* RDB$RELATION_NAME */
   } isc_727;
   struct isc_768_struct {
          ISC_QUAD isc_769;	/* RDB$DEFAULT_SOURCE */
          ISC_QUAD isc_770;	/* RDB$DEFAULT_VALUE */
          ISC_QUAD isc_771;	/* RDB$COMPUTED_BLR */
          char  isc_772 [128];	/* RDB$EDIT_STRING */
          ISC_QUAD isc_773;	/* RDB$QUERY_HEADER */
          ISC_QUAD isc_774;	/* RDB$DESCRIPTION */
          short isc_775;	/* isc_utility */
          short isc_776;	/* RDB$IDENTITY_TYPE */
          short isc_777;	/* gds__null_flag */
          short isc_778;	/* gds__null_flag */
          short isc_779;	/* RDB$COLLATION_ID */
          short isc_780;	/* gds__null_flag */
          short isc_781;	/* RDB$CHARACTER_SET_ID */
          short isc_782;	/* gds__null_flag */
          short isc_783;	/* gds__null_flag */
          short isc_784;	/* gds__null_flag */
          short isc_785;	/* RDB$NULL_FLAG */
          short isc_786;	/* RDB$DIMENSIONS */
          short isc_787;	/* RDB$SYSTEM_FLAG */
          short isc_788;	/* gds__null_flag */
          short isc_789;	/* RDB$UPDATE_FLAG */
          short isc_790;	/* RDB$VIEW_CONTEXT */
          short isc_791;	/* gds__null_flag */
          short isc_792;	/* RDB$FIELD_POSITION */
          short isc_793;	/* gds__null_flag */
          short isc_794;	/* gds__null_flag */
          short isc_795;	/* RDB$FIELD_ID */
          short isc_796;	/* RDB$FIELD_SCALE */
          short isc_797;	/* RDB$FIELD_LENGTH */
          short isc_798;	/* RDB$FIELD_SUB_TYPE */
          short isc_799;	/* RDB$FIELD_TYPE */
          char  isc_800 [125];	/* RDB$FIELD_NAME */
          char  isc_801 [125];	/* RDB$FIELD_SOURCE */
          char  isc_802 [125];	/* RDB$BASE_FIELD */
          char  isc_803 [125];	/* RDB$QUERY_NAME */
          char  isc_804 [125];	/* RDB$COMPLEX_NAME */
          char  isc_805 [125];	/* RDB$SECURITY_CLASS */
          char  isc_806 [125];	/* RDB$GENERATOR_NAME */
   } isc_768;
   struct isc_766_struct {
          char  isc_767 [125];	/* RDB$RELATION_NAME */
   } isc_766;
/**************************************
 *
 *	g e t _ f i e l d s
 *
 **************************************
 *
 * Functional description
 *	Get fields for a relation.  Test
 *	capabilities and get system specific
 *
 **************************************/
	burp_fld* field;
	ISC_QUAD* blob_id;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	USHORT count = 1;

	Firebird::HalfStaticArray<burp_fld*, 16> field_list;

	// if we have all capabilities, use the first request to get the
	// most performance out of the latest engine; if we don't
	// have one of the capabilities we must use the second set of
	// requests--this requires more code but it is well worth it
	// for the performance benefits, especially remotely--deej

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		/*FOR (REQUEST_HANDLE tdgbl->handles_get_fields_req_handle1)
			X IN RDB$RELATION_FIELDS CROSS
			Y IN RDB$FIELDS WITH
			X.RDB$FIELD_SOURCE = Y.RDB$FIELD_NAME AND
			X.RDB$RELATION_NAME EQ relation->rel_name*/
		{
		if (!tdgbl->handles_get_fields_req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle1, (short) sizeof(isc_765), (char*) isc_765);
		   }
		isc_vtov ((const char*) relation->rel_name, (char*) isc_766.isc_767, 125);
		if (tdgbl->handles_get_fields_req_handle1)
		   {
		   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_766, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle1, (short) 1, (short) 1093, &isc_768, (short) 0);
		   if (!isc_768.isc_775 || isc_status [1]) break;
		{
			field = (burp_fld*) BURP_alloc_zero(sizeof(burp_fld));
			field->fld_number = count++;
			field->fld_type = /*Y.RDB$FIELD_TYPE*/
					  isc_768.isc_799;
			field->fld_sub_type = /*Y.RDB$FIELD_SUB_TYPE*/
					      isc_768.isc_798;
			field->fld_length = /*Y.RDB$FIELD_LENGTH*/
					    isc_768.isc_797;
			field->fld_scale = /*Y.RDB$FIELD_SCALE*/
					   isc_768.isc_796;
			field->fld_id = /*X.RDB$FIELD_ID*/
					isc_768.isc_795;

			if (!/*X.RDB$DESCRIPTION.NULL*/
			     isc_768.isc_794)
			{
				blob_id = &/*X.RDB$DESCRIPTION*/
					   isc_768.isc_774;
				if (blob_id->gds_quad_low || blob_id->gds_quad_high)
					field->fld_description = /*X.RDB$DESCRIPTION*/
								 isc_768.isc_774;
			}

			if (!/*X.RDB$QUERY_HEADER.NULL*/
			     isc_768.isc_793)
			{
				blob_id = &/*X.RDB$QUERY_HEADER*/
					   isc_768.isc_773;
				if (blob_id->gds_quad_low || blob_id->gds_quad_high)
					field->fld_query_header = /*X.RDB$QUERY_HEADER*/
								  isc_768.isc_773;
			}

			if (/*X.RDB$FIELD_POSITION.NULL*/
			    isc_768.isc_791)
				field->fld_flags |= FLD_position_missing;
			else
				field->fld_position = /*X.RDB$FIELD_POSITION*/
						      isc_768.isc_792;
			field->fld_view_context = /*X.RDB$VIEW_CONTEXT*/
						  isc_768.isc_790;
			if (/*X.RDB$UPDATE_FLAG.NULL*/
			    isc_768.isc_788)
				field->fld_flags |= FLD_update_missing;
			else
				field->fld_update_flag = /*X.RDB$UPDATE_FLAG*/
							 isc_768.isc_789;

			COPY (/*X.RDB$FIELD_NAME*/
			      isc_768.isc_800, field->fld_name);
			COPY (/*X.RDB$FIELD_SOURCE*/
			      isc_768.isc_801, field->fld_source);
			COPY (/*X.RDB$BASE_FIELD*/
			      isc_768.isc_802, field->fld_base);
			COPY (/*X.RDB$QUERY_NAME*/
			      isc_768.isc_803, field->fld_query_name);
			COPY (/*X.RDB$EDIT_STRING*/
			      isc_768.isc_772, field->fld_edit_string);
			COPY (/*X.RDB$COMPLEX_NAME*/
			      isc_768.isc_804, field->fld_complex_name);

			blob_id = &/*Y.RDB$COMPUTED_BLR*/
				   isc_768.isc_771;

			if (blob_id->gds_quad_low || blob_id->gds_quad_high) {
				field->fld_flags |= FLD_computed;
			}

			field->fld_system_flag = /*X.RDB$SYSTEM_FLAG*/
						 isc_768.isc_787;

			COPY (/*X.RDB$SECURITY_CLASS*/
			      isc_768.isc_805, field->fld_security_class);

			// use the fld_flags to mark the field as an array and
			// to differentiate it from other blobs

			if (/*Y.RDB$DIMENSIONS*/
			    isc_768.isc_786)
			{
				field->fld_flags |= FLD_array;
				field->fld_dimensions = /*Y.RDB$DIMENSIONS*/
							isc_768.isc_786;
				if (field->fld_dimensions < 0) {
					BURP_error_redirect (NULL, 52, SafeArg() << field->fld_name);
				}
				// msg 52 array dimension for field %s is invalid
				get_ranges (field);
			}

			if (!/*X.RDB$NULL_FLAG.NULL*/
			     isc_768.isc_784)
			{
				field->fld_null_flag = /*X.RDB$NULL_FLAG*/
						       isc_768.isc_785;
				field->fld_flags |= FLD_null_flag;
			}

			if (!/*X.RDB$DEFAULT_VALUE.NULL*/
			     isc_768.isc_783)
			{
				blob_id = &/*X.RDB$DEFAULT_VALUE*/
					   isc_768.isc_770;
				if (blob_id->gds_quad_low || blob_id->gds_quad_high) {
					field->fld_default_value = /*X.RDB$DEFAULT_VALUE*/
								   isc_768.isc_770;
				}
			}

			if (!/*X.RDB$DEFAULT_SOURCE.NULL*/
			     isc_768.isc_782)
			{
				blob_id = &/*X.RDB$DEFAULT_SOURCE*/
					   isc_768.isc_769;
				if (blob_id->gds_quad_low || blob_id->gds_quad_high) {
					field->fld_default_source = /*X.RDB$DEFAULT_SOURCE*/
								    isc_768.isc_769;
				}
			}

			if (!/*Y.RDB$CHARACTER_SET_ID.NULL*/
			     isc_768.isc_780)
			{
				field->fld_character_set_id = /*Y.RDB$CHARACTER_SET_ID*/
							      isc_768.isc_781;
				field->fld_flags |= FLD_charset_flag;
			}

			if (!/*X.RDB$COLLATION_ID.NULL*/
			     isc_768.isc_778)
			{
				field->fld_collation_id = /*X.RDB$COLLATION_ID*/
							  isc_768.isc_779;
				field->fld_flags |= FLD_collate_flag;
			}

			// ODS 12
			if (!/*X.RDB$GENERATOR_NAME.NULL*/
			     isc_768.isc_777)
			{
				COPY(/*X.RDB$GENERATOR_NAME*/
				     isc_768.isc_806, field->fld_generator);
				field->fld_identity_type = /*X.RDB$IDENTITY_TYPE*/
							   isc_768.isc_776;
			}

			field_list.add(field);
		}
		/*END_FOR*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE tdgbl->handles_get_fields_req_handle1)
			X IN RDB$RELATION_FIELDS CROSS
			Y IN RDB$FIELDS WITH
			X.RDB$FIELD_SOURCE = Y.RDB$FIELD_NAME AND
			X.RDB$RELATION_NAME EQ relation->rel_name*/
		{
		if (!tdgbl->handles_get_fields_req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle1, (short) sizeof(isc_726), (char*) isc_726);
		   }
		isc_vtov ((const char*) relation->rel_name, (char*) isc_727.isc_728, 125);
		if (tdgbl->handles_get_fields_req_handle1)
		   {
		   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_727, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle1, (short) 1, (short) 964, &isc_729, (short) 0);
		   if (!isc_729.isc_736 || isc_status [1]) break;
		{
			field = (burp_fld*) BURP_alloc_zero(sizeof(burp_fld));
			field->fld_number = count++;
			field->fld_type = /*Y.RDB$FIELD_TYPE*/
					  isc_729.isc_758;
			field->fld_sub_type = /*Y.RDB$FIELD_SUB_TYPE*/
					      isc_729.isc_757;
			field->fld_length = /*Y.RDB$FIELD_LENGTH*/
					    isc_729.isc_756;
			field->fld_scale = /*Y.RDB$FIELD_SCALE*/
					   isc_729.isc_755;
			field->fld_id = /*X.RDB$FIELD_ID*/
					isc_729.isc_754;

			if (!/*X.RDB$DESCRIPTION.NULL*/
			     isc_729.isc_753)
			{
				blob_id = &/*X.RDB$DESCRIPTION*/
					   isc_729.isc_735;
				if (blob_id->gds_quad_low || blob_id->gds_quad_high)
					field->fld_description = /*X.RDB$DESCRIPTION*/
								 isc_729.isc_735;
			}

			if (!/*X.RDB$QUERY_HEADER.NULL*/
			     isc_729.isc_752)
			{
				blob_id = &/*X.RDB$QUERY_HEADER*/
					   isc_729.isc_734;
				if (blob_id->gds_quad_low || blob_id->gds_quad_high)
					field->fld_query_header = /*X.RDB$QUERY_HEADER*/
								  isc_729.isc_734;
			}

			if (/*X.RDB$FIELD_POSITION.NULL*/
			    isc_729.isc_750)
				field->fld_flags |= FLD_position_missing;
			else
				field->fld_position = /*X.RDB$FIELD_POSITION*/
						      isc_729.isc_751;
			field->fld_view_context = /*X.RDB$VIEW_CONTEXT*/
						  isc_729.isc_749;
			if (/*X.RDB$UPDATE_FLAG.NULL*/
			    isc_729.isc_747)
				field->fld_flags |= FLD_update_missing;
			else
				field->fld_update_flag = /*X.RDB$UPDATE_FLAG*/
							 isc_729.isc_748;

			COPY (/*X.RDB$FIELD_NAME*/
			      isc_729.isc_759, field->fld_name);
			COPY (/*X.RDB$FIELD_SOURCE*/
			      isc_729.isc_760, field->fld_source);
			COPY (/*X.RDB$BASE_FIELD*/
			      isc_729.isc_761, field->fld_base);
			COPY (/*X.RDB$QUERY_NAME*/
			      isc_729.isc_762, field->fld_query_name);
			COPY (/*X.RDB$EDIT_STRING*/
			      isc_729.isc_733, field->fld_edit_string);
			COPY (/*X.RDB$COMPLEX_NAME*/
			      isc_729.isc_763, field->fld_complex_name);

			blob_id = &/*Y.RDB$COMPUTED_BLR*/
				   isc_729.isc_732;

			if (blob_id->gds_quad_low || blob_id->gds_quad_high) {
				field->fld_flags |= FLD_computed;
			}

			field->fld_system_flag = /*X.RDB$SYSTEM_FLAG*/
						 isc_729.isc_746;

			COPY (/*X.RDB$SECURITY_CLASS*/
			      isc_729.isc_764, field->fld_security_class);

			// use the fld_flags to mark the field as an array and
			// to differentiate it from other blobs

			if (/*Y.RDB$DIMENSIONS*/
			    isc_729.isc_745)
			{
				field->fld_flags |= FLD_array;
				field->fld_dimensions = /*Y.RDB$DIMENSIONS*/
							isc_729.isc_745;
				if (field->fld_dimensions < 0) {
					BURP_error_redirect (NULL, 52, SafeArg() << field->fld_name);
				}
				// msg 52 array dimension for field %s is invalid
				get_ranges (field);
			}

			if (!/*X.RDB$NULL_FLAG.NULL*/
			     isc_729.isc_743)
			{
				field->fld_null_flag = /*X.RDB$NULL_FLAG*/
						       isc_729.isc_744;
				field->fld_flags |= FLD_null_flag;
			}

			if (!/*X.RDB$DEFAULT_VALUE.NULL*/
			     isc_729.isc_742)
			{
				blob_id = &/*X.RDB$DEFAULT_VALUE*/
					   isc_729.isc_731;
				if (blob_id->gds_quad_low || blob_id->gds_quad_high) {
					field->fld_default_value = /*X.RDB$DEFAULT_VALUE*/
								   isc_729.isc_731;
				}
			}

			if (!/*X.RDB$DEFAULT_SOURCE.NULL*/
			     isc_729.isc_741)
			{
				blob_id = &/*X.RDB$DEFAULT_SOURCE*/
					   isc_729.isc_730;
				if (blob_id->gds_quad_low || blob_id->gds_quad_high) {
					field->fld_default_source = /*X.RDB$DEFAULT_SOURCE*/
								    isc_729.isc_730;
				}
			}

			if (!/*Y.RDB$CHARACTER_SET_ID.NULL*/
			     isc_729.isc_739)
			{
				field->fld_character_set_id = /*Y.RDB$CHARACTER_SET_ID*/
							      isc_729.isc_740;
				field->fld_flags |= FLD_charset_flag;
			}

			if (!/*X.RDB$COLLATION_ID.NULL*/
			     isc_729.isc_737)
			{
				field->fld_collation_id = /*X.RDB$COLLATION_ID*/
							  isc_729.isc_738;
				field->fld_flags |= FLD_collate_flag;
			}

			field_list.add(field);
		}
		/*END_FOR*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR*/
		   }
		}
	}

	burp_fld* fields = NULL;

	while (field_list.getCount())
	{
		field = field_list.pop();
		field->fld_next = fields;
		fields = field;
	}

	return fields;
}


SINT64 get_gen_id( const TEXT* name, SSHORT name_len)
{
/**************************************
 *
 *	g e t _ g e n _ i d
 *
 **************************************
 *
 * Functional description
 *	Read id for a generator;
 *
 **************************************/
	UCHAR blr_buffer[100];	// enough to fit blr

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	FB_API_HANDLE gen_id_reqh = 0;
	UCHAR* blr = blr_buffer;

	// If this is ODS 10 (IB version 6.0) or greater, build BLR to retrieve
	// the 64-bit value of the generator.  If not, build BLR to retrieve the
	// 32-bit value, which we will cast to the expected INT64 format.

	if (tdgbl->runtimeODS >= DB_VERSION_DDL10)
	{
		// build the blr with the right relation name and 64-bit results.
		add_byte(blr, blr_version5);
		add_byte(blr, blr_begin);
		add_byte(blr, blr_message);
		add_byte(blr, 0);
		add_word(blr, 1);
		add_byte(blr, blr_int64);
		add_byte(blr, 0);
		add_byte(blr, blr_send);
		add_byte(blr, 0);
		add_byte(blr, blr_assignment);
		add_byte(blr, blr_gen_id);
		add_byte(blr, name_len);
		while (name_len--)
		{
			const UCHAR c = *name++;
			add_byte(blr, c);
		}
		add_byte(blr, blr_literal);
		add_byte(blr, blr_long);
		add_byte(blr, 0);
		add_word(blr, 0);
		add_word(blr, 0);
		add_byte(blr, blr_parameter);
		add_byte(blr, 0);
		add_word(blr, 0);
		add_byte(blr, blr_end);
		add_byte(blr, blr_eoc);
	}
	else
	{
		// build the blr with the right relation name and 32-bit results
		add_byte(blr, blr_version4);
		add_byte(blr, blr_begin);
		add_byte(blr, blr_message);
		add_byte(blr, 0);
		add_word(blr, 1);
		add_byte(blr, blr_long);
		add_byte(blr, 0);
		add_byte(blr, blr_send);
		add_byte(blr, 0);
		add_byte(blr, blr_assignment);
		add_byte(blr, blr_gen_id);
		add_byte(blr, name_len);
		while (name_len--)
		{
			const UCHAR c = *name++;
			add_byte(blr, c);
		}
		add_byte(blr, blr_literal);
		add_byte(blr, blr_long);
		add_byte(blr, 0);
		add_word(blr, 0);
		add_word(blr, 0);
		add_byte(blr, blr_parameter);
		add_byte(blr, 0);
		add_word(blr, 0);
		add_byte(blr, blr_end);
		add_byte(blr, blr_eoc);
	}

	const SSHORT blr_length = blr - blr_buffer;

#ifdef DEBUG
	if (debug_on)
		fb_print_blr(blr_buffer, blr_length, NULL, NULL, 0);
#endif

	ISC_STATUS_ARRAY status_vector;
	if (isc_compile_request(status_vector, &DB, &gen_id_reqh, blr_length, (const char*) blr_buffer))
	{
		// if there's no gen_id, never mind ...
		return 0;
	}

	// use the same gds_trans generated by gpre
	if (isc_start_request(status_vector, &gen_id_reqh, &gds_trans, 0))
	{
		BURP_error_redirect(status_vector, 25);
		// msg 25 Failed in put_blr_gen_id
	}


	SINT64 read_msg1;
	if (tdgbl->runtimeODS >= DB_VERSION_DDL10)
	{
		if (isc_receive(status_vector, &gen_id_reqh, 0, sizeof(read_msg1), &read_msg1, 0))
		{
			BURP_error_redirect(status_vector, 25);
			// msg 25 Failed in put_blr_gen_id
		}
	}
	else
	{
		SLONG read_msg0;
		if (isc_receive(status_vector, &gen_id_reqh, 0, sizeof(read_msg0), &read_msg0, 0))
		{
			BURP_error_redirect(status_vector, 25);
			// msg 25 Failed in put_blr_gen_id
		}
		read_msg1 = (SINT64) read_msg0;
	}

	isc_release_request(status_vector, &gen_id_reqh);

	return read_msg1;
}


void get_ranges( burp_fld* field)
{
   struct isc_721_struct {
          ISC_LONG isc_722;	/* RDB$UPPER_BOUND */
          ISC_LONG isc_723;	/* RDB$LOWER_BOUND */
          short isc_724;	/* isc_utility */
          short isc_725;	/* RDB$DIMENSION */
   } isc_721;
   struct isc_719_struct {
          char  isc_720 [125];	/* RDB$FIELD_NAME */
   } isc_719;
/**************************************
 *
 *	g e t _ r a n g e s
 *
 **************************************
 *
 * Functional description
 *	Fill in the range low and high bounds by reading
 *      the ranges in rdb$field_dimensions.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	SLONG* rp = field->fld_ranges;
	USHORT count = 0;

	// Get the array dimensions in the rdb$field_dimensions

	/*FOR (REQUEST_HANDLE tdgbl->handles_get_ranges_req_handle1)
		X IN RDB$FIELD_DIMENSIONS
		WITH X.RDB$FIELD_NAME EQ field->fld_source
		SORTED BY X.RDB$DIMENSION*/
	{
	if (!tdgbl->handles_get_ranges_req_handle1)
	   {
	   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_get_ranges_req_handle1, (short) sizeof(isc_718), (char*) isc_718);
	   }
	isc_vtov ((const char*) field->fld_source, (char*) isc_719.isc_720, 125);
	if (tdgbl->handles_get_ranges_req_handle1)
	   {
	   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_get_ranges_req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_719, (short) 0);
	   }
	if (!isc_status [1]) {
	while (1)
	   {
	   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_get_ranges_req_handle1, (short) 1, (short) 12, &isc_721, (short) 0);
	   if (!isc_721.isc_724 || isc_status [1]) break;

		if (count != /*X.RDB$DIMENSION*/
			     isc_721.isc_725)
			BURP_error_redirect (NULL, 52, SafeArg() << field->fld_name);
			// msg 52 array dimension for field %s is invalid
		*rp++ = /*X.RDB$LOWER_BOUND*/
			isc_721.isc_723;
		*rp++ = /*X.RDB$UPPER_BOUND*/
			isc_721.isc_722;
		count++;

	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	if (count != field->fld_dimensions)
		BURP_error_redirect(NULL, 52, SafeArg() << field->fld_name);
		// msg 52 array dimension for field %s is invalid
}


void put_array( burp_fld* field, burp_rel* relation, ISC_QUAD* blob_id)
{
/**************************************
 *
 *	p u t _ a r r a y
 *
 **************************************
 *
 * Functional description
 *	Write out an array.  If, however, it's null, don't even bother.
 *
 **************************************/
	SLONG range_buffer[16];	// enough for 16 dimensions
	UCHAR blr_buffer[200];		// enough for a sdl with 16 dimensions

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// If the array is null, don't store it.  It will be restored as null.

	if (!blob_id->gds_quad_low && !blob_id->gds_quad_high)
		return;

	lstring xdr_buffer;
	xdr_buffer.lstr_allocated = 0;
	xdr_buffer.lstr_address = NULL;

	UCHAR* blr = blr_buffer;
	const SLONG* const end_ranges = field->fld_ranges + 2 * field->fld_dimensions;

	USHORT field_length = field->fld_length;
	if (tdgbl->gbl_sw_transportable)
		xdr_buffer.lstr_length = field_length + 3;

	// build the sdl

	add_byte(blr, isc_sdl_version1);

	add_byte(blr, isc_sdl_struct);
	add_byte(blr, 1);

	add_byte(blr, field->fld_type);

	switch (field->fld_type)
	{
	case blr_short:
	case blr_long:
	case blr_quad:
	case blr_int64:
		add_byte(blr, field->fld_scale);
		break;
	case blr_text:
	case blr_varying:
		add_word(blr, field->fld_length);
		break;
	}

	if (field->fld_type == blr_varying)
		field_length += sizeof(USHORT);

	add_byte(blr, isc_sdl_rid);
	add_word(blr, relation->rel_id);
	add_byte(blr, isc_sdl_fid);
	add_word(blr, field->fld_id);

	USHORT count = 0;
	for (const SLONG* range = field->fld_ranges; range < end_ranges; range += 2, count++)
	{
		add_byte(blr, isc_sdl_do2);
		add_byte(blr, count);
		add_byte(blr, isc_sdl_long_integer);
		add_long(blr, range[0]);
		add_byte(blr, isc_sdl_long_integer);
		add_long(blr, range[1]);
	}

	add_byte(blr, isc_sdl_element);
	add_byte(blr, 1);
	add_byte(blr, isc_sdl_scalar);
	add_byte(blr, 0);
	add_byte(blr, field->fld_dimensions);

	for (count = 0; count < field->fld_dimensions; count++)
	{
		add_byte(blr, isc_sdl_variable);
		add_byte(blr, count);
	}

	add_byte(blr, isc_sdl_eoc);

#ifdef DEBUG
	if (debug_on)
		PRETTY_print_sdl(blr_buffer, NULL, NULL, 0);
#endif

	const USHORT blr_length = blr - blr_buffer;

	// compute the range size for each dimension = high_range - low_range

	ULONG slice_length = field_length;
	for (const SLONG* range = field->fld_ranges; range < end_ranges; range += 2)
	{
		slice_length *= (range[1] - range[0] + 1);
		if (tdgbl->gbl_sw_transportable)
			xdr_buffer.lstr_length *= (range[1] - range[0] + 1);
	}
	UCHAR* slice = BURP_alloc(slice_length);

	// allocate space for the XDR representation

	if (tdgbl->gbl_sw_transportable)
	{
		xdr_buffer.lstr_address = BURP_alloc(xdr_buffer.lstr_length);
		xdr_buffer.lstr_allocated = xdr_buffer.lstr_length;
	}

	ISC_STATUS_ARRAY status_vector;
	ULONG return_length = 0;
	if (isc_get_slice(status_vector, &DB, &gds_trans, blob_id, blr_length, (const char*) blr_buffer,
					  0,	// param length for subset of an array handling
					  NULL,	// param for subset of an array handling
					  slice_length, slice, (SLONG*) &return_length))
	{
		BURP_print(false, 81, field->fld_name);
		// msg 81 error accessing blob field %s -- continuing
		BURP_print_status(false, status_vector);
#ifdef DEBUG
		PRETTY_print_sdl(blr_buffer, NULL, NULL, 0);
#endif
		// CVC: At this point I would expected calls to deallocate memory
		// See the end of this function.
		BURP_free(slice);
		if (xdr_buffer.lstr_allocated)
			BURP_free(xdr_buffer.lstr_address);
		return;
	}

	if (return_length != slice_length)
	{
		// Ugh.  The full array wasn't returned.  We must recompute the top
		// element to backup.

		SLONG returned_elements = (return_length / field_length) - 1;

		SLONG* returned_range = range_buffer;
		const SLONG* range = end_ranges - 2;
		for (int i1 = 0, i3 = 0;
			 range >= field->fld_ranges; range -= 2, returned_range++, i1++)
		{
			int divisor = 1;
			for (int i2 = (2 * (i1 + 1) + 1); i2 <= field->fld_dimensions * 2; i2 += 2)
			{
				divisor *= (field->fld_ranges[i2] - field->fld_ranges[i2 - 1] + 1);
			}
			*returned_range = (returned_elements - 1) / divisor + field->fld_ranges[i3];
			returned_elements -= (*returned_range - field->fld_ranges[i3]) * divisor;
			i3 += 2;
		}
	}

	put(tdgbl, (UCHAR) rec_array);
	put_int32(att_blob_field_number, field->fld_number);
	put_int32(att_array_dimensions, field->fld_dimensions);

	SLONG* returned_range = range_buffer;
	for (const SLONG* range = field->fld_ranges; range < end_ranges; range += 2, returned_range++)
	{
		put_int32(att_array_range_low, (int) range[0]);
		if (return_length == slice_length)
			put_int32(att_array_range_high, (int) range[1]);
		else
			put_int32(att_array_range_high, (int) *returned_range);
	}

	put(tdgbl, att_blob_data);
	put(tdgbl, (UCHAR) (return_length));
	put(tdgbl, (UCHAR) (return_length >> 8));
	put(tdgbl, (UCHAR) (return_length >> 16));
	put(tdgbl, (UCHAR) (return_length >> 24));

	if (return_length)
	{
		const UCHAR* p;
		if (tdgbl->gbl_sw_transportable)
		{
			lstring xdr_slice;
			xdr_slice.lstr_allocated = xdr_slice.lstr_length = return_length;
			xdr_slice.lstr_address = slice;
			return_length = CAN_slice(&xdr_buffer, &xdr_slice, TRUE, /*blr_length,*/ blr_buffer);
			put(tdgbl, att_xdr_array);
			put(tdgbl, (UCHAR) (return_length));
			put(tdgbl, (UCHAR) (return_length >> 8));
			put(tdgbl, (UCHAR) (return_length >> 16));
			put(tdgbl, (UCHAR) (return_length >> 24));
			p = xdr_buffer.lstr_address;
		}
		else
			p = slice;
		put_block(tdgbl, p, return_length);
	}

	BURP_free(slice);
	if (xdr_buffer.lstr_allocated)
		BURP_free(xdr_buffer.lstr_address);
}


void put_asciz( const att_type attribute, const TEXT* string)
{
/**************************************
 *
 *	p u t _ a s c i z
 *
 **************************************
 *
 * Functional description
 *	Write an attribute starting with a null terminated string.
 *	Currently it's only called by write_database with the db's name as param.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	ULONG len = static_cast<ULONG>(strlen(string));
	// CVC: We'll have to ensure that length < MAX_FILE_NAME_SIZE.
	// For now, we'll truncate.
	// We can't honor operating systems that allow longer file names.
	if (len >= MAX_FILE_NAME_SIZE)
	{
		BURP_print(true, 343, SafeArg() << int(attribute) << "put_asciz()" << (MAX_FILE_NAME_SIZE - 1));
		// msg 343: text for attribute @1 is too large in @2, truncating to @3 bytes
		len = MAX_FILE_NAME_SIZE - 1;
	}

	put(tdgbl, attribute);
	put(tdgbl, (UCHAR) len);
	if (len)
		put_block(tdgbl, (const UCHAR*) string, len);
}


void put_blob( burp_fld* field, ISC_QUAD& blob_id)
{
/**************************************
 *
 *	p u t _ b l o b
 *
 **************************************
 *
 * Functional description
 *	Write out a blob.  If, however, it's null, don't even bother.
 *	This is for user data blobs.
 *
 **************************************/
	ISC_STATUS_ARRAY status_vector;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// If the blob is null, don't store it.  It will be restored as null.

	if (UserBlob::blobIsNull(blob_id))
		return;

	// Open the blob and get it's vital statistics

	UserBlob blob(status_vector);

	if (!blob.open(DB, gds_trans, blob_id))
	{
		BURP_print(false, 81, field->fld_name);
		// msg 81 error accessing blob field %s -- continuing
		BURP_print_status(false, status_vector);
		return;
	}

	UCHAR blob_info[32];
	if (!blob.getInfo(sizeof(blob_items), blob_items, sizeof(blob_info), blob_info))
	{
		BURP_error_redirect(status_vector, 20);
		// msg 20 isc_blob_info failed
	}

	put(tdgbl, (UCHAR) rec_blob);
	put_int32(att_blob_field_number, field->fld_number);

	ULONG segments = 0, total_length = 0;
	USHORT max_segment = 0;
	int blob_type = 0; // 0 - segmented, 1 - stream
	const UCHAR* p = blob_info;

	UCHAR item;
	while ((item = *p++) != isc_info_end)
	{
		const USHORT l = gds__vax_integer(p, 2);
		p += 2;
		const ULONG n = gds__vax_integer(p, l);
		p += l;
		switch (item)
		{
		case isc_info_blob_max_segment:
			max_segment = n;
			break;

		case isc_info_blob_type:
			blob_type = n;
			break;

		case isc_info_blob_num_segments:
			segments = n;
			break;

		case isc_info_blob_total_length:
			total_length = n;
			break;

		default:
			BURP_error_redirect(NULL, 21, SafeArg() << int(item));
			// msg 21 don't understand blob info item %ld
		}
	}

	// NS: Compute number of chunks we are going to write for stream blob based
	// on total blob length and maximum segment size. This way we tend to
	// preserve maximum internal segment size over backup/restore. I'm not sure
	// this is beneficial, but let's do it for the moment instead of inventing
	// our own chunk size. Note, the number of segments returned by information
	// call for stream blob is always unreliable, even for zero-length blobs
	if (blob_type == 1)
	{
		if (total_length != 0)
			segments = (total_length + max_segment - 1) / max_segment;
		else
			segments = 0;
	}

	put_int32(att_blob_max_segment, max_segment);
	put_int32(att_blob_number_segments, segments);
	put_int32(att_blob_type, blob_type);

	// Allocate a buffer large enough for the largest segment and start grinding.
	UCHAR static_buffer[1024];
	UCHAR* buffer;
	if (!max_segment || max_segment <= sizeof(static_buffer))
		buffer = static_buffer;
	else
		buffer = BURP_alloc(max_segment);

	put(tdgbl, att_blob_data);

	while (segments > 0)
	{
		FB_SIZE_T segment_length;
		blob.getSegment(max_segment, buffer, segment_length);

		const ISC_STATUS status = blob.getCode();
		// Handle the errors. For stream blob isc_segment is not error here.
		if (status && (status != isc_segment || blob_type == 0))
		{
			BURP_error_redirect(status_vector, 22);
			// msg 22 isc_get_segment failed
		}

		put(tdgbl, (UCHAR) (segment_length));
		put(tdgbl, (UCHAR) (segment_length >> 8));
		if (segment_length)
		{
			put_block(tdgbl, buffer, segment_length);
		}
		--segments;
	}

	if (!blob.close())
		BURP_error_redirect(status_vector, 23);
		// msg 23 isc_close_blob failed

	if (buffer != static_buffer)
		BURP_free(buffer);
}


bool put_blr_blob( att_type attribute, ISC_QUAD& blob_id)
{
/**************************************
 *
 *	p u t _ b l r _ b l o b
 *
 **************************************
 *
 * Functional description
 *	Write out a blr blob, if present.  Otherwise do nothing.
 *	Return true if the blob was present, false otherwise.
 *
 **************************************/
	ISC_STATUS_ARRAY status_vector;
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// If the blob is null, don't store it.  It will be restored as null.

	if (UserBlob::blobIsNull(blob_id))
		return false;

	// Open the blob and get it's vital statistics

	UserBlob blob(status_vector);

	if (!blob.open(DB, gds_trans, blob_id))
	{
		BURP_error_redirect(status_vector, 24);
		// msg 24 isc_open_blob failed
	}

	UCHAR blob_info[32];
	if (!blob.getInfo(sizeof(blr_items), blr_items, sizeof(blob_info), blob_info))
	{
		BURP_error_redirect(status_vector, 20);
		// msg 20 isc_blob_info failed
	}

	ULONG length = 0;
	USHORT max_segment = 0;
	const UCHAR* p = blob_info;
	UCHAR item;

	while ((item = *p++) != isc_info_end)
	{
		const USHORT l = isc_vax_integer((const char*) p, 2);
		p += 2;
		const ULONG n = isc_vax_integer((const char*) p, l);
		p += l;
		switch (item)
		{
		case isc_info_blob_max_segment:
			max_segment = n;
			break;

		case isc_info_blob_total_length:
			length = n;
			break;

		default:
			BURP_print(true, 79, SafeArg() << int(item));
			// msg 79 don't understand blob info item %ld
			if (!blob.close())
				BURP_error_redirect(status_vector, 23);
				// msg 23 isc_close_blob failed
			return false;
		}
	}

	if (!length)
	{
		if (!blob.close())
			BURP_error_redirect(status_vector, 23);
			// msg 23 isc_close_blob failed
		return false;
	}

	// Rdb sometimes gets the length messed up

	if (length < max_segment)
		length = max_segment;

	put_int32(attribute, (int) length);

	// Allocate a buffer large enough for the largest segment and start grinding.

	UCHAR static_buffer[1024];
	UCHAR* buffer;
	if (!max_segment || max_segment <= sizeof(static_buffer))
		buffer = static_buffer;
	else
		buffer = BURP_alloc(max_segment);

	// The old code didn't accept isc_segment so we check it.
	FB_SIZE_T segment_length;
	while (blob.getSegment(max_segment, buffer, segment_length) && !blob.getCode())
	{
		if (segment_length)
		{
			put_block(tdgbl, buffer, segment_length);
		}
	}

	if (!blob.close())
	{
		BURP_error_redirect(status_vector, 23);
		// msg 23 isc_close_blob failed
	}

	if (buffer != static_buffer)
		BURP_free(buffer);

	return true;
}


void put_data(burp_rel* relation)
{
/**************************************
 *
 *	p u t _ d a t a
 *
 **************************************
 *
 * Functional description
 *	Write relation meta-data and data.
 *
 **************************************/
	burp_fld* field;
	ISC_STATUS_ARRAY status_vector;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// CVC: A signed short isn't enough if the engine allows near 32K fields,
	// each being char(1) ASCII in the worst case. Looking at BLR generation
	// below, it's clear an extreme case won't compile => blr_length >= 32K.
	// However, SSHORT is the limit for request_length in isc_compile_request.
	SSHORT field_count = 1;

	for (field = relation->rel_fields; field; field = field->fld_next)
	{
		if (!(field->fld_flags & FLD_computed))
		{
			field_count += 2;
		}
	}
	fb_assert(field_count > 0 && field_count * 9 > 0 && field_count * 9 + 200 > 0);

	// Time to generate blr to fetch data.  Make sure we allocate a BLR buffer
	// large enough to handle the per field overhead
	UCHAR* const blr_buffer = BURP_alloc(200 + field_count * 9);
	UCHAR* blr = blr_buffer;
	add_byte(blr, blr_version4);
	add_byte(blr, blr_begin);
	add_byte(blr, blr_message);
	add_byte(blr, 0);				// Message number
	add_word(blr, field_count);		// Number of fields, counting eof

	RCRD_OFFSET offset = 0;
	SSHORT count = 0;   // This is param count.

	for (field = relation->rel_fields; field; field = field->fld_next)
	{
		if (field->fld_flags & FLD_computed)
			continue;
		SSHORT alignment = 4;
		FLD_LENGTH length = field->fld_length;
		SSHORT dtype = field->fld_type;
		if (field->fld_flags & FLD_array)
		{
			dtype = blr_blob;
			length = 8;
		}
		switch (dtype)
		{
		case blr_text:
			alignment = type_alignments[dtype_text];
			add_byte(blr, field->fld_type);
			add_word(blr, field->fld_length);
			break;

		case blr_varying:
			alignment = type_alignments[dtype_varying];
			add_byte(blr, field->fld_type);
			add_word(blr, field->fld_length);
			length += sizeof(USHORT);
			break;

		case blr_short:
			alignment = type_alignments[dtype_short];
			add_byte(blr, field->fld_type);
			add_byte(blr, field->fld_scale);
			break;

		case blr_long:
			alignment = type_alignments[dtype_long];
			add_byte(blr, field->fld_type);
			add_byte(blr, field->fld_scale);
			break;

		case blr_quad:
			alignment = type_alignments[dtype_quad];
			add_byte(blr, field->fld_type);
			add_byte(blr, field->fld_scale);
			break;

		case blr_int64:
			alignment = type_alignments[dtype_int64];
			add_byte(blr, field->fld_type);
			add_byte(blr, field->fld_scale);
			break;

		case blr_double:
			alignment = type_alignments[dtype_double];
			add_byte(blr, field->fld_type);
			break;

		case blr_timestamp:
			alignment = type_alignments[dtype_timestamp];
			add_byte(blr, field->fld_type);
			break;

		case blr_sql_time:
			alignment = type_alignments[dtype_sql_time];
			add_byte(blr, field->fld_type);
			break;

		case blr_sql_date:
			alignment = type_alignments[dtype_sql_date];
			add_byte(blr, field->fld_type);
			break;

		case blr_float:
			alignment = type_alignments[dtype_real];
			add_byte(blr, field->fld_type);
			break;

		case blr_blob:
			alignment = type_alignments[dtype_blob];
			add_byte(blr, blr_quad);
			add_byte(blr, 0);
			break;

		case blr_bool:
			alignment = type_alignments[dtype_boolean];
			add_byte(blr, field->fld_type);
			break;

		default:
			BURP_error_redirect(NULL, 26, SafeArg() << field->fld_type);
			// msg 26 datatype %ld not understood
			break;
		}
		if (alignment)
			offset = FB_ALIGN(offset, alignment);
		field->fld_offset = offset;
		field->fld_parameter = count++;
		offset += length;
	}

	// Next, build fields for null flags

	for (field = relation->rel_fields; field; field = field->fld_next)
	{
		if (field->fld_flags & FLD_computed)
			continue;
		add_byte(blr, blr_short);
		add_byte(blr, 0);
		offset = FB_ALIGN(offset, sizeof(SSHORT));
		field->fld_missing_parameter = count++;
		offset += sizeof(SSHORT);
	}

	// Finally, make up an EOF field

	add_byte(blr, blr_short);			// eof field
	add_byte(blr, 0);					// scale for eof field
	SSHORT eof_parameter = count++;
	RCRD_OFFSET record_length = offset;
	RCRD_OFFSET eof_offset = FB_ALIGN(offset, sizeof(SSHORT));
	// To be used later for the buffer size to receive data
	const FLD_LENGTH length = (USHORT) (eof_offset + sizeof(SSHORT));

	// Build FOR loop, body, and eof handler

	add_byte(blr, blr_for);
	add_byte(blr, blr_rse);
	add_byte(blr, 1);					// count of relations
	add_byte(blr, blr_rid);
	add_word(blr, relation->rel_id);
	add_byte(blr, 0);					// context variable
	add_byte(blr, blr_end);

	add_byte(blr, blr_send);
	add_byte(blr, 0);
	add_byte(blr, blr_begin);
	add_byte(blr, blr_assignment);
	add_byte(blr, blr_literal);
	add_byte(blr, blr_short);
	add_byte(blr, 0);
	add_word(blr, 1);
	add_byte(blr, blr_parameter);
	add_byte(blr, 0);
	add_word(blr, eof_parameter);

	for (field = relation->rel_fields; field; field = field->fld_next)
	{
		if (field->fld_flags & FLD_computed)
			continue;
		add_byte(blr, blr_assignment);
		add_byte(blr, blr_fid);
		add_byte(blr, 0);
		add_word(blr, field->fld_id);
		add_byte(blr, blr_parameter2);
		add_byte(blr, 0);
		add_word(blr, field->fld_parameter);
		add_word(blr, field->fld_missing_parameter);
	}

	add_byte(blr, blr_end);

	add_byte(blr, blr_send);
	add_byte(blr, 0);
	add_byte(blr, blr_assignment);
	add_byte(blr, blr_literal);
	add_byte(blr, blr_short);
	add_byte(blr, 0);
	add_word(blr, 0);
	add_byte(blr, blr_parameter);
	add_byte(blr, 0);
	add_word(blr, eof_parameter);

	add_byte(blr, blr_end);
	add_byte(blr, blr_eoc);

	SSHORT blr_length = blr - blr_buffer;

#ifdef DEBUG
	if (debug_on)
		fb_print_blr(blr_buffer, blr_length, NULL, NULL, 0);
#endif

	// Compile request

	FB_API_HANDLE request = 0;
	if (isc_compile_request(status_vector, &DB, &request, blr_length, (const SCHAR*) blr_buffer))
	{
		BURP_error_redirect(status_vector, 27);
		// msg 27 isc_compile_request failed
		fb_print_blr(blr_buffer, blr_length, NULL, NULL, 0);
	}

	BURP_free(blr_buffer);

	BURP_verbose(142, relation->rel_name);
	// msg 142  writing data for relation %s

	if (isc_start_request(status_vector, &request, &gds_trans, 0))
	{
		BURP_error_redirect(status_vector, 28);
		// msg 28 isc_start_request failed
	}

	// Here is the crux of the problem -- writing data.  All this work
	// for the following small loop.

	UCHAR* buffer = BURP_alloc(length);
	SSHORT* eof = (SSHORT *) (buffer + eof_offset);

	// the XDR representation may be even fluffier
	lstring xdr_buffer;
	if (tdgbl->gbl_sw_transportable)
	{
		xdr_buffer.lstr_length = xdr_buffer.lstr_allocated = length + count * 3;
		xdr_buffer.lstr_address = BURP_alloc(xdr_buffer.lstr_length);
	}
	else
		xdr_buffer.lstr_address = NULL;

	FB_UINT64 records = 0;
	while (true)
	{
		if (isc_receive(status_vector, &request, 0, length, buffer, 0))
		{
			BURP_error_redirect(status_vector, 29);
			// msg 29 isc_receive failed
		}
		if (!*eof)
			break;
		records++;
		// Verbose records
		if ((records % tdgbl->verboseInterval) == 0)
			BURP_verbose(108, SafeArg() << records);

		put(tdgbl, (UCHAR) rec_data);
		put_int32(att_data_length, record_length);
		const UCHAR* p;
		if (tdgbl->gbl_sw_transportable)
		{
			record_length = CAN_encode_decode(relation, &xdr_buffer, buffer, TRUE);
			put_int32(att_xdr_length, record_length);
			p = xdr_buffer.lstr_address;
		}
		else
			p = buffer;
		put(tdgbl, att_data_data);
		if (tdgbl->gbl_sw_compress)
			compress(p, record_length);
		else if (record_length)
			put_block(tdgbl, p, record_length);

		// Look for any blobs to write

		for (field = relation->rel_fields; field; field = field->fld_next)
		{
			if (field->fld_type == blr_blob &&
				!(field->fld_flags & FLD_computed) && !(field->fld_flags & FLD_array))
			{
				put_blob(field, *(ISC_QUAD*) (buffer + field->fld_offset));
			}
		}

		// Look for any array to write
		// we got back the blob_id for the array from isc_receive in the second param.
		for (field = relation->rel_fields; field; field = field->fld_next)
		{
			if (field->fld_flags & FLD_array)
			{
				put_array(field, relation, (ISC_QUAD*) (buffer + field->fld_offset));
			}
		}
	}

	BURP_free(buffer);

	if (xdr_buffer.lstr_address)
		BURP_free(xdr_buffer.lstr_address);

	BURP_verbose(108, SafeArg() << records);
	// msg 108 %ld records written

	if (isc_release_request(status_vector, &request))
		BURP_error_redirect(status_vector, 30);
	// msg 30 isc_release_request failed
}


void put_index( burp_rel* relation)
{
   struct isc_692_struct {
          short isc_693;	/* isc_utility */
          char  isc_694 [125];	/* RDB$FIELD_NAME */
   } isc_692;
   struct isc_690_struct {
          char  isc_691 [125];	/* RDB$INDEX_NAME */
   } isc_690;
   struct isc_699_struct {
          short isc_700;	/* isc_utility */
   } isc_699;
   struct isc_696_struct {
          char  isc_697 [125];	/* RDB$INDEX_NAME */
          char  isc_698 [125];	/* RDB$RELATION_NAME */
   } isc_696;
   struct isc_704_struct {
          ISC_QUAD isc_705;	/* RDB$EXPRESSION_BLR */
          ISC_QUAD isc_706;	/* RDB$EXPRESSION_SOURCE */
          ISC_QUAD isc_707;	/* RDB$DESCRIPTION */
          short isc_708;	/* isc_utility */
          short isc_709;	/* gds__null_flag */
          short isc_710;	/* gds__null_flag */
          short isc_711;	/* gds__null_flag */
          short isc_712;	/* RDB$INDEX_TYPE */
          short isc_713;	/* RDB$UNIQUE_FLAG */
          short isc_714;	/* RDB$INDEX_INACTIVE */
          short isc_715;	/* RDB$SEGMENT_COUNT */
          char  isc_716 [125];	/* RDB$INDEX_NAME */
          char  isc_717 [125];	/* RDB$FOREIGN_KEY */
   } isc_704;
   struct isc_702_struct {
          char  isc_703 [125];	/* RDB$RELATION_NAME */
   } isc_702;
/**************************************
 *
 *	p u t _ i n d e x
 *
 **************************************
 *
 * Functional description
 *	Write information about an index.  First
 *	check that all the segments of the
 *	index exist.
 *
 **************************************/
	ULONG count;
	TEXT temp[GDS_NAME_LEN];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// if we have all capabilities, use the first request to get the
	// most performance out of the latest engine; if we don't
	// have one of the capabilities we must use the second set of
	// requests--this requires more code but it is well worth it
	// for the performance benefits, especially remotely--deej

	/*FOR (REQUEST_HANDLE tdgbl->handles_put_index_req_handle1)
		X IN RDB$INDICES WITH
		X.RDB$RELATION_NAME EQ relation->rel_name*/
	{
	if (!tdgbl->handles_put_index_req_handle1)
	   {
	   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle1, (short) sizeof(isc_701), (char*) isc_701);
	   }
	isc_vtov ((const char*) relation->rel_name, (char*) isc_702.isc_703, 125);
	if (tdgbl->handles_put_index_req_handle1)
	   {
	   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_702, (short) 0);
	   }
	if (!isc_status [1]) {
	while (1)
	   {
	   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle1, (short) 1, (short) 290, &isc_704, (short) 0);
	   if (!isc_704.isc_708 || isc_status [1]) break;

		count = 0;
		/*FOR (REQUEST_HANDLE tdgbl->handles_put_index_req_handle2)
			I_S IN RDB$INDEX_SEGMENTS CROSS
			RFR IN RDB$RELATION_FIELDS WITH
			I_S.RDB$FIELD_NAME = RFR.RDB$FIELD_NAME AND
			I_S.RDB$INDEX_NAME = X.RDB$INDEX_NAME AND
			RFR.RDB$RELATION_NAME = relation->rel_name*/
		{
		if (!tdgbl->handles_put_index_req_handle2)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle2, (short) sizeof(isc_695), (char*) isc_695);
		   }
		isc_vtov ((const char*) isc_704.isc_716, (char*) isc_696.isc_697, 125);
		isc_vtov ((const char*) relation->rel_name, (char*) isc_696.isc_698, 125);
		if (tdgbl->handles_put_index_req_handle2)
		   {
		   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle2, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 250, &isc_696, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle2, (short) 1, (short) 2, &isc_699, (short) 0);
		   if (!isc_699.isc_700 || isc_status [1]) break;

			count++;

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}

		if (count != (ULONG) /*X.RDB$SEGMENT_COUNT*/
				     isc_704.isc_715)
		{
			BURP_print(true, 180, SafeArg() << /*X.RDB$INDEX_NAME*/
							   isc_704.isc_716 << count << /*X.RDB$SEGMENT_COUNT*/
	     isc_704.isc_715);
			continue;
		}

		put(tdgbl, rec_index);
		const ULONG l = PUT_TEXT (att_index_name, /*X.RDB$INDEX_NAME*/
							  isc_704.isc_716);
		MISC_terminate (/*X.RDB$INDEX_NAME*/
				isc_704.isc_716, temp, l, sizeof(temp));
		BURP_verbose (151, temp);
		// msg 151 writing index %s
		put_int32 (att_segment_count, /*X.RDB$SEGMENT_COUNT*/
					      isc_704.isc_715);
		put_int32 (att_index_inactive, /*X.RDB$INDEX_INACTIVE*/
					       isc_704.isc_714);
		put_int32 (att_index_unique_flag, /*X.RDB$UNIQUE_FLAG*/
						  isc_704.isc_713);

		/*FOR (REQUEST_HANDLE tdgbl->handles_put_index_req_handle5)
			Y IN RDB$INDEX_SEGMENTS WITH
			Y.RDB$INDEX_NAME EQ X.RDB$INDEX_NAME
			SORTED BY Y.RDB$FIELD_POSITION*/
		{
		if (!tdgbl->handles_put_index_req_handle5)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle5, (short) sizeof(isc_689), (char*) isc_689);
		   }
		isc_vtov ((const char*) isc_704.isc_716, (char*) isc_690.isc_691, 125);
		if (tdgbl->handles_put_index_req_handle5)
		   {
		   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle5, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_690, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle5, (short) 1, (short) 127, &isc_692, (short) 0);
		   if (!isc_692.isc_693 || isc_status [1]) break;

			PUT_TEXT (att_index_field_name, /*Y.RDB$FIELD_NAME*/
							isc_692.isc_694);

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}

		put_source_blob (att_index_description2, att_index_description, /*X.RDB$DESCRIPTION*/
										isc_704.isc_707);
		put_int32 (att_index_type, /*X.RDB$INDEX_TYPE*/
					   isc_704.isc_712);

		if (!/*X.RDB$EXPRESSION_SOURCE.NULL*/
		     isc_704.isc_711)
			put_source_blob (att_index_expression_source, att_index_expression_source,
							 /*X.RDB$EXPRESSION_SOURCE*/
							 isc_704.isc_706);
		if (!/*X.RDB$EXPRESSION_BLR.NULL*/
		     isc_704.isc_710)
			put_blr_blob (att_index_expression_blr, /*X.RDB$EXPRESSION_BLR*/
								isc_704.isc_705);
		if (!/*X.RDB$FOREIGN_KEY.NULL*/
		     isc_704.isc_709)
			PUT_TEXT (att_index_foreign_key, /*X.RDB$FOREIGN_KEY*/
							 isc_704.isc_717);
		put(tdgbl, att_end);

	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}
}


int put_message( att_type attribute, att_type attribute2, const TEXT* text, const ULONG length)
{
/**************************************
 *
 *	p u t _ m e s s a g e
 *
 **************************************
 *
 * Functional description
 *	Write a variable length text string, with embedded
 *      blanks.  Same as put_text but handles embedded blanks.
 * CVC: As v6 time, put_text handles embedded blanks, too!
 * The only difference is that put_text's length is UCHAR, so
 * in theory put_message can handle much longer input and it's
 * used for exception and trigger's messages (plus update/delete
 * rules for FKs and constraint types, where it's irrelevant
 * which function of the two you use).
 * CVC: Responsability for FKs and constraint types transferred to put_text.
 * This function tries to maintain backwards compatibility where possible.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	ULONG len = 0;
	for (const TEXT* p = text; *p && len < length; p++)
		len++;

	const ULONG newlen = MIN(len, length);
	fb_assert(newlen <= MAX_USHORT);

	// If we can store the message using the old format, we do it.
	if (newlen <= MAX_UCHAR)
	{
		put(tdgbl, attribute);
		put(tdgbl, (UCHAR) newlen);
	}
	else if (newlen <= MAX_USHORT)
	{
		if (!attribute2) // In theory, this never happens, because the caller knows what it's doing.
			BURP_error(314, true);
		put(tdgbl, attribute2);
		USHORT vax_value = (USHORT) newlen;
		vax_value = (USHORT) gds__vax_integer((const UCHAR*) &vax_value, sizeof(vax_value));
		put_block(tdgbl, (const UCHAR*) &vax_value, sizeof(vax_value));
	}
	else
		BURP_error(315, true);

	if (newlen)
		put_block(tdgbl, reinterpret_cast<const UCHAR*>(text), newlen);

	return newlen;
}


void put_int32( att_type attribute, SLONG value)
{
/**************************************
 *
 *	p u t _ i n t 3 2
 *
 **************************************
 *
 * Functional description
 *	Write a numeric value as an attribute.  The number is represented
 *	low byte first, high byte last, as in VAX.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	const SLONG vax_value = (SLONG) isc_vax_integer((const char*) &value, sizeof(value));

	put(tdgbl, attribute);
	put(tdgbl, (UCHAR) sizeof(value));
	put_block(tdgbl, (const UCHAR*) &vax_value, sizeof(vax_value));
}


void put_int64( att_type attribute, SINT64 value)
{
/**************************************
 *
 *	p u t _ i n t 6 4
 *
 **************************************
 *
 * Functional description
 *	Write a 64-bit numeric value as an attribute.
 *      The number is represented low byte first, high byte last, as in VAX.
 *      This function is just like put_int32, except that it handles an
 *      INT64 value, while put_int32 handles a 32-bit value.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	const FB_UINT64 le_value = (FB_UINT64) isc_portable_integer((const UCHAR*) &value, sizeof(value));

	put(tdgbl, attribute);
	put(tdgbl, (UCHAR) sizeof(value));
	put_block(tdgbl, (const UCHAR*) &le_value, sizeof(le_value));
}


void put_relation( burp_rel* relation)
{
   struct isc_672_struct {
          short isc_673;	/* isc_utility */
          short isc_674;	/* RDB$VIEW_CONTEXT */
          char  isc_675 [125];	/* RDB$RELATION_NAME */
          char  isc_676 [1021];	/* RDB$CONTEXT_NAME */
   } isc_672;
   struct isc_670_struct {
          char  isc_671 [125];	/* RDB$VIEW_NAME */
   } isc_670;
   struct isc_680_struct {
          short isc_681;	/* isc_utility */
          short isc_682;	/* gds__null_flag */
          short isc_683;	/* gds__null_flag */
          short isc_684;	/* RDB$CONTEXT_TYPE */
          short isc_685;	/* RDB$VIEW_CONTEXT */
          char  isc_686 [125];	/* RDB$RELATION_NAME */
          char  isc_687 [1021];	/* RDB$CONTEXT_NAME */
          char  isc_688 [125];	/* RDB$PACKAGE_NAME */
   } isc_680;
   struct isc_678_struct {
          char  isc_679 [125];	/* RDB$VIEW_NAME */
   } isc_678;
/**************************************
 *
 * 	p u t _ r e l a t i o n
 *
 **************************************
 *
 * Functional description
 *	Write relation meta-data and data.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// Write local field information.  This is made slightly more complicated
	// by the requirement that computational fields be aligned.

	burp_fld* aligned = NULL;
	burp_fld* unaligned = NULL;
	burp_fld* aligned4 = NULL;
	burp_fld* aligned8 = NULL;

	burp_fld* fields = get_fields(relation);

	// sort the list of fields into three lists, depending on alignment
	burp_fld* field;
	for (field = fields; field = fields;)
	{
		fields = field->fld_next;
		USHORT l = field->fld_length;
		if (field->fld_type == blr_varying)
			l += sizeof(USHORT);
		if (!(l & 7))
		{
			field->fld_next = aligned8;
			aligned8 = field;
		}
		else if (!(l & 3))
		{
			field->fld_next = aligned4;
			aligned4 = field;
		}
		else if (l & 1)
		{
			field->fld_next = unaligned;
			unaligned = field;
		}
		else
		{
			field->fld_next = aligned;
			aligned = field;
		}
	}

	// Next, merge the aligned and unaligned sub-lists.  In the process,
	// re-create (approximately) the original order of the fields.  This is
	// not strictly required, but it certainly is polite.

	while (field = unaligned)
	{
		unaligned = field->fld_next;
		field->fld_next = relation->rel_fields;
		relation->rel_fields = field;
	}

	while (field = aligned)
	{
		aligned = field->fld_next;
		field->fld_next = relation->rel_fields;
		relation->rel_fields = field;
	}

	while (field = aligned4)
	{
		aligned4 = field->fld_next;
		field->fld_next = relation->rel_fields;
		relation->rel_fields = field;
	}

	while (field = aligned8)
	{
		aligned8 = field->fld_next;
		field->fld_next = relation->rel_fields;
		relation->rel_fields = field;
	}

	// Now write the fields in what will become physical backup order

	for (field = relation->rel_fields; field; field = field->fld_next)
	{
		put(tdgbl, (UCHAR) rec_field);
		const USHORT l = PUT_TEXT(att_field_name, field->fld_name);
		MISC_terminate(field->fld_name, temp, l, sizeof(temp));
		BURP_verbose(144, temp);
		// msg 144  writing field %s
		PUT_TEXT(att_field_source, field->fld_source);
		if (field->fld_query_name[0])
			PUT_TEXT(att_field_query_name, field->fld_query_name);
		if (field->fld_complex_name[0])
			PUT_TEXT(att_field_complex_name, field->fld_complex_name);
		if (field->fld_edit_string[0])
			PUT_TEXT(att_field_edit_string, field->fld_edit_string);
		put_source_blob(att_field_description2, att_field_description, field->fld_description);
		put_source_blob(att_field_query_header, att_field_query_header, field->fld_query_header);
		if (field->fld_security_class[0])
			PUT_TEXT(att_field_security_class, field->fld_security_class);
		if (!(field->fld_flags & FLD_position_missing))
			put_int32(att_field_position, field->fld_position);
		put_int32(att_field_type, field->fld_type);
		put_int32(att_field_length, field->fld_length);
		put_int32(att_field_sub_type, field->fld_sub_type);
		put_int32(att_field_scale, field->fld_scale);
		put_int32(att_field_number, field->fld_number);
		put_int32(att_field_system_flag, field->fld_system_flag);
		if (!(field->fld_flags & FLD_update_missing))
			put_int32(att_field_update_flag, field->fld_update_flag);
		if (field->fld_flags & FLD_null_flag)
			put_int32(att_field_null_flag, field->fld_null_flag);
		if (field->fld_flags & FLD_charset_flag)
			put_int32(att_field_character_set, field->fld_character_set_id);
		if (field->fld_flags & FLD_collate_flag)
			put_int32(att_field_collation_id, field->fld_collation_id);
		put_blr_blob(att_field_default_value, field->fld_default_value);
		put_source_blob(att_field_default_source, att_field_default_source, field->fld_default_source);

		if (relation->rel_flags & REL_view)
		{
			put_int32(att_view_context, field->fld_view_context);
			if (field->fld_base[0])
				PUT_TEXT(att_base_field, field->fld_base);
		}

		if (field->fld_flags & FLD_computed)
			put_int32(att_field_computed_flag, TRUE);

		if (field->fld_flags & FLD_array)
		{
			put_int32(att_field_dimensions, field->fld_dimensions);
			const SLONG* rp = field->fld_ranges;
			for (USHORT n = field->fld_dimensions; n; rp += 2, n--)
			{
				put_int32(att_field_range_low, *rp);
				put_int32(att_field_range_high, *(rp + 1));
			}
		}

		if (field->fld_generator[0])
		{
			PUT_TEXT(att_field_generator_name, field->fld_generator);
			put_int32(att_field_identity_type, field->fld_identity_type);
		}

		put(tdgbl, att_end);
	}

	// Write out view relations (if a view, of course)

	if (relation->rel_flags & REL_view)
	{
		if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
		{
			/*FOR (REQUEST_HANDLE tdgbl->handles_put_relation_req_handle1)
				X IN RDB$VIEW_RELATIONS WITH X.RDB$VIEW_NAME EQ relation->rel_name*/
			{
			if (!tdgbl->handles_put_relation_req_handle1)
			   {
			   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_put_relation_req_handle1, (short) sizeof(isc_677), (char*) isc_677);
			   }
			isc_vtov ((const char*) relation->rel_name, (char*) isc_678.isc_679, 125);
			if (tdgbl->handles_put_relation_req_handle1)
			   {
			   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_relation_req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_678, (short) 0);
			   }
			if (!isc_status [1]) {
			while (1)
			   {
			   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_relation_req_handle1, (short) 1, (short) 1281, &isc_680, (short) 0);
			   if (!isc_680.isc_681 || isc_status [1]) break;
				put(tdgbl, rec_view);
				PUT_TEXT (att_view_relation_name, /*X.RDB$RELATION_NAME*/
								  isc_680.isc_686);
				put_int32 (att_view_context_id, /*X.RDB$VIEW_CONTEXT*/
								isc_680.isc_685);
				// Will need PUT_MESSAGE if this field grows to more than 255 bytes.
				PUT_TEXT (att_view_context_name, /*X.RDB$CONTEXT_NAME*/
								 isc_680.isc_687);
				if (!/*X.RDB$CONTEXT_TYPE.NULL*/
				     isc_680.isc_683)
					put_int32(att_view_context_type, /*X.RDB$CONTEXT_TYPE*/
									 isc_680.isc_684);
				if (!/*X.RDB$PACKAGE_NAME.NULL*/
				     isc_680.isc_682)
					PUT_TEXT(att_view_context_package, /*X.RDB$PACKAGE_NAME*/
									   isc_680.isc_688);
				put(tdgbl, att_end);
			/*END_FOR*/
			   }
			   };
			/*ON_ERROR*/
			if (isc_status [1])
			   {
				general_on_error();
			/*END_ERROR;*/
			   }
			}
		}
		else
		{
			/*FOR (REQUEST_HANDLE tdgbl->handles_put_relation_req_handle1)
				X IN RDB$VIEW_RELATIONS WITH X.RDB$VIEW_NAME EQ relation->rel_name*/
			{
			if (!tdgbl->handles_put_relation_req_handle1)
			   {
			   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_put_relation_req_handle1, (short) sizeof(isc_669), (char*) isc_669);
			   }
			isc_vtov ((const char*) relation->rel_name, (char*) isc_670.isc_671, 125);
			if (tdgbl->handles_put_relation_req_handle1)
			   {
			   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_relation_req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_670, (short) 0);
			   }
			if (!isc_status [1]) {
			while (1)
			   {
			   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_relation_req_handle1, (short) 1, (short) 1150, &isc_672, (short) 0);
			   if (!isc_672.isc_673 || isc_status [1]) break;
				put(tdgbl, rec_view);
				PUT_TEXT (att_view_relation_name, /*X.RDB$RELATION_NAME*/
								  isc_672.isc_675);
				put_int32 (att_view_context_id, /*X.RDB$VIEW_CONTEXT*/
								isc_672.isc_674);
				PUT_TEXT (att_view_context_name, /*X.RDB$CONTEXT_NAME*/
								 isc_672.isc_676);
				put(tdgbl, att_end);
			/*END_FOR*/
			   }
			   };
			/*ON_ERROR*/
			if (isc_status [1])
			   {
				general_on_error();
			/*END_ERROR;*/
			   }
			}
		}
	}
	put(tdgbl, (UCHAR) rec_relation_end);
}


bool put_source_blob(att_type attribute, att_type old_attribute, ISC_QUAD& blob_id)
{
/**************************************
 *
 *	p u t _ s o u r c e _ b l o b
 *
 **************************************
 *
 * Functional description
 *	Write out a source blob or query header if present.
 *	Return true is there was the blob was present, false otherwise.
 *	Include the NULL character to separate each segment.
 *
 **************************************/
	ISC_STATUS_ARRAY status_vector;
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// If the blob is null, don't store it.  It will be restored as null.

	if (UserBlob::blobIsNull(blob_id))
		return false;

	if (tdgbl->gbl_sw_old_descriptions && attribute != att_field_query_header)
		return put_blr_blob(old_attribute, blob_id);

	// Open the blob and get it's vital statistics

	UserBlob blob(status_vector);

	if (!blob.open(DB, gds_trans, blob_id))
	{
		BURP_error_redirect(status_vector, 24);
		// msg 24 isc_open_blob failed
	}

	UCHAR blob_info[48];
	if (!blob.getInfo(sizeof(source_items), source_items, sizeof(blob_info), blob_info))
	{
		BURP_error_redirect(status_vector, 20);
		// msg 20 isc_blob_info failed
	}

	ULONG length = 0;
	ULONG num_seg = 0;
	USHORT max_segment = 0;
	const UCHAR* p = blob_info;
	UCHAR item;

	while ((item = *p++) != isc_info_end)
	{
		const USHORT l = gds__vax_integer(p, 2);
		p += 2;
		const ULONG n = gds__vax_integer(p, l);
		p += l;
		switch (item)
		{
		case isc_info_blob_max_segment:
			max_segment = n;
			break;

		case isc_info_blob_total_length:
			length = n;
			break;

		case isc_info_blob_num_segments:
			num_seg = n;
			break;

		default:
			BURP_print(true, 79, SafeArg() << int(item));
			// msg 79 don't understand blob info item %ld
			if (!blob.close())
			{
				BURP_error_redirect(status_vector, 23);
				// msg 23 isc_close_blob failed
			}
			return false;
		}
	}

	if (!length)
	{
		if (!blob.close())
		{
			BURP_error_redirect(status_vector, 23);
			// msg 23 isc_close_blob failed
		}
		return false;
	}

	// Rdb sometimes gets the length messed up

	if (length < max_segment)
		length = max_segment;

	fb_assert(FB_UINT64(length) + num_seg <= FB_UINT64(MAX_ULONG));
	put_int32(attribute, length + num_seg);

	// Allocate a buffer large enough for the largest segment and start grinding.

	UCHAR static_buffer[1024];
	UCHAR* buffer;
	if (!max_segment || max_segment <= sizeof(static_buffer))
		buffer = static_buffer;
	else
		buffer = BURP_alloc(max_segment);

	// The old code didn't accept isc_segment so we check it.
	FB_SIZE_T segment_length;
	while (blob.getSegment(max_segment, buffer, segment_length) && !blob.getCode())
	{
		if (segment_length)
		{
			put_block(tdgbl, buffer, segment_length);
		}
		put(tdgbl, (UCHAR) 0);
	}

	if (!blob.close())
		BURP_error_redirect(status_vector, 23);
	// msg 23 isc_close_blob failed

	if (buffer != static_buffer)
		BURP_free(buffer);

	return true;
}


int put_text( att_type attribute, const TEXT* text, SSHORT size_len)
{
/**************************************
 *
 *	p u t _ t e x t
 *
 **************************************
 *
 * Functional description
 * Write a variable length text string, with embedded spaces.
 * Truncate trailing spaces.
 * Now this routine does not truncate trailing spaces, 3-2002 MOD
 * transfering changes from fb1, I believe this is to do with problems
 * with quoted names and embedded spaces.
 * CVC: This routine does trailing spaces truncation, but correctly.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	SSHORT l = (SSHORT) MISC_symbol_length(text, (ULONG) size_len);
	fb_assert(l <= MAX_UCHAR);
	if (l > MAX_UCHAR)
	{
		BURP_print(true, 343, SafeArg() << int(attribute) << "put_text()" << MAX_UCHAR);
		// msg 343: text for attribute @1 is too large in @2, truncating to @3 bytes
		l = MAX_UCHAR;
	}

	put(tdgbl, attribute);
	put(tdgbl, (UCHAR) l);
	if (l)
		put_block(tdgbl, (const UCHAR*) text, l);

	return l;
}


void write_character_sets()
{
   struct isc_633_struct {
          ISC_QUAD isc_634;	/* RDB$DESCRIPTION */
          ISC_LONG isc_635;	/* RDB$NUMBER_OF_CHARACTERS */
          short isc_636;	/* isc_utility */
          short isc_637;	/* RDB$BYTES_PER_CHARACTER */
          short isc_638;	/* gds__null_flag */
          short isc_639;	/* gds__null_flag */
          short isc_640;	/* RDB$CHARACTER_SET_ID */
          short isc_641;	/* gds__null_flag */
          short isc_642;	/* gds__null_flag */
          short isc_643;	/* gds__null_flag */
          short isc_644;	/* RDB$SYSTEM_FLAG */
          char  isc_645 [125];	/* RDB$CHARACTER_SET_NAME */
          char  isc_646 [125];	/* RDB$FORM_OF_USE */
          char  isc_647 [125];	/* RDB$FUNCTION_NAME */
          char  isc_648 [125];	/* RDB$DEFAULT_COLLATE_NAME */
   } isc_633;
   struct isc_650_struct {
          ISC_QUAD isc_651;	/* RDB$DESCRIPTION */
          ISC_LONG isc_652;	/* RDB$NUMBER_OF_CHARACTERS */
          short isc_653;	/* isc_utility */
          short isc_654;	/* gds__null_flag */
          short isc_655;	/* gds__null_flag */
          short isc_656;	/* RDB$BYTES_PER_CHARACTER */
          short isc_657;	/* gds__null_flag */
          short isc_658;	/* gds__null_flag */
          short isc_659;	/* RDB$CHARACTER_SET_ID */
          short isc_660;	/* gds__null_flag */
          short isc_661;	/* gds__null_flag */
          short isc_662;	/* RDB$SYSTEM_FLAG */
          char  isc_663 [125];	/* RDB$CHARACTER_SET_NAME */
          char  isc_664 [125];	/* RDB$FORM_OF_USE */
          char  isc_665 [125];	/* RDB$FUNCTION_NAME */
          char  isc_666 [125];	/* RDB$SECURITY_CLASS */
          char  isc_667 [125];	/* RDB$OWNER_NAME */
          char  isc_668 [125];	/* RDB$DEFAULT_COLLATE_NAME */
   } isc_650;
/**************************************
 *
 *	w r i t e _ c h a r a c t e r _ s e t s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each user defined character set.
 *
 **************************************/
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$CHARACTER_SETS
			WITH X.RDB$SYSTEM_FLAG NE 1 OR
				 X.RDB$DEFAULT_COLLATE_NAME NE X.RDB$CHARACTER_SET_NAME*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_649), (char*) isc_649);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 782, &isc_650, (short) 0);
		   if (!isc_650.isc_653 || isc_status [1]) break;

			put(tdgbl, rec_charset);
			PUT_TEXT (att_charset_name, /*X.RDB$CHARACTER_SET_NAME*/
						    isc_650.isc_663);

			if (/*X.RDB$SYSTEM_FLAG*/
			    isc_650.isc_662 != 1)
			{
				if (!/*X.RDB$FORM_OF_USE.NULL*/
				     isc_650.isc_661)
					PUT_TEXT (att_charset_form, /*X.RDB$FORM_OF_USE*/
								    isc_650.isc_664);
				if (!/*X.RDB$NUMBER_OF_CHARACTERS.NULL*/
				     isc_650.isc_660)
					put_int32 (att_charset_numchar, /*X.RDB$NUMBER_OF_CHARACTERS*/
									isc_650.isc_652);
				put_int32 (att_charset_id, /*X.RDB$CHARACTER_SET_ID*/
							   isc_650.isc_659);
				if (/*X.RDB$SYSTEM_FLAG*/
				    isc_650.isc_662)
					put_int32 (att_charset_sysflag, /*X.RDB$SYSTEM_FLAG*/
									isc_650.isc_662);
				if (!/*X.RDB$DESCRIPTION.NULL*/
				     isc_650.isc_658)
				{
					put_source_blob (att_charset_description, att_charset_description, /*X.RDB$DESCRIPTION*/
													   isc_650.isc_651);
				}
				if (!/*X.RDB$FUNCTION_NAME.NULL*/
				     isc_650.isc_657)
					PUT_TEXT (att_charset_funct, /*X.RDB$FUNCTION_NAME*/
								     isc_650.isc_665);
				put_int32 (att_charset_bytes_char, /*X.RDB$BYTES_PER_CHARACTER*/
								   isc_650.isc_656);

				// CVC: Not sure if this code goes inside or outside this "if" block.
				if (!/*X.RDB$SECURITY_CLASS.NULL*/
				     isc_650.isc_655)
					PUT_TEXT(att_charset_security_class, /*X.RDB$SECURITY_CLASS*/
									     isc_650.isc_666);
				if (!/*X.RDB$OWNER_NAME.NULL*/
				     isc_650.isc_654)
					PUT_TEXT(att_charset_owner_name, /*X.RDB$OWNER_NAME*/
									 isc_650.isc_667);
			}

			PUT_TEXT (att_charset_coll, /*X.RDB$DEFAULT_COLLATE_NAME*/
						    isc_650.isc_668);
			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$CHARACTER_SETS
			WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1 OR
				 X.RDB$DEFAULT_COLLATE_NAME NE X.RDB$CHARACTER_SET_NAME*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_632), (char*) isc_632);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 530, &isc_633, (short) 0);
		   if (!isc_633.isc_636 || isc_status [1]) break;

			put(tdgbl, rec_charset);
			PUT_TEXT (att_charset_name, /*X.RDB$CHARACTER_SET_NAME*/
						    isc_633.isc_645);

			if (/*X.RDB$SYSTEM_FLAG.NULL*/
			    isc_633.isc_643 || /*X.RDB$SYSTEM_FLAG*/
    isc_633.isc_644 != 1)
			{
				if (!/*X.RDB$FORM_OF_USE.NULL*/
				     isc_633.isc_642)
					PUT_TEXT (att_charset_form, /*X.RDB$FORM_OF_USE*/
								    isc_633.isc_646);
				if (!/*X.RDB$NUMBER_OF_CHARACTERS.NULL*/
				     isc_633.isc_641)
					put_int32 (att_charset_numchar, /*X.RDB$NUMBER_OF_CHARACTERS*/
									isc_633.isc_635);
				put_int32 (att_charset_id, /*X.RDB$CHARACTER_SET_ID*/
							   isc_633.isc_640);
				if (/*X.RDB$SYSTEM_FLAG*/
				    isc_633.isc_644)
					put_int32 (att_charset_sysflag, /*X.RDB$SYSTEM_FLAG*/
									isc_633.isc_644);
				if (!/*X.RDB$DESCRIPTION.NULL*/
				     isc_633.isc_639)
				{
					put_source_blob (att_charset_description, att_charset_description, /*X.RDB$DESCRIPTION*/
													   isc_633.isc_634);
				}
				if (!/*X.RDB$FUNCTION_NAME.NULL*/
				     isc_633.isc_638)
					PUT_TEXT (att_charset_funct, /*X.RDB$FUNCTION_NAME*/
								     isc_633.isc_647);
				put_int32 (att_charset_bytes_char, /*X.RDB$BYTES_PER_CHARACTER*/
								   isc_633.isc_637);
			}

			PUT_TEXT (att_charset_coll, /*X.RDB$DEFAULT_COLLATE_NAME*/
						    isc_633.isc_648);
			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}


void write_check_constraints()
{
   struct isc_627_struct {
          short isc_628;	/* isc_utility */
          short isc_629;	/* gds__null_flag */
          char  isc_630 [125];	/* RDB$CONSTRAINT_NAME */
          char  isc_631 [125];	/* RDB$TRIGGER_NAME */
   } isc_627;
/**************************************
 *
 *	w r i t e _ c h e c k _ c o n s t r a i n t s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each check constraint.
 *
 **************************************/
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$CHECK_CONSTRAINTS*/
	{
	if (!req_handle1)
	   {
	   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_626), (char*) isc_626);
	   }
	if (req_handle1)
	   {
	   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	   }
	if (!isc_status [1]) {
	while (1)
	   {
	   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 254, &isc_627, (short) 0);
	   if (!isc_627.isc_628 || isc_status [1]) break;
		put(tdgbl, rec_chk_constraint);

		PUT_TEXT (att_chk_constraint_name, /*X.RDB$CONSTRAINT_NAME*/
						   isc_627.isc_630);
		if (!/*X.RDB$TRIGGER_NAME.NULL*/
		     isc_627.isc_629)
			PUT_TEXT (att_chk_trigger_name, /*X.RDB$TRIGGER_NAME*/
							isc_627.isc_631);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_collations()
{
   struct isc_579_struct {
          ISC_QUAD isc_580;	/* RDB$DESCRIPTION */
          short isc_581;	/* isc_utility */
          short isc_582;	/* gds__null_flag */
          short isc_583;	/* gds__null_flag */
          short isc_584;	/* RDB$SYSTEM_FLAG */
          short isc_585;	/* RDB$COLLATION_ATTRIBUTES */
          short isc_586;	/* RDB$CHARACTER_SET_ID */
          short isc_587;	/* RDB$COLLATION_ID */
          char  isc_588 [125];	/* RDB$COLLATION_NAME */
          char  isc_589 [125];	/* RDB$FUNCTION_NAME */
   } isc_579;
   struct isc_591_struct {
          ISC_QUAD isc_592;	/* RDB$SPECIFIC_ATTRIBUTES */
          ISC_QUAD isc_593;	/* RDB$DESCRIPTION */
          short isc_594;	/* isc_utility */
          short isc_595;	/* gds__null_flag */
          short isc_596;	/* gds__null_flag */
          short isc_597;	/* gds__null_flag */
          short isc_598;	/* gds__null_flag */
          short isc_599;	/* RDB$SYSTEM_FLAG */
          short isc_600;	/* RDB$COLLATION_ATTRIBUTES */
          short isc_601;	/* RDB$CHARACTER_SET_ID */
          short isc_602;	/* RDB$COLLATION_ID */
          char  isc_603 [125];	/* RDB$COLLATION_NAME */
          char  isc_604 [125];	/* RDB$FUNCTION_NAME */
          char  isc_605 [125];	/* RDB$BASE_COLLATION_NAME */
   } isc_591;
   struct isc_607_struct {
          ISC_QUAD isc_608;	/* RDB$SPECIFIC_ATTRIBUTES */
          ISC_QUAD isc_609;	/* RDB$DESCRIPTION */
          short isc_610;	/* isc_utility */
          short isc_611;	/* gds__null_flag */
          short isc_612;	/* gds__null_flag */
          short isc_613;	/* gds__null_flag */
          short isc_614;	/* gds__null_flag */
          short isc_615;	/* gds__null_flag */
          short isc_616;	/* gds__null_flag */
          short isc_617;	/* RDB$SYSTEM_FLAG */
          short isc_618;	/* RDB$COLLATION_ATTRIBUTES */
          short isc_619;	/* RDB$CHARACTER_SET_ID */
          short isc_620;	/* RDB$COLLATION_ID */
          char  isc_621 [125];	/* RDB$COLLATION_NAME */
          char  isc_622 [125];	/* RDB$FUNCTION_NAME */
          char  isc_623 [125];	/* RDB$BASE_COLLATION_NAME */
          char  isc_624 [125];	/* RDB$SECURITY_CLASS */
          char  isc_625 [125];	/* RDB$OWNER_NAME */
   } isc_607;
/**************************************
 *
 *	w r i t e _ c o l l a t i o n s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each user defined collation
 *
 **************************************/
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$COLLATIONS WITH X.RDB$SYSTEM_FLAG NE 1*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_606), (char*) isc_606);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 663, &isc_607, (short) 0);
		   if (!isc_607.isc_610 || isc_status [1]) break;
			put(tdgbl, rec_collation);
			PUT_TEXT (att_coll_name, /*X.RDB$COLLATION_NAME*/
						 isc_607.isc_621);
			put_int32 (att_coll_id, /*X.RDB$COLLATION_ID*/
						isc_607.isc_620);
			put_int32 (att_coll_cs_id, /*X.RDB$CHARACTER_SET_ID*/
						   isc_607.isc_619);
			put_int32 (att_coll_attr, /*X.RDB$COLLATION_ATTRIBUTES*/
						  isc_607.isc_618);
			if (/*X.RDB$SYSTEM_FLAG*/
			    isc_607.isc_617)
				put_int32 (att_coll_sysflag, /*X.RDB$SYSTEM_FLAG*/
							     isc_607.isc_617);
			if (!/*X.RDB$DESCRIPTION.NULL*/
			     isc_607.isc_616)
				put_source_blob (att_coll_description, att_coll_description, /*X.RDB$DESCRIPTION*/
											     isc_607.isc_609);
			if (!/*X.RDB$FUNCTION_NAME.NULL*/
			     isc_607.isc_615)
				PUT_TEXT (att_coll_funct, /*X.RDB$FUNCTION_NAME*/
							  isc_607.isc_622);
			if (!/*X.RDB$BASE_COLLATION_NAME.NULL*/
			     isc_607.isc_614)
				PUT_TEXT(att_coll_base_collation_name, /*X.RDB$BASE_COLLATION_NAME*/
								       isc_607.isc_623);
			if (!/*X.RDB$SPECIFIC_ATTRIBUTES.NULL*/
			     isc_607.isc_613)
				put_source_blob (att_coll_specific_attr, att_coll_specific_attr, /*X.RDB$SPECIFIC_ATTRIBUTES*/
												 isc_607.isc_608);

			if (!/*X.RDB$SECURITY_CLASS.NULL*/
			     isc_607.isc_612)
				PUT_TEXT(att_coll_security_class, /*X.RDB$SECURITY_CLASS*/
								  isc_607.isc_624);
			if (!/*X.RDB$OWNER_NAME.NULL*/
			     isc_607.isc_611)
				PUT_TEXT(att_coll_owner_name, /*X.RDB$OWNER_NAME*/
							      isc_607.isc_625);

			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else if (tdgbl->runtimeODS >= DB_VERSION_DDL11)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$COLLATIONS WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_590), (char*) isc_590);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 409, &isc_591, (short) 0);
		   if (!isc_591.isc_594 || isc_status [1]) break;
			put(tdgbl, rec_collation);
			PUT_TEXT (att_coll_name, /*X.RDB$COLLATION_NAME*/
						 isc_591.isc_603);
			put_int32 (att_coll_id, /*X.RDB$COLLATION_ID*/
						isc_591.isc_602);
			put_int32 (att_coll_cs_id, /*X.RDB$CHARACTER_SET_ID*/
						   isc_591.isc_601);
			put_int32 (att_coll_attr, /*X.RDB$COLLATION_ATTRIBUTES*/
						  isc_591.isc_600);
			if (/*X.RDB$SYSTEM_FLAG*/
			    isc_591.isc_599)
				put_int32 (att_coll_sysflag, /*X.RDB$SYSTEM_FLAG*/
							     isc_591.isc_599);
			if (!/*X.RDB$DESCRIPTION.NULL*/
			     isc_591.isc_598)
				put_source_blob (att_coll_description, att_coll_description, /*X.RDB$DESCRIPTION*/
											     isc_591.isc_593);
			if (!/*X.RDB$FUNCTION_NAME.NULL*/
			     isc_591.isc_597)
				PUT_TEXT (att_coll_funct, /*X.RDB$FUNCTION_NAME*/
							  isc_591.isc_604);
			if (!/*X.RDB$BASE_COLLATION_NAME.NULL*/
			     isc_591.isc_596)
				PUT_TEXT(att_coll_base_collation_name, /*X.RDB$BASE_COLLATION_NAME*/
								       isc_591.isc_605);
			if (!/*X.RDB$SPECIFIC_ATTRIBUTES.NULL*/
			     isc_591.isc_595)
				put_source_blob (att_coll_specific_attr, att_coll_specific_attr, /*X.RDB$SPECIFIC_ATTRIBUTES*/
												 isc_591.isc_592);
			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$COLLATIONS WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_578), (char*) isc_578);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 272, &isc_579, (short) 0);
		   if (!isc_579.isc_581 || isc_status [1]) break;
			put(tdgbl, rec_collation);
			PUT_TEXT (att_coll_name, /*X.RDB$COLLATION_NAME*/
						 isc_579.isc_588);
			put_int32 (att_coll_id, /*X.RDB$COLLATION_ID*/
						isc_579.isc_587);
			put_int32 (att_coll_cs_id, /*X.RDB$CHARACTER_SET_ID*/
						   isc_579.isc_586);
			put_int32 (att_coll_attr, /*X.RDB$COLLATION_ATTRIBUTES*/
						  isc_579.isc_585);
			if (/*X.RDB$SYSTEM_FLAG*/
			    isc_579.isc_584)
				put_int32 (att_coll_sysflag, /*X.RDB$SYSTEM_FLAG*/
							     isc_579.isc_584);
			if (!/*X.RDB$DESCRIPTION.NULL*/
			     isc_579.isc_583)
				put_source_blob (att_coll_description, att_coll_description, /*X.RDB$DESCRIPTION*/
											     isc_579.isc_580);
			if (!/*X.RDB$FUNCTION_NAME.NULL*/
			     isc_579.isc_582)
				PUT_TEXT (att_coll_funct, /*X.RDB$FUNCTION_NAME*/
							  isc_579.isc_589);
			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}


void write_database( const TEXT* dbb_file)
{
   struct isc_561_struct {
          ISC_QUAD isc_562;	/* RDB$DESCRIPTION */
          short isc_563;	/* isc_utility */
          short isc_564;	/* gds__null_flag */
          short isc_565;	/* gds__null_flag */
          char  isc_566 [125];	/* RDB$SECURITY_CLASS */
          char  isc_567 [125];	/* RDB$CHARACTER_SET_NAME */
   } isc_561;
   struct isc_569_struct {
          ISC_QUAD isc_570;	/* RDB$DESCRIPTION */
          ISC_LONG isc_571;	/* RDB$LINGER */
          short isc_572;	/* isc_utility */
          short isc_573;	/* gds__null_flag */
          short isc_574;	/* gds__null_flag */
          short isc_575;	/* gds__null_flag */
          char  isc_576 [125];	/* RDB$SECURITY_CLASS */
          char  isc_577 [125];	/* RDB$CHARACTER_SET_NAME */
   } isc_569;
/**************************************
 *
 *	w r i t e _ d a t a b a s e
 *
 **************************************
 *
 * Functional description
 * 	write a physical database record and a
 *	logical database record in the burp file for
 *	the database itself.
 *
 **************************************/
	ISC_STATUS_ARRAY status_vector;
	SCHAR buffer[256];
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	put(tdgbl, (UCHAR) rec_physical_db);

	if (isc_database_info(status_vector, &DB, sizeof(db_info_items), db_info_items,
						  sizeof(buffer), buffer))
	{
		BURP_error_redirect(status_vector, 31);
		// msg 31 isc_database_info failed
	}

	USHORT page_size = 0, forced_writes, no_reserve, SQL_dialect, db_read_only;
 	ULONG sweep_interval, page_buffers;
 	USHORT length = 0;
	for (const SCHAR* d = buffer; *d != isc_info_end; d += length)
	{
		const UCHAR item = *d++;
		length = (USHORT) isc_vax_integer(d, 2);
		d += 2;
		switch (item)
		{
		case isc_info_end:
			break;

		case isc_info_page_size:
			page_size = (USHORT) isc_vax_integer(d, length);
			put_int32(att_page_size, page_size);
			break;

		case isc_info_sweep_interval:
			sweep_interval = isc_vax_integer(d, length);
			put_int32(att_sweep_interval, sweep_interval);
			break;

		case isc_info_forced_writes:
			forced_writes = (USHORT) isc_vax_integer(d, length);
			put_int32(att_forced_writes, forced_writes);
			break;

		case isc_info_no_reserve:
			if (no_reserve = (USHORT) isc_vax_integer(d, length))
				put_int32(att_no_reserve, no_reserve);
			break;

		case isc_info_set_page_buffers:
			if (page_buffers = isc_vax_integer(d, length))
				put_int32(att_page_buffers, page_buffers);
			break;

		case isc_info_error:	// old server does not understand new isc_info
			break;				// parameter and returns isc_info_error. skip it

		case isc_info_db_sql_dialect:
			SQL_dialect = (USHORT) isc_vax_integer(d, length);
			put_int32(att_SQL_dialect, SQL_dialect);
			break;

		case isc_info_db_read_only:
			if (db_read_only = (USHORT) isc_vax_integer(d, length))
				put_int32(att_db_read_only, db_read_only);
			break;

		default:
			BURP_error_redirect(status_vector, 31);
			// msg 31 isc_database_info failed
			break;
		}
	}

	put_asciz(att_file_name, dbb_file);

	BURP_verbose(77, SafeArg() << dbb_file << page_size);
	// msg 77 database %s has a page size of %ld bytes.

	put(tdgbl, att_end);

	put(tdgbl, (UCHAR) rec_database);

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			D IN RDB$DATABASE*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_568), (char*) isc_568);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 270, &isc_569, (short) 0);
		   if (!isc_569.isc_572 || isc_status [1]) break;
			if (!/*D.RDB$SECURITY_CLASS.NULL*/
			     isc_569.isc_575)
				PUT_TEXT (att_database_security_class, /*D.RDB$SECURITY_CLASS*/
								       isc_569.isc_576);
			put_source_blob (att_database_description2, att_database_description, /*D.RDB$DESCRIPTION*/
											      isc_569.isc_570);
			if (!/*D.RDB$CHARACTER_SET_NAME.NULL*/
			     isc_569.isc_574)
				PUT_TEXT (att_database_dfl_charset, /*D.RDB$CHARACTER_SET_NAME*/
								    isc_569.isc_577);
			if (!/*D.RDB$LINGER.NULL*/
			     isc_569.isc_573)
				put_int32(att_database_linger, /*D.RDB$LINGER*/
							       isc_569.isc_571);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			D IN RDB$DATABASE*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_560), (char*) isc_560);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 264, &isc_561, (short) 0);
		   if (!isc_561.isc_563 || isc_status [1]) break;
			if (!/*D.RDB$SECURITY_CLASS.NULL*/
			     isc_561.isc_565)
				PUT_TEXT (att_database_security_class, /*D.RDB$SECURITY_CLASS*/
								       isc_561.isc_566);
			put_source_blob (att_database_description2, att_database_description, /*D.RDB$DESCRIPTION*/
											      isc_561.isc_562);
			if (!/*D.RDB$CHARACTER_SET_NAME.NULL*/
			     isc_561.isc_564)
				PUT_TEXT (att_database_dfl_charset, /*D.RDB$CHARACTER_SET_NAME*/
								    isc_561.isc_567);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);

	put(tdgbl, att_end);
}


void write_exceptions()
{
   struct isc_545_struct {
          ISC_QUAD isc_546;	/* RDB$DESCRIPTION */
          char  isc_547 [1024];	/* RDB$MESSAGE */
          short isc_548;	/* isc_utility */
          char  isc_549 [125];	/* RDB$EXCEPTION_NAME */
   } isc_545;
   struct isc_551_struct {
          ISC_QUAD isc_552;	/* RDB$DESCRIPTION */
          char  isc_553 [1024];	/* RDB$MESSAGE */
          short isc_554;	/* isc_utility */
          short isc_555;	/* gds__null_flag */
          short isc_556;	/* gds__null_flag */
          char  isc_557 [125];	/* RDB$EXCEPTION_NAME */
          char  isc_558 [125];	/* RDB$SECURITY_CLASS */
          char  isc_559 [125];	/* RDB$OWNER_NAME */
   } isc_551;
/**************************************
 *
 *	w r i t e _ e x c e p t i o n s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each exception.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$EXCEPTIONS
			WITH X.RDB$SYSTEM_FLAG NE 1*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_550), (char*) isc_550);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 1413, &isc_551, (short) 0);
		   if (!isc_551.isc_554 || isc_status [1]) break;
			put(tdgbl, rec_exception);
			const SSHORT l = PUT_TEXT (att_exception_name, /*X.RDB$EXCEPTION_NAME*/
								       isc_551.isc_557);
			MISC_terminate (/*X.RDB$EXCEPTION_NAME*/
					isc_551.isc_557, temp, l, sizeof(temp));
			BURP_verbose (198, temp);
			// msg 198 writing exception %s
			PUT_MESSAGE(att_exception_msg, att_exception_msg2, /*X.RDB$MESSAGE*/
									   isc_551.isc_553);
			put_source_blob (att_exception_description2, att_procedure_description, /*X.RDB$DESCRIPTION*/
												isc_551.isc_552);

			if (!/*X.RDB$SECURITY_CLASS.NULL*/
			     isc_551.isc_556)
				PUT_TEXT(att_exception_security_class, /*X.RDB$SECURITY_CLASS*/
								       isc_551.isc_558);
			if (!/*X.RDB$OWNER_NAME.NULL*/
			     isc_551.isc_555)
				PUT_TEXT(att_exception_owner_name, /*X.RDB$OWNER_NAME*/
								   isc_551.isc_559);

			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$EXCEPTIONS
			WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_544), (char*) isc_544);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 1159, &isc_545, (short) 0);
		   if (!isc_545.isc_548 || isc_status [1]) break;
			put(tdgbl, rec_exception);
			const SSHORT l = PUT_TEXT (att_exception_name, /*X.RDB$EXCEPTION_NAME*/
								       isc_545.isc_549);
			MISC_terminate (/*X.RDB$EXCEPTION_NAME*/
					isc_545.isc_549, temp, l, sizeof(temp));
			BURP_verbose (198, temp);
			// msg 198 writing exception %s
			PUT_MESSAGE(att_exception_msg, att_exception_msg2, /*X.RDB$MESSAGE*/
									   isc_545.isc_547);
			put_source_blob (att_exception_description2, att_procedure_description, /*X.RDB$DESCRIPTION*/
												isc_545.isc_546);
			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}


void write_field_dimensions()
{
   struct isc_538_struct {
          ISC_LONG isc_539;	/* RDB$UPPER_BOUND */
          ISC_LONG isc_540;	/* RDB$LOWER_BOUND */
          short isc_541;	/* isc_utility */
          short isc_542;	/* RDB$DIMENSION */
          char  isc_543 [125];	/* RDB$FIELD_NAME */
   } isc_538;
/**************************************
 *
 *	w r i t e _ f i e l d _ d i m e n s i o n s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each array field dimension.
 *
 **************************************/
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$FIELD_DIMENSIONS*/
	{
	if (!req_handle1)
	   {
	   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_537), (char*) isc_537);
	   }
	if (req_handle1)
	   {
	   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	   }
	if (!isc_status [1]) {
	while (1)
	   {
	   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 137, &isc_538, (short) 0);
	   if (!isc_538.isc_541 || isc_status [1]) break;
		put(tdgbl, rec_field_dimensions);
		PUT_TEXT (att_field_name, /*X.RDB$FIELD_NAME*/
					  isc_538.isc_543);
		put_int32 (att_field_dimensions, /*X.RDB$DIMENSION*/
						 isc_538.isc_542);
		put_int32 (att_field_range_low, /*X.RDB$LOWER_BOUND*/
						isc_538.isc_540);
		put_int32 (att_field_range_high, /*X.RDB$UPPER_BOUND*/
						 isc_538.isc_539);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_filters()
{
   struct isc_529_struct {
          char  isc_530 [256];	/* RDB$ENTRYPOINT */
          char  isc_531 [256];	/* RDB$MODULE_NAME */
          ISC_QUAD isc_532;	/* RDB$DESCRIPTION */
          short isc_533;	/* isc_utility */
          short isc_534;	/* RDB$OUTPUT_SUB_TYPE */
          short isc_535;	/* RDB$INPUT_SUB_TYPE */
          char  isc_536 [125];	/* RDB$FUNCTION_NAME */
   } isc_529;
/**************************************
 *
 *	w r i t e _ f i l t e r s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each filter.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$FILTERS
		WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
	{
	if (!req_handle1)
	   {
	   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_528), (char*) isc_528);
	   }
	if (req_handle1)
	   {
	   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	   }
	if (!isc_status [1]) {
	while (1)
	   {
	   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 651, &isc_529, (short) 0);
	   if (!isc_529.isc_533 || isc_status [1]) break;
		put(tdgbl, rec_filter);
		const SSHORT l = PUT_TEXT (att_filter_name, /*X.RDB$FUNCTION_NAME*/
							    isc_529.isc_536);
		MISC_terminate (/*X.RDB$FUNCTION_NAME*/
				isc_529.isc_536, temp, l, sizeof(temp));
		BURP_verbose (145, temp);
		// msg 145 writing filter %s
		put_source_blob (att_filter_description2, att_filter_description, /*X.RDB$DESCRIPTION*/
										  isc_529.isc_532);
		PUT_TEXT (att_filter_module_name, /*X.RDB$MODULE_NAME*/
						  isc_529.isc_531);
		PUT_TEXT (att_filter_entrypoint, /*X.RDB$ENTRYPOINT*/
						 isc_529.isc_530);
		put_int32 (att_filter_input_sub_type, /*X.RDB$INPUT_SUB_TYPE*/
						      isc_529.isc_535);
		put_int32 (att_filter_output_sub_type, /*X.RDB$OUTPUT_SUB_TYPE*/
						       isc_529.isc_534);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_functions()
{
   struct isc_485_struct {
          char  isc_486 [256];	/* RDB$ENTRYPOINT */
          char  isc_487 [256];	/* RDB$MODULE_NAME */
          ISC_QUAD isc_488;	/* RDB$DESCRIPTION */
          short isc_489;	/* isc_utility */
          short isc_490;	/* RDB$FUNCTION_TYPE */
          short isc_491;	/* RDB$RETURN_ARGUMENT */
          char  isc_492 [125];	/* RDB$FUNCTION_NAME */
          char  isc_493 [125];	/* RDB$QUERY_NAME */
   } isc_485;
   struct isc_495_struct {
          ISC_QUAD isc_496;	/* RDB$DEBUG_INFO */
          ISC_QUAD isc_497;	/* RDB$FUNCTION_SOURCE */
          ISC_QUAD isc_498;	/* RDB$FUNCTION_BLR */
          char  isc_499 [256];	/* RDB$ENTRYPOINT */
          char  isc_500 [256];	/* RDB$MODULE_NAME */
          ISC_QUAD isc_501;	/* RDB$DESCRIPTION */
          short isc_502;	/* isc_utility */
          short isc_503;	/* gds__null_flag */
          short isc_504;	/* RDB$DETERMINISTIC_FLAG */
          short isc_505;	/* gds__null_flag */
          short isc_506;	/* RDB$LEGACY_FLAG */
          short isc_507;	/* gds__null_flag */
          short isc_508;	/* gds__null_flag */
          short isc_509;	/* gds__null_flag */
          short isc_510;	/* gds__null_flag */
          short isc_511;	/* RDB$VALID_BLR */
          short isc_512;	/* gds__null_flag */
          short isc_513;	/* gds__null_flag */
          short isc_514;	/* gds__null_flag */
          short isc_515;	/* RDB$PRIVATE_FLAG */
          short isc_516;	/* gds__null_flag */
          short isc_517;	/* gds__null_flag */
          short isc_518;	/* gds__null_flag */
          short isc_519;	/* RDB$FUNCTION_TYPE */
          short isc_520;	/* RDB$RETURN_ARGUMENT */
          short isc_521;	/* gds__null_flag */
          char  isc_522 [125];	/* RDB$PACKAGE_NAME */
          char  isc_523 [125];	/* RDB$FUNCTION_NAME */
          char  isc_524 [125];	/* RDB$QUERY_NAME */
          char  isc_525 [125];	/* RDB$ENGINE_NAME */
          char  isc_526 [125];	/* RDB$SECURITY_CLASS */
          char  isc_527 [125];	/* RDB$OWNER_NAME */
   } isc_495;
/**************************************
 *
 *	w r i t e _ f u n c t i o n s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each function.
 *
 **************************************/
	GDS_NAME func;
	TEXT temp[GDS_NAME_LEN * 2];
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$FUNCTIONS WITH X.RDB$SYSTEM_FLAG NE 1*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_494), (char*) isc_494);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 1334, &isc_495, (short) 0);
		   if (!isc_495.isc_502 || isc_status [1]) break;
			put(tdgbl, rec_function);

			SSHORT prefixLen = 0;

			if (!/*X.RDB$PACKAGE_NAME.NULL*/
			     isc_495.isc_521)
			{
				prefixLen = PUT_TEXT(att_function_package_name, /*X.RDB$PACKAGE_NAME*/
										isc_495.isc_522);
				MISC_terminate(/*X.RDB$PACKAGE_NAME*/
					       isc_495.isc_522, temp, prefixLen, sizeof(temp));
				temp[prefixLen++] = '.';
			}

			const SSHORT l = PUT_TEXT (att_function_name, /*X.RDB$FUNCTION_NAME*/
								      isc_495.isc_523);
			MISC_terminate (/*X.RDB$FUNCTION_NAME*/
					isc_495.isc_523, temp + prefixLen, l, sizeof(temp) - prefixLen);
			BURP_verbose (147, temp);
			// msg 147 writing function %.*s
			put_source_blob (att_function_description2, att_function_description, /*X.RDB$DESCRIPTION*/
											      isc_495.isc_501);
			put_int32 (att_function_return_arg, /*X.RDB$RETURN_ARGUMENT*/
							    isc_495.isc_520);
			put_int32 (att_function_type, /*X.RDB$FUNCTION_TYPE*/
						      isc_495.isc_519);
			PUT_TEXT (att_function_query_name, /*X.RDB$QUERY_NAME*/
							   isc_495.isc_524);

			if (!/*X.RDB$MODULE_NAME.NULL*/
			     isc_495.isc_518)
				PUT_TEXT(att_function_module_name, /*X.RDB$MODULE_NAME*/
								   isc_495.isc_500);
			if (!/*X.RDB$ENTRYPOINT.NULL*/
			     isc_495.isc_517)
				PUT_TEXT(att_function_entrypoint, /*X.RDB$ENTRYPOINT*/
								  isc_495.isc_499);

			if (!/*X.RDB$ENGINE_NAME.NULL*/
			     isc_495.isc_516)
				PUT_TEXT(att_function_engine_name, /*X.RDB$ENGINE_NAME*/
								   isc_495.isc_525);
			if (!/*X.RDB$PRIVATE_FLAG.NULL*/
			     isc_495.isc_514)
				put_int32(att_function_private_flag, /*X.RDB$PRIVATE_FLAG*/
								     isc_495.isc_515);
			if (!/*X.RDB$FUNCTION_BLR.NULL*/
			     isc_495.isc_513)
				put_blr_blob(att_function_blr, /*X.RDB$FUNCTION_BLR*/
							       isc_495.isc_498);
			if (!/*X.RDB$FUNCTION_SOURCE.NULL*/
			     isc_495.isc_512)
				put_source_blob(att_function_source, att_function_source, /*X.RDB$FUNCTION_SOURCE*/
											  isc_495.isc_497);
			if (!/*X.RDB$VALID_BLR.NULL*/
			     isc_495.isc_510)
				put_int32(att_function_valid_blr, /*X.RDB$VALID_BLR*/
								  isc_495.isc_511);
			if (!/*X.RDB$DEBUG_INFO.NULL*/
			     isc_495.isc_509)
				put_blr_blob(att_function_debug_info, /*X.RDB$DEBUG_INFO*/
								      isc_495.isc_496);
			if (!/*X.RDB$SECURITY_CLASS.NULL*/
			     isc_495.isc_508)
				PUT_TEXT(att_function_security_class, /*X.RDB$SECURITY_CLASS*/
								      isc_495.isc_526);
			if (!/*X.RDB$OWNER_NAME.NULL*/
			     isc_495.isc_507)
				PUT_TEXT(att_function_owner_name, /*X.RDB$OWNER_NAME*/
								  isc_495.isc_527);
			if (!/*X.RDB$LEGACY_FLAG.NULL*/
			     isc_495.isc_505)
				put_int32(att_function_legacy_flag, /*X.RDB$LEGACY_FLAG*/
								    isc_495.isc_506);
			if (!/*X.RDB$DETERMINISTIC_FLAG.NULL*/
			     isc_495.isc_503)
				put_int32(att_function_deterministic_flag, /*X.RDB$DETERMINISTIC_FLAG*/
									   isc_495.isc_504);

			put(tdgbl, att_end);

			COPY (/*X.RDB$FUNCTION_NAME*/
			      isc_495.isc_523, func);
			write_function_args ((/*X.RDB$PACKAGE_NAME.NULL*/
					      isc_495.isc_521 ? "" : /*X.RDB$PACKAGE_NAME*/
	isc_495.isc_522), func);
			put(tdgbl, rec_function_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$FUNCTIONS WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_484), (char*) isc_484);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 776, &isc_485, (short) 0);
		   if (!isc_485.isc_489 || isc_status [1]) break;
			put(tdgbl, rec_function);
			const SSHORT l = PUT_TEXT (att_function_name, /*X.RDB$FUNCTION_NAME*/
								      isc_485.isc_492);
			MISC_terminate (/*X.RDB$FUNCTION_NAME*/
					isc_485.isc_492, temp, l, sizeof(temp));
			BURP_verbose (147, temp);
			// msg 147 writing function %.*s
			put_source_blob (att_function_description2, att_function_description, /*X.RDB$DESCRIPTION*/
											      isc_485.isc_488);
			PUT_TEXT (att_function_module_name, /*X.RDB$MODULE_NAME*/
							    isc_485.isc_487);
			PUT_TEXT (att_function_entrypoint, /*X.RDB$ENTRYPOINT*/
							   isc_485.isc_486);
			put_int32 (att_function_return_arg, /*X.RDB$RETURN_ARGUMENT*/
							    isc_485.isc_491);
			put_int32 (att_function_type, /*X.RDB$FUNCTION_TYPE*/
						      isc_485.isc_490);
			PUT_TEXT (att_function_query_name, /*X.RDB$QUERY_NAME*/
							   isc_485.isc_493);
			put(tdgbl, att_end);
			COPY (/*X.RDB$FUNCTION_NAME*/
			      isc_485.isc_492, func);
			write_function_args ("", func);
			put(tdgbl, rec_function_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}


void write_function_args(const GDS_NAME package, GDS_NAME funcptr)
{
   struct isc_418_struct {
          short isc_419;	/* isc_utility */
          short isc_420;	/* gds__null_flag */
          short isc_421;	/* RDB$CHARACTER_SET_ID */
          short isc_422;	/* RDB$FIELD_SUB_TYPE */
          short isc_423;	/* RDB$FIELD_LENGTH */
          short isc_424;	/* RDB$FIELD_SCALE */
          short isc_425;	/* RDB$FIELD_TYPE */
          short isc_426;	/* RDB$MECHANISM */
          short isc_427;	/* RDB$ARGUMENT_POSITION */
          char  isc_428 [125];	/* RDB$FUNCTION_NAME */
   } isc_418;
   struct isc_416_struct {
          char  isc_417 [125];	/* RDB$FUNCTION_NAME */
   } isc_416;
   struct isc_432_struct {
          short isc_433;	/* isc_utility */
          short isc_434;	/* gds__null_flag */
          short isc_435;	/* RDB$FIELD_PRECISION */
          short isc_436;	/* gds__null_flag */
          short isc_437;	/* RDB$CHARACTER_SET_ID */
          short isc_438;	/* RDB$FIELD_SUB_TYPE */
          short isc_439;	/* RDB$FIELD_LENGTH */
          short isc_440;	/* RDB$FIELD_SCALE */
          short isc_441;	/* RDB$FIELD_TYPE */
          short isc_442;	/* RDB$MECHANISM */
          short isc_443;	/* RDB$ARGUMENT_POSITION */
          char  isc_444 [125];	/* RDB$FUNCTION_NAME */
   } isc_432;
   struct isc_430_struct {
          char  isc_431 [125];	/* RDB$FUNCTION_NAME */
   } isc_430;
   struct isc_449_struct {
          ISC_QUAD isc_450;	/* RDB$DESCRIPTION */
          ISC_QUAD isc_451;	/* RDB$DEFAULT_SOURCE */
          ISC_QUAD isc_452;	/* RDB$DEFAULT_VALUE */
          short isc_453;	/* isc_utility */
          short isc_454;	/* gds__null_flag */
          short isc_455;	/* gds__null_flag */
          short isc_456;	/* gds__null_flag */
          short isc_457;	/* gds__null_flag */
          short isc_458;	/* RDB$ARGUMENT_MECHANISM */
          short isc_459;	/* gds__null_flag */
          short isc_460;	/* RDB$NULL_FLAG */
          short isc_461;	/* gds__null_flag */
          short isc_462;	/* RDB$COLLATION_ID */
          short isc_463;	/* gds__null_flag */
          short isc_464;	/* gds__null_flag */
          short isc_465;	/* gds__null_flag */
          short isc_466;	/* gds__null_flag */
          short isc_467;	/* gds__null_flag */
          short isc_468;	/* RDB$FIELD_PRECISION */
          short isc_469;	/* gds__null_flag */
          short isc_470;	/* RDB$CHARACTER_SET_ID */
          short isc_471;	/* RDB$FIELD_SUB_TYPE */
          short isc_472;	/* RDB$FIELD_LENGTH */
          short isc_473;	/* RDB$FIELD_SCALE */
          short isc_474;	/* RDB$FIELD_TYPE */
          short isc_475;	/* RDB$MECHANISM */
          short isc_476;	/* RDB$ARGUMENT_POSITION */
          short isc_477;	/* gds__null_flag */
          char  isc_478 [125];	/* RDB$PACKAGE_NAME */
          char  isc_479 [125];	/* RDB$FUNCTION_NAME */
          char  isc_480 [125];	/* RDB$ARGUMENT_NAME */
          char  isc_481 [125];	/* RDB$FIELD_SOURCE */
          char  isc_482 [125];	/* RDB$FIELD_NAME */
          char  isc_483 [125];	/* RDB$RELATION_NAME */
   } isc_449;
   struct isc_446_struct {
          char  isc_447 [125];	/* RDB$FUNCTION_NAME */
          char  isc_448 [125];	/* RDB$PACKAGE_NAME */
   } isc_446;
/**************************************
 *
 *	w r i t e _ f u n c t i o n _ a r g s
 *
 **************************************
 *
 * Functional description
 * 	write all arguments for a function.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN * 2];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// if we have all capabilities, use the first request to get the
	// most performance out of the latest engine; if we don't
	// have one of the capabilities we must use the second set of
	// requests--this requires more code but it is well worth it
	// for the performance benefits, especially remotely--deej

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		/*FOR (REQUEST_HANDLE tdgbl->handles_write_function_args_req_handle1)
			X IN RDB$FUNCTION_ARGUMENTS
			WITH X.RDB$FUNCTION_NAME EQ funcptr AND
				 X.RDB$PACKAGE_NAME EQUIV NULLIF(package, '')*/
		{
		if (!tdgbl->handles_write_function_args_req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_write_function_args_req_handle1, (short) sizeof(isc_445), (char*) isc_445);
		   }
		isc_vtov ((const char*) funcptr, (char*) isc_446.isc_447, 125);
		isc_vtov ((const char*) package, (char*) isc_446.isc_448, 125);
		if (tdgbl->handles_write_function_args_req_handle1)
		   {
		   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_write_function_args_req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 250, &isc_446, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_write_function_args_req_handle1, (short) 1, (short) 824, &isc_449, (short) 0);
		   if (!isc_449.isc_453 || isc_status [1]) break;

			put(tdgbl, rec_function_arg);

			SSHORT prefixLen = 0;

			if (!/*X.RDB$PACKAGE_NAME.NULL*/
			     isc_449.isc_477)
			{
				prefixLen = PUT_TEXT(att_functionarg_package_name, /*X.RDB$PACKAGE_NAME*/
										   isc_449.isc_478);
				MISC_terminate(/*X.RDB$PACKAGE_NAME*/
					       isc_449.isc_478, temp, prefixLen, sizeof(temp));
				temp[prefixLen++] = '.';
			}

			const SSHORT l = PUT_TEXT (att_functionarg_name, /*X.RDB$FUNCTION_NAME*/
									 isc_449.isc_479);
			MISC_terminate (/*X.RDB$FUNCTION_NAME*/
					isc_449.isc_479, temp + prefixLen, l, sizeof(temp) - prefixLen);
			BURP_verbose (141, temp);
			// msg 141 writing argument for function %s

			put_int32 (att_functionarg_position, /*X.RDB$ARGUMENT_POSITION*/
							     isc_449.isc_476);
			put_int32 (att_functionarg_passing_mechanism, /*X.RDB$MECHANISM*/
								      isc_449.isc_475);
			put_int32 (att_functionarg_field_type, /*X.RDB$FIELD_TYPE*/
							       isc_449.isc_474);
			put_int32 (att_functionarg_field_scale, /*X.RDB$FIELD_SCALE*/
								isc_449.isc_473);
			put_int32 (att_functionarg_field_length, /*X.RDB$FIELD_LENGTH*/
								 isc_449.isc_472);
			put_int32 (att_functionarg_field_sub_type, /*X.RDB$FIELD_SUB_TYPE*/
								   isc_449.isc_471);
			if (!/*X.RDB$CHARACTER_SET_ID.NULL*/
			     isc_449.isc_469)
				put_int32 (att_functionarg_character_set, /*X.RDB$CHARACTER_SET_ID*/
									  isc_449.isc_470);

			if (!/*X.RDB$FIELD_PRECISION.NULL*/
			     isc_449.isc_467)
				put_int32 (att_functionarg_field_precision, /*X.RDB$FIELD_PRECISION*/
									    isc_449.isc_468);

			if (!/*X.RDB$ARGUMENT_NAME.NULL*/
			     isc_449.isc_466)
				PUT_TEXT(att_functionarg_arg_name, /*X.RDB$ARGUMENT_NAME*/
								   isc_449.isc_480);
			if (!/*X.RDB$FIELD_SOURCE.NULL*/
			     isc_449.isc_465)
				PUT_TEXT(att_functionarg_field_source, /*X.RDB$FIELD_SOURCE*/
								       isc_449.isc_481);
			if (!/*X.RDB$DEFAULT_VALUE.NULL*/
			     isc_449.isc_464)
				put_blr_blob(att_functionarg_default_value, /*X.RDB$DEFAULT_VALUE*/
									    isc_449.isc_452);
			if (!/*X.RDB$DEFAULT_SOURCE.NULL*/
			     isc_449.isc_463)
				put_source_blob(att_functionarg_default_source, att_functionarg_default_source,
								/*X.RDB$DEFAULT_SOURCE*/
								isc_449.isc_451);
			if (!/*X.RDB$COLLATION_ID.NULL*/
			     isc_449.isc_461)
				put_int32(att_functionarg_collation_id, /*X.RDB$COLLATION_ID*/
									isc_449.isc_462);
			if (!/*X.RDB$NULL_FLAG.NULL*/
			     isc_449.isc_459)
				put_int32(att_functionarg_null_flag, /*X.RDB$NULL_FLAG*/
								     isc_449.isc_460);
			if (!/*X.RDB$ARGUMENT_MECHANISM.NULL*/
			     isc_449.isc_457)
				put_int32(att_functionarg_type_mechanism, /*X.RDB$ARGUMENT_MECHANISM*/
									  isc_449.isc_458);
			if (!/*X.RDB$FIELD_NAME.NULL*/
			     isc_449.isc_456)
				PUT_TEXT(att_functionarg_field_name, /*X.RDB$FIELD_NAME*/
								     isc_449.isc_482);
			if (!/*X.RDB$RELATION_NAME.NULL*/
			     isc_449.isc_455)
				PUT_TEXT(att_functionarg_relation_name, /*X.RDB$RELATION_NAME*/
									isc_449.isc_483);
			if (!/*X.RDB$DESCRIPTION.NULL*/
			     isc_449.isc_454)
				put_source_blob(att_functionarg_description, att_functionarg_description, /*X.RDB$DESCRIPTION*/
													  isc_449.isc_450);

			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else if (tdgbl->runtimeODS >= DB_VERSION_DDL10)
	{
		/*FOR (REQUEST_HANDLE tdgbl->handles_write_function_args_req_handle1)
			X IN RDB$FUNCTION_ARGUMENTS WITH
			X.RDB$FUNCTION_NAME EQ funcptr*/
		{
		if (!tdgbl->handles_write_function_args_req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_write_function_args_req_handle1, (short) sizeof(isc_429), (char*) isc_429);
		   }
		isc_vtov ((const char*) funcptr, (char*) isc_430.isc_431, 125);
		if (tdgbl->handles_write_function_args_req_handle1)
		   {
		   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_write_function_args_req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_430, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_write_function_args_req_handle1, (short) 1, (short) 147, &isc_432, (short) 0);
		   if (!isc_432.isc_433 || isc_status [1]) break;

			put(tdgbl, rec_function_arg);
			const SSHORT l = PUT_TEXT (att_functionarg_name, /*X.RDB$FUNCTION_NAME*/
									 isc_432.isc_444);
			MISC_terminate (/*X.RDB$FUNCTION_NAME*/
					isc_432.isc_444, temp, l, sizeof(temp));
			BURP_verbose (141, temp);
			// msg 141 writing argument for function %s
			put_int32 (att_functionarg_position, /*X.RDB$ARGUMENT_POSITION*/
							     isc_432.isc_443);
			put_int32 (att_functionarg_passing_mechanism, /*X.RDB$MECHANISM*/
								      isc_432.isc_442);
			put_int32 (att_functionarg_field_type, /*X.RDB$FIELD_TYPE*/
							       isc_432.isc_441);
			put_int32 (att_functionarg_field_scale, /*X.RDB$FIELD_SCALE*/
								isc_432.isc_440);
			put_int32 (att_functionarg_field_length, /*X.RDB$FIELD_LENGTH*/
								 isc_432.isc_439);
			put_int32 (att_functionarg_field_sub_type, /*X.RDB$FIELD_SUB_TYPE*/
								   isc_432.isc_438);
			if (!/*X.RDB$CHARACTER_SET_ID.NULL*/
			     isc_432.isc_436)
				put_int32 (att_functionarg_character_set, /*X.RDB$CHARACTER_SET_ID*/
									  isc_432.isc_437);

			if (!/*X.RDB$FIELD_PRECISION.NULL*/
			     isc_432.isc_434)
				put_int32 (att_functionarg_field_precision, /*X.RDB$FIELD_PRECISION*/
									    isc_432.isc_435);
			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE tdgbl->handles_write_function_args_req_handle1)
			X IN RDB$FUNCTION_ARGUMENTS WITH
			X.RDB$FUNCTION_NAME EQ funcptr*/
		{
		if (!tdgbl->handles_write_function_args_req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_write_function_args_req_handle1, (short) sizeof(isc_415), (char*) isc_415);
		   }
		isc_vtov ((const char*) funcptr, (char*) isc_416.isc_417, 125);
		if (tdgbl->handles_write_function_args_req_handle1)
		   {
		   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_write_function_args_req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_416, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_write_function_args_req_handle1, (short) 1, (short) 143, &isc_418, (short) 0);
		   if (!isc_418.isc_419 || isc_status [1]) break;

			put(tdgbl, rec_function_arg);
			const SSHORT l = PUT_TEXT (att_functionarg_name, /*X.RDB$FUNCTION_NAME*/
									 isc_418.isc_428);
			MISC_terminate (/*X.RDB$FUNCTION_NAME*/
					isc_418.isc_428, temp, l, sizeof(temp));
			BURP_verbose (141, temp);
			// msg 141 writing argument for function %s
			put_int32 (att_functionarg_position, /*X.RDB$ARGUMENT_POSITION*/
							     isc_418.isc_427);
			put_int32 (att_functionarg_passing_mechanism, /*X.RDB$MECHANISM*/
								      isc_418.isc_426);
			put_int32 (att_functionarg_field_type, /*X.RDB$FIELD_TYPE*/
							       isc_418.isc_425);
			put_int32 (att_functionarg_field_scale, /*X.RDB$FIELD_SCALE*/
								isc_418.isc_424);
			put_int32 (att_functionarg_field_length, /*X.RDB$FIELD_LENGTH*/
								 isc_418.isc_423);
			put_int32 (att_functionarg_field_sub_type, /*X.RDB$FIELD_SUB_TYPE*/
								   isc_418.isc_422);

			if (!/*X.RDB$CHARACTER_SET_ID.NULL*/
			     isc_418.isc_420)
				put_int32 (att_functionarg_character_set, /*X.RDB$CHARACTER_SET_ID*/
									  isc_418.isc_421);
			// Note that DB_VERSION_DDL10 canNOT be set if we're in this
			// "else" branch.  Hence there is no need to test that
			// bit and store the RDB$FIELD_PRECISION.

			put(tdgbl, att_end);

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
}


void write_generators()
{
   struct isc_392_struct {
          short isc_393;	/* isc_utility */
          char  isc_394 [125];	/* RDB$GENERATOR_NAME */
   } isc_392;
   struct isc_396_struct {
          ISC_QUAD isc_397;	/* RDB$DESCRIPTION */
          short isc_398;	/* isc_utility */
          short isc_399;	/* gds__null_flag */
          char  isc_400 [125];	/* RDB$GENERATOR_NAME */
   } isc_396;
   struct isc_402_struct {
          ISC_INT64 isc_403;	/* RDB$INITIAL_VALUE */
          ISC_QUAD isc_404;	/* RDB$DESCRIPTION */
          ISC_LONG isc_405;	/* RDB$GENERATOR_INCREMENT */
          short isc_406;	/* isc_utility */
          short isc_407;	/* gds__null_flag */
          short isc_408;	/* gds__null_flag */
          short isc_409;	/* gds__null_flag */
          short isc_410;	/* RDB$SYSTEM_FLAG */
          short isc_411;	/* gds__null_flag */
          char  isc_412 [125];	/* RDB$GENERATOR_NAME */
          char  isc_413 [125];	/* RDB$SECURITY_CLASS */
          char  isc_414 [125];	/* RDB$OWNER_NAME */
   } isc_402;
/**************************************
 *
 *	w r i t e _ g e n e r a t o r s
 *
 **************************************
 *
 * Functional description
 *	Write any defined generators.
 *
 **************************************/
	isc_req_handle req_handle1 = 0;
	TEXT temp[GDS_NAME_LEN];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$GENERATORS
			WITH X.RDB$SYSTEM_FLAG NE 1*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_401), (char*) isc_401);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 407, &isc_402, (short) 0);
		   if (!isc_402.isc_406 || isc_status [1]) break;
			put(tdgbl, rec_generator);
			const SSHORT l = PUT_TEXT (att_gen_generator, /*X.RDB$GENERATOR_NAME*/
								      isc_402.isc_412);
			SINT64 value = 0;
			if (!tdgbl->gbl_sw_meta)
			{
				value = get_gen_id (/*X.RDB$GENERATOR_NAME*/
						    isc_402.isc_412, l);
				put_int64 (att_gen_value_int64, value);
			}
			if (!/*X.RDB$DESCRIPTION.NULL*/
			     isc_402.isc_411) {
				put_source_blob (att_gen_description, att_gen_description, /*X.RDB$DESCRIPTION*/
											   isc_402.isc_404);
			}

			if (/*X.RDB$SYSTEM_FLAG*/
			    isc_402.isc_410)
				put_int32(att_gen_sysflag, /*X.RDB$SYSTEM_FLAG*/
							   isc_402.isc_410);

			if (!/*X.RDB$SECURITY_CLASS.NULL*/
			     isc_402.isc_409)
				PUT_TEXT(att_gen_security_class, /*X.RDB$SECURITY_CLASS*/
								 isc_402.isc_413);
			if (!/*X.RDB$OWNER_NAME.NULL*/
			     isc_402.isc_408)
				PUT_TEXT(att_gen_owner_name, /*X.RDB$OWNER_NAME*/
							     isc_402.isc_414);
			if (!/*X.RDB$INITIAL_VALUE.NULL*/
			     isc_402.isc_407)
				put_int64(att_gen_init_val, /*X.RDB$INITIAL_VALUE*/
							    isc_402.isc_403);

			put_int32(att_gen_id_increment, /*X.RDB$GENERATOR_INCREMENT*/
							isc_402.isc_405);

			put(tdgbl, att_end);
			MISC_terminate (/*X.RDB$GENERATOR_NAME*/
					isc_402.isc_412, temp, l, sizeof(temp));
			BURP_verbose (165, SafeArg() << temp << value);
			// msg 165 writing generator %s value %ld
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else if (tdgbl->runtimeODS >= DB_VERSION_DDL11)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$GENERATORS
			WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_395), (char*) isc_395);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 137, &isc_396, (short) 0);
		   if (!isc_396.isc_398 || isc_status [1]) break;
			put(tdgbl, rec_generator);
			const SSHORT l = PUT_TEXT (att_gen_generator, /*X.RDB$GENERATOR_NAME*/
								      isc_396.isc_400);
			SINT64 value = 0;
			if (!tdgbl->gbl_sw_meta)
			{
				value = get_gen_id (/*X.RDB$GENERATOR_NAME*/
						    isc_396.isc_400, l);
				put_int64 (att_gen_value_int64, value);
			}
			if (!/*X.RDB$DESCRIPTION.NULL*/
			     isc_396.isc_399) {
				put_source_blob (att_gen_description, att_gen_description, /*X.RDB$DESCRIPTION*/
											   isc_396.isc_397);
			}
			put(tdgbl, att_end);
			MISC_terminate (/*X.RDB$GENERATOR_NAME*/
					isc_396.isc_400, temp, l, sizeof(temp));
			BURP_verbose (165, SafeArg() << temp << value);
			// msg 165 writing generator %s value %ld
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$GENERATORS
			WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_391), (char*) isc_391);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 127, &isc_392, (short) 0);
		   if (!isc_392.isc_393 || isc_status [1]) break;
			put(tdgbl, rec_generator);
			const SSHORT l = PUT_TEXT (att_gen_generator, /*X.RDB$GENERATOR_NAME*/
								      isc_392.isc_394);
			SINT64 value = 0;
			if (!tdgbl->gbl_sw_meta)
			{
				value = get_gen_id (/*X.RDB$GENERATOR_NAME*/
						    isc_392.isc_394, l);
				put_int64 (att_gen_value_int64, value);
			}
			put(tdgbl, att_end);
			MISC_terminate (/*X.RDB$GENERATOR_NAME*/
					isc_392.isc_394, temp, l, sizeof(temp));
			BURP_verbose (165, SafeArg() << temp << value);
			// msg 165 writing generator %s value %ld
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}


void write_global_fields()
{
   struct isc_270_struct {
          ISC_QUAD isc_271;	/* RDB$MISSING_SOURCE */
          ISC_QUAD isc_272;	/* RDB$DEFAULT_SOURCE */
          ISC_QUAD isc_273;	/* RDB$DESCRIPTION */
          ISC_QUAD isc_274;	/* RDB$COMPUTED_SOURCE */
          ISC_QUAD isc_275;	/* RDB$COMPUTED_BLR */
          ISC_QUAD isc_276;	/* RDB$VALIDATION_SOURCE */
          ISC_QUAD isc_277;	/* RDB$VALIDATION_BLR */
          ISC_QUAD isc_278;	/* RDB$DEFAULT_VALUE */
          ISC_QUAD isc_279;	/* RDB$MISSING_VALUE */
          ISC_QUAD isc_280;	/* RDB$QUERY_HEADER */
          char  isc_281 [128];	/* RDB$EDIT_STRING */
          short isc_282;	/* isc_utility */
          short isc_283;	/* gds__null_flag */
          short isc_284;	/* RDB$COLLATION_ID */
          short isc_285;	/* gds__null_flag */
          short isc_286;	/* RDB$CHARACTER_SET_ID */
          short isc_287;	/* gds__null_flag */
          short isc_288;	/* gds__null_flag */
          short isc_289;	/* gds__null_flag */
          short isc_290;	/* RDB$CHARACTER_LENGTH */
          short isc_291;	/* gds__null_flag */
          short isc_292;	/* RDB$NULL_FLAG */
          short isc_293;	/* RDB$DIMENSIONS */
          short isc_294;	/* RDB$EXTERNAL_SCALE */
          short isc_295;	/* RDB$EXTERNAL_TYPE */
          short isc_296;	/* RDB$EXTERNAL_LENGTH */
          short isc_297;	/* RDB$SYSTEM_FLAG */
          short isc_298;	/* RDB$SEGMENT_LENGTH */
          short isc_299;	/* RDB$FIELD_SCALE */
          short isc_300;	/* RDB$FIELD_SUB_TYPE */
          short isc_301;	/* RDB$FIELD_LENGTH */
          short isc_302;	/* RDB$FIELD_TYPE */
          short isc_303;	/* gds__null_flag */
          short isc_304;	/* gds__null_flag */
          char  isc_305 [125];	/* RDB$FIELD_NAME */
          char  isc_306 [125];	/* RDB$QUERY_NAME */
   } isc_270;
   struct isc_308_struct {
          ISC_QUAD isc_309;	/* RDB$MISSING_SOURCE */
          ISC_QUAD isc_310;	/* RDB$DEFAULT_SOURCE */
          ISC_QUAD isc_311;	/* RDB$DESCRIPTION */
          ISC_QUAD isc_312;	/* RDB$COMPUTED_SOURCE */
          ISC_QUAD isc_313;	/* RDB$COMPUTED_BLR */
          ISC_QUAD isc_314;	/* RDB$VALIDATION_SOURCE */
          ISC_QUAD isc_315;	/* RDB$VALIDATION_BLR */
          ISC_QUAD isc_316;	/* RDB$DEFAULT_VALUE */
          ISC_QUAD isc_317;	/* RDB$MISSING_VALUE */
          ISC_QUAD isc_318;	/* RDB$QUERY_HEADER */
          char  isc_319 [128];	/* RDB$EDIT_STRING */
          short isc_320;	/* isc_utility */
          short isc_321;	/* gds__null_flag */
          short isc_322;	/* RDB$FIELD_PRECISION */
          short isc_323;	/* gds__null_flag */
          short isc_324;	/* RDB$COLLATION_ID */
          short isc_325;	/* gds__null_flag */
          short isc_326;	/* RDB$CHARACTER_SET_ID */
          short isc_327;	/* gds__null_flag */
          short isc_328;	/* gds__null_flag */
          short isc_329;	/* gds__null_flag */
          short isc_330;	/* RDB$CHARACTER_LENGTH */
          short isc_331;	/* gds__null_flag */
          short isc_332;	/* RDB$NULL_FLAG */
          short isc_333;	/* RDB$DIMENSIONS */
          short isc_334;	/* RDB$EXTERNAL_SCALE */
          short isc_335;	/* RDB$EXTERNAL_TYPE */
          short isc_336;	/* RDB$EXTERNAL_LENGTH */
          short isc_337;	/* RDB$SYSTEM_FLAG */
          short isc_338;	/* RDB$SEGMENT_LENGTH */
          short isc_339;	/* RDB$FIELD_SCALE */
          short isc_340;	/* RDB$FIELD_SUB_TYPE */
          short isc_341;	/* RDB$FIELD_LENGTH */
          short isc_342;	/* RDB$FIELD_TYPE */
          short isc_343;	/* gds__null_flag */
          short isc_344;	/* gds__null_flag */
          char  isc_345 [125];	/* RDB$FIELD_NAME */
          char  isc_346 [125];	/* RDB$QUERY_NAME */
   } isc_308;
   struct isc_348_struct {
          ISC_QUAD isc_349;	/* RDB$MISSING_SOURCE */
          ISC_QUAD isc_350;	/* RDB$DEFAULT_SOURCE */
          ISC_QUAD isc_351;	/* RDB$DESCRIPTION */
          ISC_QUAD isc_352;	/* RDB$COMPUTED_SOURCE */
          ISC_QUAD isc_353;	/* RDB$COMPUTED_BLR */
          ISC_QUAD isc_354;	/* RDB$VALIDATION_SOURCE */
          ISC_QUAD isc_355;	/* RDB$VALIDATION_BLR */
          ISC_QUAD isc_356;	/* RDB$DEFAULT_VALUE */
          ISC_QUAD isc_357;	/* RDB$MISSING_VALUE */
          ISC_QUAD isc_358;	/* RDB$QUERY_HEADER */
          char  isc_359 [128];	/* RDB$EDIT_STRING */
          short isc_360;	/* isc_utility */
          short isc_361;	/* gds__null_flag */
          short isc_362;	/* gds__null_flag */
          short isc_363;	/* gds__null_flag */
          short isc_364;	/* RDB$FIELD_PRECISION */
          short isc_365;	/* gds__null_flag */
          short isc_366;	/* RDB$COLLATION_ID */
          short isc_367;	/* gds__null_flag */
          short isc_368;	/* RDB$CHARACTER_SET_ID */
          short isc_369;	/* gds__null_flag */
          short isc_370;	/* gds__null_flag */
          short isc_371;	/* gds__null_flag */
          short isc_372;	/* RDB$CHARACTER_LENGTH */
          short isc_373;	/* gds__null_flag */
          short isc_374;	/* RDB$NULL_FLAG */
          short isc_375;	/* RDB$DIMENSIONS */
          short isc_376;	/* RDB$EXTERNAL_SCALE */
          short isc_377;	/* RDB$EXTERNAL_TYPE */
          short isc_378;	/* RDB$EXTERNAL_LENGTH */
          short isc_379;	/* RDB$SYSTEM_FLAG */
          short isc_380;	/* RDB$SEGMENT_LENGTH */
          short isc_381;	/* RDB$FIELD_SCALE */
          short isc_382;	/* RDB$FIELD_SUB_TYPE */
          short isc_383;	/* RDB$FIELD_LENGTH */
          short isc_384;	/* RDB$FIELD_TYPE */
          short isc_385;	/* gds__null_flag */
          short isc_386;	/* gds__null_flag */
          char  isc_387 [125];	/* RDB$FIELD_NAME */
          char  isc_388 [125];	/* RDB$QUERY_NAME */
          char  isc_389 [125];	/* RDB$SECURITY_CLASS */
          char  isc_390 [125];	/* RDB$OWNER_NAME */
   } isc_348;
/**************************************
 *
 *	w r i t e _ g l o b a l _ f i e l d s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each global field.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// if we have all capabilities, use the first request to get the
	// most performance out of the latest engine; if we don't
	// have one of the capabilities we must use the second set of
	// requests--this requires more code but it is well worth it
	// for the performance benefits, especially remotely--deej

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$FIELDS WITH
			X.RDB$SYSTEM_FLAG NE 1*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_347), (char*) isc_347);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 762, &isc_348, (short) 0);
		   if (!isc_348.isc_360 || isc_status [1]) break;

			put(tdgbl, rec_global_field);
			const SSHORT l = PUT_TEXT (att_field_name, /*X.RDB$FIELD_NAME*/
								   isc_348.isc_387);
			MISC_terminate (/*X.RDB$FIELD_NAME*/
					isc_348.isc_387, temp, l, sizeof(temp));
			BURP_verbose (149, temp);
			// msg 149  writing global field %.*s
			if (!/*X.RDB$QUERY_NAME.NULL*/
			     isc_348.isc_386 && /*X.RDB$QUERY_NAME*/
    isc_348.isc_388 [0] != ' ')
				PUT_TEXT (att_field_query_name, /*X.RDB$QUERY_NAME*/
								isc_348.isc_388);
			if (!/*X.RDB$EDIT_STRING.NULL*/
			     isc_348.isc_385 && /*X.RDB$EDIT_STRING*/
    isc_348.isc_359 [0] != ' ')
				PUT_TEXT (att_field_edit_string, /*X.RDB$EDIT_STRING*/
								 isc_348.isc_359);
			put_source_blob (att_field_query_header, att_field_query_header, /*X.RDB$QUERY_HEADER*/
											 isc_348.isc_358);
			put_int32 (att_field_type, /*X.RDB$FIELD_TYPE*/
						   isc_348.isc_384);
			put_int32 (att_field_length, /*X.RDB$FIELD_LENGTH*/
						     isc_348.isc_383);
			put_int32 (att_field_sub_type, /*X.RDB$FIELD_SUB_TYPE*/
						       isc_348.isc_382);
			put_int32 (att_field_scale, /*X.RDB$FIELD_SCALE*/
						    isc_348.isc_381);
			put_blr_blob (att_field_missing_value, /*X.RDB$MISSING_VALUE*/
							       isc_348.isc_357);
			put_blr_blob (att_field_default_value, /*X.RDB$DEFAULT_VALUE*/
							       isc_348.isc_356);
			put_blr_blob (att_field_validation_blr, /*X.RDB$VALIDATION_BLR*/
								isc_348.isc_355);
			put_source_blob(att_field_validation_source2, att_field_validation_source,
							/*X.RDB$VALIDATION_SOURCE*/
							isc_348.isc_354);
			put_blr_blob (att_field_computed_blr, /*X.RDB$COMPUTED_BLR*/
							      isc_348.isc_353);
			put_source_blob(att_field_computed_source2, att_field_computed_source,
							/*X.RDB$COMPUTED_SOURCE*/
							isc_348.isc_352);
			if (/*X.RDB$SEGMENT_LENGTH*/
			    isc_348.isc_380)
				put_int32 (att_field_segment_length, /*X.RDB$SEGMENT_LENGTH*/
								     isc_348.isc_380);
			if (/*X.RDB$SYSTEM_FLAG*/
			    isc_348.isc_379)
				put_int32 (att_field_system_flag, /*X.RDB$SYSTEM_FLAG*/
								  isc_348.isc_379);
			put_source_blob (att_field_description2, att_field_description, /*X.RDB$DESCRIPTION*/
											isc_348.isc_351);

			if (/*X.RDB$EXTERNAL_LENGTH*/
			    isc_348.isc_378)
				put_int32 (att_field_external_length, /*X.RDB$EXTERNAL_LENGTH*/
								      isc_348.isc_378);
			if (/*X.RDB$EXTERNAL_TYPE*/
			    isc_348.isc_377)
				put_int32 (att_field_external_type, /*X.RDB$EXTERNAL_TYPE*/
								    isc_348.isc_377);
			if (/*X.RDB$EXTERNAL_SCALE*/
			    isc_348.isc_376)
				put_int32 (att_field_external_scale, /*X.RDB$EXTERNAL_SCALE*/
								     isc_348.isc_376);
			if (/*X.RDB$DIMENSIONS*/
			    isc_348.isc_375)
				put_int32 (att_field_dimensions, /*X.RDB$DIMENSIONS*/
								 isc_348.isc_375);
			if (!/*X.RDB$NULL_FLAG.NULL*/
			     isc_348.isc_373)
				put_int32 (att_field_null_flag, /*X.RDB$NULL_FLAG*/
								isc_348.isc_374);
			if (!/*X.RDB$CHARACTER_LENGTH.NULL*/
			     isc_348.isc_371)
				put_int32 (att_field_character_length, /*X.RDB$CHARACTER_LENGTH*/
								       isc_348.isc_372);
			if (!/*X.RDB$DEFAULT_SOURCE.NULL*/
			     isc_348.isc_370)
				put_source_blob(att_field_default_source, att_field_default_source,
								/*X.RDB$DEFAULT_SOURCE*/
								isc_348.isc_350);
			if (!/*X.RDB$MISSING_SOURCE.NULL*/
			     isc_348.isc_369)
				put_source_blob(att_field_missing_source, att_field_missing_source,
								/*X.RDB$MISSING_SOURCE*/
								isc_348.isc_349);
			if (!/*X.RDB$CHARACTER_SET_ID.NULL*/
			     isc_348.isc_367)
				put_int32 (att_field_character_set, /*X.RDB$CHARACTER_SET_ID*/
								    isc_348.isc_368);
			if (!/*X.RDB$COLLATION_ID.NULL*/
			     isc_348.isc_365)
				put_int32 (att_field_collation_id, /*X.RDB$COLLATION_ID*/
								   isc_348.isc_366);
			if (!/*X.RDB$FIELD_PRECISION.NULL*/
			     isc_348.isc_363)
				put_int32 (att_field_precision, /*X.RDB$FIELD_PRECISION*/
								isc_348.isc_364);

			if (!/*X.RDB$SECURITY_CLASS.NULL*/
			     isc_348.isc_362)
				PUT_TEXT(att_field_security_class, /*X.RDB$SECURITY_CLASS*/
								   isc_348.isc_389);
			if (!/*X.RDB$OWNER_NAME.NULL*/
			     isc_348.isc_361)
				PUT_TEXT(att_field_owner_name, /*X.RDB$OWNER_NAME*/
							       isc_348.isc_390);

			put(tdgbl, att_end);

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else if (tdgbl->runtimeODS >= DB_VERSION_DDL10)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$FIELDS WITH
			X.RDB$SYSTEM_FLAG NE 1 OR
			X.RDB$SYSTEM_FLAG MISSING*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_307), (char*) isc_307);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 508, &isc_308, (short) 0);
		   if (!isc_308.isc_320 || isc_status [1]) break;

			put(tdgbl, rec_global_field);
			const SSHORT l = PUT_TEXT (att_field_name, /*X.RDB$FIELD_NAME*/
								   isc_308.isc_345);
			MISC_terminate (/*X.RDB$FIELD_NAME*/
					isc_308.isc_345, temp, l, sizeof(temp));
			BURP_verbose (149, temp);
			// msg 149  writing global field %.*s
			if (!/*X.RDB$QUERY_NAME.NULL*/
			     isc_308.isc_344 && /*X.RDB$QUERY_NAME*/
    isc_308.isc_346 [0] != ' ')
				PUT_TEXT (att_field_query_name, /*X.RDB$QUERY_NAME*/
								isc_308.isc_346);
			if (!/*X.RDB$EDIT_STRING.NULL*/
			     isc_308.isc_343 && /*X.RDB$EDIT_STRING*/
    isc_308.isc_319 [0] != ' ')
				PUT_TEXT (att_field_edit_string, /*X.RDB$EDIT_STRING*/
								 isc_308.isc_319);
			put_source_blob (att_field_query_header, att_field_query_header, /*X.RDB$QUERY_HEADER*/
											 isc_308.isc_318);
			put_int32 (att_field_type, /*X.RDB$FIELD_TYPE*/
						   isc_308.isc_342);
			put_int32 (att_field_length, /*X.RDB$FIELD_LENGTH*/
						     isc_308.isc_341);
			put_int32 (att_field_sub_type, /*X.RDB$FIELD_SUB_TYPE*/
						       isc_308.isc_340);
			put_int32 (att_field_scale, /*X.RDB$FIELD_SCALE*/
						    isc_308.isc_339);
			put_blr_blob (att_field_missing_value, /*X.RDB$MISSING_VALUE*/
							       isc_308.isc_317);
			put_blr_blob (att_field_default_value, /*X.RDB$DEFAULT_VALUE*/
							       isc_308.isc_316);
			put_blr_blob (att_field_validation_blr, /*X.RDB$VALIDATION_BLR*/
								isc_308.isc_315);
			put_source_blob(att_field_validation_source2, att_field_validation_source,
							/*X.RDB$VALIDATION_SOURCE*/
							isc_308.isc_314);
			put_blr_blob (att_field_computed_blr, /*X.RDB$COMPUTED_BLR*/
							      isc_308.isc_313);
			put_source_blob(att_field_computed_source2, att_field_computed_source,
							/*X.RDB$COMPUTED_SOURCE*/
							isc_308.isc_312);
			if (/*X.RDB$SEGMENT_LENGTH*/
			    isc_308.isc_338)
				put_int32 (att_field_segment_length, /*X.RDB$SEGMENT_LENGTH*/
								     isc_308.isc_338);
			if (/*X.RDB$SYSTEM_FLAG*/
			    isc_308.isc_337)
				put_int32 (att_field_system_flag, /*X.RDB$SYSTEM_FLAG*/
								  isc_308.isc_337);
			put_source_blob (att_field_description2, att_field_description, /*X.RDB$DESCRIPTION*/
											isc_308.isc_311);

			if (/*X.RDB$EXTERNAL_LENGTH*/
			    isc_308.isc_336)
				put_int32 (att_field_external_length, /*X.RDB$EXTERNAL_LENGTH*/
								      isc_308.isc_336);
			if (/*X.RDB$EXTERNAL_TYPE*/
			    isc_308.isc_335)
				put_int32 (att_field_external_type, /*X.RDB$EXTERNAL_TYPE*/
								    isc_308.isc_335);
			if (/*X.RDB$EXTERNAL_SCALE*/
			    isc_308.isc_334)
				put_int32 (att_field_external_scale, /*X.RDB$EXTERNAL_SCALE*/
								     isc_308.isc_334);
			if (/*X.RDB$DIMENSIONS*/
			    isc_308.isc_333)
				put_int32 (att_field_dimensions, /*X.RDB$DIMENSIONS*/
								 isc_308.isc_333);
			if (!/*X.RDB$NULL_FLAG.NULL*/
			     isc_308.isc_331)
				put_int32 (att_field_null_flag, /*X.RDB$NULL_FLAG*/
								isc_308.isc_332);
			if (!/*X.RDB$CHARACTER_LENGTH.NULL*/
			     isc_308.isc_329)
				put_int32 (att_field_character_length, /*X.RDB$CHARACTER_LENGTH*/
								       isc_308.isc_330);
			if (!/*X.RDB$DEFAULT_SOURCE.NULL*/
			     isc_308.isc_328)
				put_source_blob(att_field_default_source, att_field_default_source,
								/*X.RDB$DEFAULT_SOURCE*/
								isc_308.isc_310);
			if (!/*X.RDB$MISSING_SOURCE.NULL*/
			     isc_308.isc_327)
				put_source_blob(att_field_missing_source, att_field_missing_source,
								/*X.RDB$MISSING_SOURCE*/
								isc_308.isc_309);
			if (!/*X.RDB$CHARACTER_SET_ID.NULL*/
			     isc_308.isc_325)
				put_int32 (att_field_character_set, /*X.RDB$CHARACTER_SET_ID*/
								    isc_308.isc_326);
			if (!/*X.RDB$COLLATION_ID.NULL*/
			     isc_308.isc_323)
				put_int32 (att_field_collation_id, /*X.RDB$COLLATION_ID*/
								   isc_308.isc_324);

			if (!/*X.RDB$FIELD_PRECISION.NULL*/
			     isc_308.isc_321)
				put_int32 (att_field_precision, /*X.RDB$FIELD_PRECISION*/
								isc_308.isc_322);

			put(tdgbl, att_end);

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$FIELDS WITH
			X.RDB$SYSTEM_FLAG NE 1 OR
			X.RDB$SYSTEM_FLAG MISSING*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_269), (char*) isc_269);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 504, &isc_270, (short) 0);
		   if (!isc_270.isc_282 || isc_status [1]) break;

			put(tdgbl, rec_global_field);
			const SSHORT l = PUT_TEXT (att_field_name, /*X.RDB$FIELD_NAME*/
								   isc_270.isc_305);
			MISC_terminate (/*X.RDB$FIELD_NAME*/
					isc_270.isc_305, temp, l, sizeof(temp));
			BURP_verbose (149, temp);
			// msg 149  writing global field %.*s
			if (!/*X.RDB$QUERY_NAME.NULL*/
			     isc_270.isc_304 && /*X.RDB$QUERY_NAME*/
    isc_270.isc_306 [0] != ' ')
				PUT_TEXT (att_field_query_name, /*X.RDB$QUERY_NAME*/
								isc_270.isc_306);
			if (!/*X.RDB$EDIT_STRING.NULL*/
			     isc_270.isc_303 && /*X.RDB$EDIT_STRING*/
    isc_270.isc_281 [0] != ' ')
				PUT_TEXT (att_field_edit_string, /*X.RDB$EDIT_STRING*/
								 isc_270.isc_281);
			put_source_blob (att_field_query_header, att_field_query_header, /*X.RDB$QUERY_HEADER*/
											 isc_270.isc_280);
			put_int32 (att_field_type, /*X.RDB$FIELD_TYPE*/
						   isc_270.isc_302);
			put_int32 (att_field_length, /*X.RDB$FIELD_LENGTH*/
						     isc_270.isc_301);
			put_int32 (att_field_sub_type, /*X.RDB$FIELD_SUB_TYPE*/
						       isc_270.isc_300);
			put_int32 (att_field_scale, /*X.RDB$FIELD_SCALE*/
						    isc_270.isc_299);
			put_blr_blob (att_field_missing_value, /*X.RDB$MISSING_VALUE*/
							       isc_270.isc_279);
			put_blr_blob (att_field_default_value, /*X.RDB$DEFAULT_VALUE*/
							       isc_270.isc_278);
			put_blr_blob (att_field_validation_blr, /*X.RDB$VALIDATION_BLR*/
								isc_270.isc_277);
			put_source_blob(att_field_validation_source2, att_field_validation_source,
							/*X.RDB$VALIDATION_SOURCE*/
							isc_270.isc_276);
			put_blr_blob (att_field_computed_blr, /*X.RDB$COMPUTED_BLR*/
							      isc_270.isc_275);
			put_source_blob (att_field_computed_source2, att_field_computed_source,
				/*X.RDB$COMPUTED_SOURCE*/
				isc_270.isc_274);
			if (/*X.RDB$SEGMENT_LENGTH*/
			    isc_270.isc_298)
				put_int32 (att_field_segment_length, /*X.RDB$SEGMENT_LENGTH*/
								     isc_270.isc_298);
			if (/*X.RDB$SYSTEM_FLAG*/
			    isc_270.isc_297)
				put_int32 (att_field_system_flag, /*X.RDB$SYSTEM_FLAG*/
								  isc_270.isc_297);
			put_source_blob (att_field_description2, att_field_description, /*X.RDB$DESCRIPTION*/
											isc_270.isc_273);
			if (/*X.RDB$EXTERNAL_LENGTH*/
			    isc_270.isc_296)
				put_int32 (att_field_external_length, /*X.RDB$EXTERNAL_LENGTH*/
								      isc_270.isc_296);
			if (/*X.RDB$EXTERNAL_TYPE*/
			    isc_270.isc_295)
				put_int32 (att_field_external_type, /*X.RDB$EXTERNAL_TYPE*/
								    isc_270.isc_295);
			if (/*X.RDB$EXTERNAL_SCALE*/
			    isc_270.isc_294)
				put_int32 (att_field_external_scale, /*X.RDB$EXTERNAL_SCALE*/
								     isc_270.isc_294);
			if (/*X.RDB$DIMENSIONS*/
			    isc_270.isc_293)
				put_int32 (att_field_dimensions, /*X.RDB$DIMENSIONS*/
								 isc_270.isc_293);
			if (!/*X.RDB$NULL_FLAG.NULL*/
			     isc_270.isc_291)
				put_int32 (att_field_null_flag, /*X.RDB$NULL_FLAG*/
								isc_270.isc_292);
			if (!/*X.RDB$CHARACTER_LENGTH.NULL*/
			     isc_270.isc_289)
				put_int32 (att_field_character_length, /*X.RDB$CHARACTER_LENGTH*/
								       isc_270.isc_290);
			if (!/*X.RDB$DEFAULT_SOURCE.NULL*/
			     isc_270.isc_288)
				put_source_blob(att_field_default_source, att_field_default_source,
								/*X.RDB$DEFAULT_SOURCE*/
								isc_270.isc_272);
			if (!/*X.RDB$MISSING_SOURCE.NULL*/
			     isc_270.isc_287)
				put_source_blob(att_field_missing_source, att_field_missing_source,
								/*X.RDB$MISSING_SOURCE*/
								isc_270.isc_271);
			if (!/*X.RDB$CHARACTER_SET_ID.NULL*/
			     isc_270.isc_285)
				put_int32 (att_field_character_set, /*X.RDB$CHARACTER_SET_ID*/
								    isc_270.isc_286);
			if (!/*X.RDB$COLLATION_ID.NULL*/
			     isc_270.isc_283)
				put_int32 (att_field_collation_id, /*X.RDB$COLLATION_ID*/
								   isc_270.isc_284);

			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}


void write_packages()
{
   struct isc_254_struct {
          ISC_QUAD isc_255;	/* RDB$DESCRIPTION */
          ISC_QUAD isc_256;	/* RDB$PACKAGE_BODY_SOURCE */
          ISC_QUAD isc_257;	/* RDB$PACKAGE_HEADER_SOURCE */
          short isc_258;	/* isc_utility */
          short isc_259;	/* gds__null_flag */
          short isc_260;	/* gds__null_flag */
          short isc_261;	/* gds__null_flag */
          short isc_262;	/* gds__null_flag */
          short isc_263;	/* RDB$VALID_BODY_FLAG */
          short isc_264;	/* gds__null_flag */
          short isc_265;	/* gds__null_flag */
          char  isc_266 [125];	/* RDB$PACKAGE_NAME */
          char  isc_267 [125];	/* RDB$SECURITY_CLASS */
          char  isc_268 [125];	/* RDB$OWNER_NAME */
   } isc_254;
/**************************************
 *
 *	w r i t e _ p a c k a g e s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each package.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// This code is for DDL12 onwards, so no need to check for null sysflag.
	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$PACKAGES
		WITH X.RDB$SYSTEM_FLAG NE 1*/
	{
	if (!req_handle1)
	   {
	   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_253), (char*) isc_253);
	   }
	if (req_handle1)
	   {
	   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	   }
	if (!isc_status [1]) {
	while (1)
	   {
	   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 415, &isc_254, (short) 0);
	   if (!isc_254.isc_258 || isc_status [1]) break;
	{
		put(tdgbl, rec_package);
		const SSHORT l = PUT_TEXT(att_package_name, /*X.RDB$PACKAGE_NAME*/
							    isc_254.isc_266);
		MISC_terminate(/*X.RDB$PACKAGE_NAME*/
			       isc_254.isc_266, temp, l, sizeof(temp));

		BURP_verbose(335, temp);	// msg 335 writing package @1

		if (!/*X.RDB$PACKAGE_HEADER_SOURCE.NULL*/
		     isc_254.isc_265)
		{
			put_source_blob(att_package_header_source, att_package_header_source,
				/*X.RDB$PACKAGE_HEADER_SOURCE*/
				isc_254.isc_257);
		}

		if (!/*X.RDB$PACKAGE_BODY_SOURCE.NULL*/
		     isc_254.isc_264)
		{
			put_source_blob(att_package_body_source, att_package_body_source,
				/*X.RDB$PACKAGE_BODY_SOURCE*/
				isc_254.isc_256);
		}

		if (!/*X.RDB$VALID_BODY_FLAG.NULL*/
		     isc_254.isc_262)
			put_int32(att_package_valid_body_flag, /*X.RDB$VALID_BODY_FLAG*/
							       isc_254.isc_263);

		if (!/*X.RDB$SECURITY_CLASS.NULL*/
		     isc_254.isc_261)
			PUT_TEXT(att_package_security_class, /*X.RDB$SECURITY_CLASS*/
							     isc_254.isc_267);
		if (!/*X.RDB$OWNER_NAME.NULL*/
		     isc_254.isc_260)
			PUT_TEXT(att_package_owner_name, /*X.RDB$OWNER_NAME*/
							 isc_254.isc_268);

		if (!/*X.RDB$DESCRIPTION.NULL*/
		     isc_254.isc_259)
			put_source_blob(att_package_description, att_package_description, /*X.RDB$DESCRIPTION*/
											  isc_254.isc_255);

		put(tdgbl, att_end);
	}
	/*END_FOR*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_procedures()
{
   struct isc_214_struct {
          ISC_QUAD isc_215;	/* RDB$PROCEDURE_BLR */
          ISC_QUAD isc_216;	/* RDB$PROCEDURE_SOURCE */
          ISC_QUAD isc_217;	/* RDB$DESCRIPTION */
          short isc_218;	/* isc_utility */
          short isc_219;	/* gds__null_flag */
          short isc_220;	/* RDB$PROCEDURE_OUTPUTS */
          short isc_221;	/* RDB$PROCEDURE_INPUTS */
          char  isc_222 [125];	/* RDB$PROCEDURE_NAME */
          char  isc_223 [125];	/* RDB$SECURITY_CLASS */
          char  isc_224 [125];	/* RDB$OWNER_NAME */
   } isc_214;
   struct isc_226_struct {
          char  isc_227 [256];	/* RDB$ENTRYPOINT */
          ISC_QUAD isc_228;	/* RDB$DEBUG_INFO */
          ISC_QUAD isc_229;	/* RDB$PROCEDURE_BLR */
          ISC_QUAD isc_230;	/* RDB$PROCEDURE_SOURCE */
          ISC_QUAD isc_231;	/* RDB$DESCRIPTION */
          short isc_232;	/* isc_utility */
          short isc_233;	/* gds__null_flag */
          short isc_234;	/* RDB$PRIVATE_FLAG */
          short isc_235;	/* gds__null_flag */
          short isc_236;	/* gds__null_flag */
          short isc_237;	/* gds__null_flag */
          short isc_238;	/* gds__null_flag */
          short isc_239;	/* RDB$VALID_BLR */
          short isc_240;	/* gds__null_flag */
          short isc_241;	/* RDB$PROCEDURE_TYPE */
          short isc_242;	/* gds__null_flag */
          short isc_243;	/* gds__null_flag */
          short isc_244;	/* gds__null_flag */
          short isc_245;	/* RDB$PROCEDURE_OUTPUTS */
          short isc_246;	/* RDB$PROCEDURE_INPUTS */
          short isc_247;	/* gds__null_flag */
          char  isc_248 [125];	/* RDB$PACKAGE_NAME */
          char  isc_249 [125];	/* RDB$PROCEDURE_NAME */
          char  isc_250 [125];	/* RDB$SECURITY_CLASS */
          char  isc_251 [125];	/* RDB$OWNER_NAME */
          char  isc_252 [125];	/* RDB$ENGINE_NAME */
   } isc_226;
/**************************************
 *
 *	w r i t e _ p r o c e d u r e s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each stored procedure.
 *
 **************************************/
	GDS_NAME proc;
	TEXT temp[GDS_NAME_LEN * 2];
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	if (tdgbl->runtimeODS >= DB_VERSION_DDL11_1)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$PROCEDURES
			WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_225), (char*) isc_225);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 945, &isc_226, (short) 0);
		   if (!isc_226.isc_232 || isc_status [1]) break;
			put(tdgbl, rec_procedure);

			SSHORT prefixLen = 0;

			if (!/*X.RDB$PACKAGE_NAME.NULL*/
			     isc_226.isc_247)
			{
				prefixLen = PUT_TEXT(att_procedure_package_name, /*X.RDB$PACKAGE_NAME*/
										 isc_226.isc_248);
				MISC_terminate (/*X.RDB$PACKAGE_NAME*/
						isc_226.isc_248, temp, prefixLen, sizeof(temp));
				temp[prefixLen++] = '.';
			}

			const SSHORT len = PUT_TEXT (att_procedure_name, /*X.RDB$PROCEDURE_NAME*/
									 isc_226.isc_249);
			MISC_terminate (/*X.RDB$PROCEDURE_NAME*/
					isc_226.isc_249, temp + prefixLen, len, sizeof(temp) - prefixLen);

			BURP_verbose (193, temp);
			// msg 193 writing stored procedure %.*s
			put_int32 (att_procedure_inputs, /*X.RDB$PROCEDURE_INPUTS*/
							 isc_226.isc_246);
			put_int32 (att_procedure_outputs, /*X.RDB$PROCEDURE_OUTPUTS*/
							  isc_226.isc_245);
			put_source_blob(att_procedure_description2, att_procedure_description, /*X.RDB$DESCRIPTION*/
											       isc_226.isc_231);
			put_source_blob (att_procedure_source2, att_procedure_source, /*X.RDB$PROCEDURE_SOURCE*/
										      isc_226.isc_230);

			if (!/*X.RDB$PROCEDURE_BLR.NULL*/
			     isc_226.isc_244)
				put_blr_blob (att_procedure_blr, /*X.RDB$PROCEDURE_BLR*/
								 isc_226.isc_229);

			if (!/*X.RDB$SECURITY_CLASS.NULL*/
			     isc_226.isc_243)
				PUT_TEXT (att_procedure_security_class, /*X.RDB$SECURITY_CLASS*/
									isc_226.isc_250);
			if (!/*X.RDB$OWNER_NAME.NULL*/
			     isc_226.isc_242)
				PUT_TEXT (att_procedure_owner_name, /*X.RDB$OWNER_NAME*/
								    isc_226.isc_251);
			if (!/*X.RDB$PROCEDURE_TYPE.NULL*/
			     isc_226.isc_240)
				put_int32 (att_procedure_type, /*X.RDB$PROCEDURE_TYPE*/
							       isc_226.isc_241);
			if (!/*X.RDB$VALID_BLR.NULL*/
			     isc_226.isc_238)
				put_int32 (att_procedure_valid_blr, /*X.RDB$VALID_BLR*/
								    isc_226.isc_239);
			if (!/*X.RDB$DEBUG_INFO.NULL*/
			     isc_226.isc_237)
				put_blr_blob (att_procedure_debug_info, /*X.RDB$DEBUG_INFO*/
									isc_226.isc_228);

			if (!/*X.RDB$ENGINE_NAME.NULL*/
			     isc_226.isc_236)
				PUT_TEXT(att_procedure_engine_name, /*X.RDB$ENGINE_NAME*/
								    isc_226.isc_252);

			if (!/*X.RDB$ENTRYPOINT.NULL*/
			     isc_226.isc_235)
				PUT_TEXT(att_procedure_entrypoint, /*X.RDB$ENTRYPOINT*/
								   isc_226.isc_227);

			if (!/*X.RDB$PRIVATE_FLAG.NULL*/
			     isc_226.isc_233)
				put_int32(att_procedure_private_flag, /*X.RDB$PRIVATE_FLAG*/
								      isc_226.isc_234);

			put(tdgbl, att_end);
			COPY(/*X.RDB$PROCEDURE_NAME*/
			     isc_226.isc_249, proc);
			write_procedure_prms ((/*X.RDB$PACKAGE_NAME.NULL*/
					       isc_226.isc_247 ? "" : /*X.RDB$PACKAGE_NAME*/
	isc_226.isc_248), proc);
			put(tdgbl, rec_procedure_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$PROCEDURES
			WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_213), (char*) isc_213);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 407, &isc_214, (short) 0);
		   if (!isc_214.isc_218 || isc_status [1]) break;
			put(tdgbl, rec_procedure);
			const SSHORT l = PUT_TEXT (att_procedure_name, /*X.RDB$PROCEDURE_NAME*/
								       isc_214.isc_222);
			MISC_terminate (/*X.RDB$PROCEDURE_NAME*/
					isc_214.isc_222, temp, l, sizeof(temp));
			BURP_verbose (193, temp);
			// msg 193 writing stored procedure %.*s
			put_int32 (att_procedure_inputs, /*X.RDB$PROCEDURE_INPUTS*/
							 isc_214.isc_221);
			put_int32 (att_procedure_outputs, /*X.RDB$PROCEDURE_OUTPUTS*/
							  isc_214.isc_220);
			put_source_blob (att_procedure_description2, att_procedure_description, /*X.RDB$DESCRIPTION*/
												isc_214.isc_217);
			put_source_blob (att_procedure_source2, att_procedure_source, /*X.RDB$PROCEDURE_SOURCE*/
										      isc_214.isc_216);
			put_blr_blob (att_procedure_blr, /*X.RDB$PROCEDURE_BLR*/
							 isc_214.isc_215);
			if (!/*X.RDB$SECURITY_CLASS.NULL*/
			     isc_214.isc_219)
				PUT_TEXT (att_procedure_security_class, /*X.RDB$SECURITY_CLASS*/
									isc_214.isc_223);
			if (!/*X.RDB$SECURITY_CLASS.NULL*/
			     isc_214.isc_219)
				PUT_TEXT (att_procedure_owner_name, /*X.RDB$OWNER_NAME*/
								    isc_214.isc_224);
			put(tdgbl, att_end);
			COPY(/*X.RDB$PROCEDURE_NAME*/
			     isc_214.isc_222, proc);
			write_procedure_prms ("", proc);
			put(tdgbl, rec_procedure_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}


void write_procedure_prms(const GDS_NAME package, const GDS_NAME procptr)
{
   struct isc_183_struct {
          ISC_QUAD isc_184;	/* RDB$DESCRIPTION */
          short isc_185;	/* isc_utility */
          short isc_186;	/* RDB$PARAMETER_TYPE */
          short isc_187;	/* RDB$PARAMETER_NUMBER */
          char  isc_188 [125];	/* RDB$PARAMETER_NAME */
          char  isc_189 [125];	/* RDB$FIELD_SOURCE */
   } isc_183;
   struct isc_181_struct {
          char  isc_182 [125];	/* RDB$PROCEDURE_NAME */
   } isc_181;
   struct isc_194_struct {
          ISC_QUAD isc_195;	/* RDB$DEFAULT_SOURCE */
          ISC_QUAD isc_196;	/* RDB$DEFAULT_VALUE */
          ISC_QUAD isc_197;	/* RDB$DESCRIPTION */
          short isc_198;	/* isc_utility */
          short isc_199;	/* gds__null_flag */
          short isc_200;	/* gds__null_flag */
          short isc_201;	/* gds__null_flag */
          short isc_202;	/* RDB$PARAMETER_MECHANISM */
          short isc_203;	/* gds__null_flag */
          short isc_204;	/* RDB$NULL_FLAG */
          short isc_205;	/* gds__null_flag */
          short isc_206;	/* RDB$COLLATION_ID */
          short isc_207;	/* RDB$PARAMETER_TYPE */
          short isc_208;	/* RDB$PARAMETER_NUMBER */
          char  isc_209 [125];	/* RDB$PARAMETER_NAME */
          char  isc_210 [125];	/* RDB$FIELD_SOURCE */
          char  isc_211 [125];	/* RDB$FIELD_NAME */
          char  isc_212 [125];	/* RDB$RELATION_NAME */
   } isc_194;
   struct isc_191_struct {
          char  isc_192 [125];	/* RDB$PROCEDURE_NAME */
          char  isc_193 [125];	/* RDB$PACKAGE_NAME */
   } isc_191;
/**************************************
 *
 *	w r i t e _ p r o c e d u r e _ p r m s
 *
 **************************************
 *
 * Functional description
 * 	write all parameters of a stored procedure.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	if (tdgbl->runtimeODS >= DB_VERSION_DDL11_1)
	{
		/*FOR (REQUEST_HANDLE tdgbl->handles_write_procedure_prms_req_handle1)
			X IN RDB$PROCEDURE_PARAMETERS
			WITH X.RDB$PROCEDURE_NAME EQ procptr AND
				 X.RDB$PACKAGE_NAME EQUIV NULLIF(package, '')*/
		{
		if (!tdgbl->handles_write_procedure_prms_req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_write_procedure_prms_req_handle1, (short) sizeof(isc_190), (char*) isc_190);
		   }
		isc_vtov ((const char*) procptr, (char*) isc_191.isc_192, 125);
		isc_vtov ((const char*) package, (char*) isc_191.isc_193, 125);
		if (tdgbl->handles_write_procedure_prms_req_handle1)
		   {
		   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_write_procedure_prms_req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 250, &isc_191, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_write_procedure_prms_req_handle1, (short) 1, (short) 546, &isc_194, (short) 0);
		   if (!isc_194.isc_198 || isc_status [1]) break;
		{
			put(tdgbl, rec_procedure_prm);
			const SSHORT l = PUT_TEXT (att_procedureprm_name, /*X.RDB$PARAMETER_NAME*/
									  isc_194.isc_209);
			MISC_terminate (/*X.RDB$PARAMETER_NAME*/
					isc_194.isc_209, temp, l, sizeof(temp));
			BURP_verbose (194, temp);
			// msg 194 writing parameter %s for stored procedure
			put_int32 (att_procedureprm_number, /*X.RDB$PARAMETER_NUMBER*/
							    isc_194.isc_208);
			put_int32 (att_procedureprm_type, /*X.RDB$PARAMETER_type*/
							  isc_194.isc_207);
			PUT_TEXT (att_procedureprm_field_source, /*X.RDB$FIELD_SOURCE*/
								 isc_194.isc_210);
			put_source_blob(att_procedureprm_description2, att_procedureprm_description,
							/*X.RDB$DESCRIPTION*/
							isc_194.isc_197);
			put_blr_blob (att_procedureprm_default_value, /*X.RDB$DEFAULT_VALUE*/
								      isc_194.isc_196);
			put_source_blob(att_procedureprm_default_source, att_procedureprm_default_source,
							/*X.RDB$DEFAULT_SOURCE*/
							isc_194.isc_195);
			if (!/*X.RDB$COLLATION_ID.NULL*/
			     isc_194.isc_205)
				put_int32 (att_procedureprm_collation_id, /*X.RDB$COLLATION_ID*/
									  isc_194.isc_206);
			if (!/*X.RDB$NULL_FLAG.NULL*/
			     isc_194.isc_203)
				put_int32 (att_procedureprm_null_flag, /*X.RDB$NULL_FLAG*/
								       isc_194.isc_204);
			if (!/*X.RDB$PARAMETER_MECHANISM.NULL*/
			     isc_194.isc_201)
				put_int32 (att_procedureprm_mechanism, /*X.RDB$PARAMETER_MECHANISM*/
								       isc_194.isc_202);

			// DB_VERSION_DDL11_2
			if (!/*X.RDB$FIELD_NAME.NULL*/
			     isc_194.isc_200)
				PUT_TEXT(att_procedureprm_field_name, /*X.RDB$FIELD_NAME*/
								      isc_194.isc_211);
			if (!/*X.RDB$RELATION_NAME.NULL*/
			     isc_194.isc_199)
				PUT_TEXT(att_procedureprm_relation_name, /*X.RDB$RELATION_NAME*/
									 isc_194.isc_212);

			put(tdgbl, att_end);
		}
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE tdgbl->handles_write_procedure_prms_req_handle1)
			X IN RDB$PROCEDURE_PARAMETERS WITH X.RDB$PROCEDURE_NAME EQ procptr*/
		{
		if (!tdgbl->handles_write_procedure_prms_req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_write_procedure_prms_req_handle1, (short) sizeof(isc_180), (char*) isc_180);
		   }
		isc_vtov ((const char*) procptr, (char*) isc_181.isc_182, 125);
		if (tdgbl->handles_write_procedure_prms_req_handle1)
		   {
		   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_write_procedure_prms_req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_181, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_write_procedure_prms_req_handle1, (short) 1, (short) 264, &isc_183, (short) 0);
		   if (!isc_183.isc_185 || isc_status [1]) break;
			put(tdgbl, rec_procedure_prm);
			const SSHORT l = PUT_TEXT (att_procedureprm_name, /*X.RDB$PARAMETER_NAME*/
									  isc_183.isc_188);
			MISC_terminate (/*X.RDB$PARAMETER_NAME*/
					isc_183.isc_188, temp, l, sizeof(temp));
			BURP_verbose (194, temp);
			// msg 194 writing parameter %s for stored procedure
			put_int32 (att_procedureprm_number, /*X.RDB$PARAMETER_NUMBER*/
							    isc_183.isc_187);
			put_int32 (att_procedureprm_type, /*X.RDB$PARAMETER_type*/
							  isc_183.isc_186);
			PUT_TEXT (att_procedureprm_field_source, /*X.RDB$FIELD_SOURCE*/
								 isc_183.isc_189);
			put_source_blob(att_procedureprm_description2, att_procedureprm_description,
							/*X.RDB$DESCRIPTION*/
							isc_183.isc_184);
			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
}


void write_ref_constraints()
{
   struct isc_173_struct {
          char  isc_174 [8];	/* RDB$MATCH_OPTION */
          char  isc_175 [12];	/* RDB$DELETE_RULE */
          char  isc_176 [12];	/* RDB$UPDATE_RULE */
          short isc_177;	/* isc_utility */
          char  isc_178 [125];	/* RDB$CONSTRAINT_NAME */
          char  isc_179 [125];	/* RDB$CONST_NAME_UQ */
   } isc_173;
/**************************************
 *
 *	w r i t e _ r e f _ c o n s t r a i n t s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each referential constraint.
 *
 **************************************/
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$REF_CONSTRAINTS*/
	{
	if (!req_handle1)
	   {
	   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_172), (char*) isc_172);
	   }
	if (req_handle1)
	   {
	   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	   }
	if (!isc_status [1]) {
	while (1)
	   {
	   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 284, &isc_173, (short) 0);
	   if (!isc_173.isc_177 || isc_status [1]) break;
		put(tdgbl, rec_ref_constraint);
		PUT_TEXT (att_ref_constraint_name, /*X.RDB$CONSTRAINT_NAME*/
						   isc_173.isc_178);
		PUT_TEXT (att_ref_unique_const_name, /*X.RDB$CONST_NAME_UQ*/
						     isc_173.isc_179);
		PUT_TEXT (att_ref_match_option, /*X.RDB$MATCH_OPTION*/
						isc_173.isc_174);
		PUT_TEXT (att_ref_update_rule, /*X.RDB$UPDATE_RULE*/
					       isc_173.isc_176);
		PUT_TEXT (att_ref_delete_rule, /*X.RDB$DELETE_RULE*/
					       isc_173.isc_175);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_rel_constraints()
{
   struct isc_163_struct {
          char  isc_164 [4];	/* RDB$INITIALLY_DEFERRED */
          char  isc_165 [4];	/* RDB$DEFERRABLE */
          char  isc_166 [12];	/* RDB$CONSTRAINT_TYPE */
          short isc_167;	/* isc_utility */
          short isc_168;	/* gds__null_flag */
          char  isc_169 [125];	/* RDB$CONSTRAINT_NAME */
          char  isc_170 [125];	/* RDB$RELATION_NAME */
          char  isc_171 [125];	/* RDB$INDEX_NAME */
   } isc_163;
/**************************************
 *
 *	w r i t e _ r e l _ c o n s t r a i n t s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each relation constraint.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$RELATION_CONSTRAINTS CROSS
		REL IN RDB$RELATIONS
		WITH REL.RDB$RELATION_NAME EQ X.RDB$RELATION_NAME AND
			 (REL.RDB$SYSTEM_FLAG MISSING OR REL.RDB$SYSTEM_FLAG NE 1)*/
	{
	if (!req_handle1)
	   {
	   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_162), (char*) isc_162);
	   }
	if (req_handle1)
	   {
	   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	   }
	if (!isc_status [1]) {
	while (1)
	   {
	   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 399, &isc_163, (short) 0);
	   if (!isc_163.isc_167 || isc_status [1]) break;
		put(tdgbl, rec_rel_constraint);
		const SSHORT l = PUT_TEXT (att_rel_constraint_name, /*X.RDB$CONSTRAINT_NAME*/
								    isc_163.isc_169);
		MISC_terminate (/*X.RDB$CONSTRAINT_NAME*/
				isc_163.isc_169, temp, l, sizeof(temp));
		BURP_verbose (207, temp);
		// msg 207 writing constraint %s
		PUT_TEXT (att_rel_constraint_type, /*X.RDB$CONSTRAINT_TYPE*/
						   isc_163.isc_166);
		PUT_TEXT (att_rel_constraint_rel_name, /*X.RDB$RELATION_NAME*/
						       isc_163.isc_170);
		PUT_TEXT (att_rel_constraint_defer, /*X.RDB$DEFERRABLE*/
						    isc_163.isc_165);
		PUT_TEXT (att_rel_constraint_init, /*X.RDB$INITIALLY_DEFERRED*/
						   isc_163.isc_164);
		if (!/*X.RDB$INDEX_NAME.NULL*/
		     isc_163.isc_168)
			PUT_TEXT (att_rel_constraint_index, /*X.RDB$INDEX_NAME*/
							    isc_163.isc_171);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_relations()
{
   struct isc_126_struct {
          char  isc_127 [256];	/* RDB$EXTERNAL_FILE */
          ISC_QUAD isc_128;	/* RDB$EXTERNAL_DESCRIPTION */
          ISC_QUAD isc_129;	/* RDB$VIEW_SOURCE */
          ISC_QUAD isc_130;	/* RDB$DESCRIPTION */
          ISC_QUAD isc_131;	/* RDB$VIEW_BLR */
          short isc_132;	/* isc_utility */
          short isc_133;	/* RDB$RELATION_ID */
          short isc_134;	/* gds__null_flag */
          short isc_135;	/* gds__null_flag */
          short isc_136;	/* gds__null_flag */
          short isc_137;	/* RDB$FLAGS */
          short isc_138;	/* RDB$SYSTEM_FLAG */
          char  isc_139 [125];	/* RDB$RELATION_NAME */
          char  isc_140 [125];	/* RDB$SECURITY_CLASS */
          char  isc_141 [125];	/* RDB$OWNER_NAME */
   } isc_126;
   struct isc_143_struct {
          char  isc_144 [256];	/* RDB$EXTERNAL_FILE */
          ISC_QUAD isc_145;	/* RDB$EXTERNAL_DESCRIPTION */
          ISC_QUAD isc_146;	/* RDB$VIEW_SOURCE */
          ISC_QUAD isc_147;	/* RDB$DESCRIPTION */
          ISC_QUAD isc_148;	/* RDB$VIEW_BLR */
          short isc_149;	/* isc_utility */
          short isc_150;	/* RDB$RELATION_ID */
          short isc_151;	/* gds__null_flag */
          short isc_152;	/* RDB$RELATION_TYPE */
          short isc_153;	/* gds__null_flag */
          short isc_154;	/* gds__null_flag */
          short isc_155;	/* gds__null_flag */
          short isc_156;	/* RDB$FLAGS */
          short isc_157;	/* RDB$SYSTEM_FLAG */
          short isc_158;	/* gds__null_flag */
          char  isc_159 [125];	/* RDB$RELATION_NAME */
          char  isc_160 [125];	/* RDB$SECURITY_CLASS */
          char  isc_161 [125];	/* RDB$OWNER_NAME */
   } isc_143;
/**************************************
 *
 *	w r i t e _ r e l a t i o n s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each relation.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// if we have all capabilities, use the first request to get the
	// most performance out of the latest engine; if we don't
	// have one of the capabilities we must use the second set of
	// requests--this requires more code but it is well worth it
	// for the performance benefits, especially remotely--deej

	if (tdgbl->runtimeODS >= DB_VERSION_DDL11_1)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$RELATIONS WITH X.RDB$SYSTEM_FLAG NE 1 OR
			X.RDB$SYSTEM_FLAG MISSING*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_142), (char*) isc_142);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 683, &isc_143, (short) 0);
		   if (!isc_143.isc_149 || isc_status [1]) break;

			SSHORT flags = 0;
			put(tdgbl, rec_relation);
			const SSHORT l = PUT_TEXT (att_relation_name, /*X.RDB$RELATION_NAME*/
								      isc_143.isc_159);
			MISC_terminate (/*X.RDB$RELATION_NAME*/
					isc_143.isc_159, temp, l, sizeof(temp));
			if (/*X.RDB$VIEW_BLR.NULL*/
			    isc_143.isc_158)
				BURP_verbose(153, temp); // msg 153 writing table @1
			else
				BURP_verbose(345, temp); // msg 345 writing view @1

			// RDB$VIEW_BLR must be the first blob field in the backup file.
			// RESTORE.EPP makes this assumption in get_relation().

			if (put_blr_blob (att_relation_view_blr, /*X.RDB$VIEW_BLR*/
								 isc_143.isc_148))
				flags |= REL_view;
			if (/*X.RDB$SYSTEM_FLAG*/
			    isc_143.isc_157)
				put_int32 (att_relation_system_flag, /*X.RDB$SYSTEM_FLAG*/
								     isc_143.isc_157);
			if (!/*X.RDB$FLAGS.NULL*/
			     isc_143.isc_155)
				put_int32 (att_relation_flags, /*X.RDB$FLAGS*/
							       isc_143.isc_156);
			if (!/*X.RDB$SECURITY_CLASS.NULL*/
			     isc_143.isc_154)
				PUT_TEXT (att_relation_security_class, /*X.RDB$SECURITY_CLASS*/
								       isc_143.isc_160);

			put_source_blob (att_relation_description2, att_relation_description,
				/*X.RDB$DESCRIPTION*/
				isc_143.isc_147);
			put_source_blob (att_relation_view_source2, att_relation_view_source, /*X.RDB$VIEW_SOURCE*/
											      isc_143.isc_146);

			put_source_blob(att_relation_ext_description2, att_relation_ext_description,
							/*X.RDB$EXTERNAL_DESCRIPTION*/
							isc_143.isc_145);
			PUT_TEXT (att_relation_owner_name, /*X.RDB$OWNER_NAME*/
							   isc_143.isc_161);
			if (!/*X.RDB$EXTERNAL_FILE.NULL*/
			     isc_143.isc_153)
			{
				if (!tdgbl->gbl_sw_convert_ext_tables)
				{
					PUT_TEXT(att_relation_ext_file_name, /*X.RDB$EXTERNAL_FILE*/
									     isc_143.isc_144);
					flags |= REL_external;
				}
			}

			if (!/*X.RDB$RELATION_TYPE.NULL*/
			     isc_143.isc_151)
				put_int32 (att_relation_type, /*X.RDB$RELATION_TYPE*/
							      isc_143.isc_152);

			put(tdgbl, att_end);
			burp_rel* relation = (burp_rel*) BURP_alloc_zero (sizeof(burp_rel));
			relation->rel_next = tdgbl->relations;
			tdgbl->relations = relation;
			relation->rel_id = /*X.RDB$RELATION_ID*/
					   isc_143.isc_150;
			relation->rel_name_length = COPY(/*X.RDB$RELATION_NAME*/
							 isc_143.isc_159, relation->rel_name);
			relation->rel_flags |= flags;
			put_relation (relation);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$RELATIONS WITH X.RDB$SYSTEM_FLAG NE 1 OR
			X.RDB$SYSTEM_FLAG MISSING*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_125), (char*) isc_125);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 677, &isc_126, (short) 0);
		   if (!isc_126.isc_132 || isc_status [1]) break;

			SSHORT flags = 0;
			put(tdgbl, rec_relation);
			const SSHORT l = PUT_TEXT(att_relation_name, /*X.RDB$RELATION_NAME*/
								     isc_126.isc_139);
			MISC_terminate (/*X.RDB$RELATION_NAME*/
					isc_126.isc_139, temp, l, sizeof(temp));
			BURP_verbose (153, temp);
			// msg 153 writing table %.*s

			// RDB$VIEW_BLR must be the first blob field in the backup file.
			// RESTORE.EPP makes this assumption in get_relation().

			if (put_blr_blob (att_relation_view_blr, /*X.RDB$VIEW_BLR*/
								 isc_126.isc_131))
				flags |= REL_view;
			if (/*X.RDB$SYSTEM_FLAG*/
			    isc_126.isc_138)
				put_int32 (att_relation_system_flag, /*X.RDB$SYSTEM_FLAG*/
								     isc_126.isc_138);
			if (!/*X.RDB$FLAGS.NULL*/
			     isc_126.isc_136)
				put_int32 (att_relation_flags, /*X.RDB$FLAGS*/
							       isc_126.isc_137);
			if (!/*X.RDB$SECURITY_CLASS.NULL*/
			     isc_126.isc_135)
				PUT_TEXT(att_relation_security_class, /*X.RDB$SECURITY_CLASS*/
								      isc_126.isc_140);
			put_source_blob (att_relation_description2, att_relation_description, /*X.RDB$DESCRIPTION*/
											      isc_126.isc_130);
			put_source_blob (att_relation_view_source2, att_relation_view_source, /*X.RDB$VIEW_SOURCE*/
											      isc_126.isc_129);
			put_source_blob(att_relation_ext_description2, att_relation_ext_description,
							/*X.RDB$EXTERNAL_DESCRIPTION*/
							isc_126.isc_128);
			PUT_TEXT(att_relation_owner_name, /*X.RDB$OWNER_NAME*/
							  isc_126.isc_141);
			if (!/*X.RDB$EXTERNAL_FILE.NULL*/
			     isc_126.isc_134)
			{
				if (!tdgbl->gbl_sw_convert_ext_tables)
				{
					PUT_TEXT(att_relation_ext_file_name, /*X.RDB$EXTERNAL_FILE*/
									     isc_126.isc_127);
					flags |= REL_external;
				}
			}
			put(tdgbl, att_end);
			burp_rel* relation = (burp_rel*) BURP_alloc_zero (sizeof(burp_rel));
			relation->rel_next = tdgbl->relations;
			tdgbl->relations = relation;
			relation->rel_id = /*X.RDB$RELATION_ID*/
					   isc_126.isc_133;
			relation->rel_name_length = COPY(/*X.RDB$RELATION_NAME*/
							 isc_126.isc_139, relation->rel_name);
			relation->rel_flags |= flags;
			put_relation (relation);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}


void write_secclasses()
{
   struct isc_120_struct {
          ISC_QUAD isc_121;	/* RDB$DESCRIPTION */
          ISC_QUAD isc_122;	/* RDB$ACL */
          short isc_123;	/* isc_utility */
          char  isc_124 [125];	/* RDB$SECURITY_CLASS */
   } isc_120;
	TEXT temp[GDS_NAME_LEN];
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$SECURITY_CLASSES WITH X.RDB$SECURITY_CLASS NOT STARTING "SQL$"*/
	{
	if (!req_handle1)
	   {
	   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_119), (char*) isc_119);
	   }
	if (req_handle1)
	   {
	   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	   }
	if (!isc_status [1]) {
	while (1)
	   {
	   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 143, &isc_120, (short) 0);
	   if (!isc_120.isc_123 || isc_status [1]) break;
		put(tdgbl, rec_security_class);
		const ULONG l = PUT_TEXT (att_class_security_class, /*X.RDB$SECURITY_CLASS*/
								    isc_120.isc_124);
		MISC_terminate (/*X.RDB$SECURITY_CLASS*/
				isc_120.isc_124, temp, l, sizeof(temp));
		BURP_verbose (155, temp);
		// msg 155 writing security class @1
		put_blr_blob (att_class_acl, /*X.RDB$ACL*/
					     isc_120.isc_122);
		put_source_blob (att_class_description2, att_class_description, /*X.RDB$DESCRIPTION*/
										isc_120.isc_121);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_shadow_files()
{
   struct isc_111_struct {
          char  isc_112 [256];	/* RDB$FILE_NAME */
          ISC_LONG isc_113;	/* RDB$FILE_LENGTH */
          ISC_LONG isc_114;	/* RDB$FILE_START */
          short isc_115;	/* isc_utility */
          short isc_116;	/* RDB$SHADOW_NUMBER */
          short isc_117;	/* RDB$FILE_FLAGS */
          short isc_118;	/* RDB$FILE_SEQUENCE */
   } isc_111;
/**************************************
 *
 *	w r i t e _ s h a d o w _ f i l e s
 *
 **************************************
 *
 * Functional description
 *	Write out files to use as shadows.
 *
 **************************************/
	/*BASED ON RDB$FILES.RDB$FILE_NAME temp;*/
	char
	   temp[256];

	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$FILES
		WITH X.RDB$SHADOW_NUMBER NOT MISSING
		AND X.RDB$SHADOW_NUMBER NE 0*/
	{
	if (!req_handle1)
	   {
	   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_110), (char*) isc_110);
	   }
	if (req_handle1)
	   {
	   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	   }
	if (!isc_status [1]) {
	while (1)
	   {
	   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 272, &isc_111, (short) 0);
	   if (!isc_111.isc_115 || isc_status [1]) break;
		put(tdgbl, rec_files);
		const SSHORT l = PUT_TEXT (att_file_filename, /*X.RDB$FILE_NAME*/
							      isc_111.isc_112);
		MISC_terminate (/*X.RDB$FILE_NAME*/
				isc_111.isc_112, temp, l, sizeof(temp));
		BURP_verbose (163, temp);
		// msg 163 writing shadow file %s
		put_int32 (att_file_sequence, /*X.RDB$FILE_SEQUENCE*/
					      isc_111.isc_118);
		put_int32 (att_file_start, /*X.RDB$FILE_START*/
					   isc_111.isc_114);
		put_int32 (att_file_length, /*X.RDB$FILE_LENGTH*/
					    isc_111.isc_113);
		put_int32 (att_file_flags, /*X.RDB$FILE_FLAGS*/
					   isc_111.isc_117);
		put_int32 (att_shadow_number, /*X.RDB$SHADOW_NUMBER*/
					      isc_111.isc_116);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_sql_roles()
{
   struct isc_99_struct {
          short isc_100;	/* isc_utility */
          char  isc_101 [125];	/* RDB$ROLE_NAME */
          char  isc_102 [125];	/* RDB$OWNER_NAME */
   } isc_99;
   struct isc_104_struct {
          ISC_QUAD isc_105;	/* RDB$DESCRIPTION */
          short isc_106;	/* isc_utility */
          short isc_107;	/* gds__null_flag */
          char  isc_108 [125];	/* RDB$ROLE_NAME */
          char  isc_109 [125];	/* RDB$OWNER_NAME */
   } isc_104;
/**************************************
 *
 *	w r i t e _ s q l _ r o l e s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each SQL roles.
 *
 **************************************/
	isc_req_handle req_handle1 = 0;
	TEXT temp[GDS_NAME_LEN];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	if (tdgbl->runtimeODS >= DB_VERSION_DDL11)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$ROLES
			WITH X.RDB$SYSTEM_FLAG EQ 0 OR X.RDB$SYSTEM_FLAG MISSING*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_103), (char*) isc_103);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 262, &isc_104, (short) 0);
		   if (!isc_104.isc_106 || isc_status [1]) break;

			put(tdgbl, rec_sql_roles);
			const SSHORT l = PUT_TEXT(att_role_name, /*X.RDB$ROLE_NAME*/
								 isc_104.isc_108);
			PUT_TEXT (att_role_owner_name, /*X.RDB$OWNER_NAME*/
						       isc_104.isc_109);
			if (!/*X.RDB$DESCRIPTION.NULL*/
			     isc_104.isc_107) {
				put_source_blob (att_role_description, att_role_description, /*X.RDB$DESCRIPTION*/
											     isc_104.isc_105);
			}
			put(tdgbl, att_end);
			MISC_terminate (/*X.RDB$ROLE_NAME*/
					isc_104.isc_108, temp, l, sizeof(temp));
			BURP_verbose (249, temp);
			// msg 249 writing SQL role: %s

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$ROLES*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_98), (char*) isc_98);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 252, &isc_99, (short) 0);
		   if (!isc_99.isc_100 || isc_status [1]) break;

			put(tdgbl, rec_sql_roles);
			const SSHORT l = PUT_TEXT(att_role_name, /*X.RDB$ROLE_NAME*/
								 isc_99.isc_101);
			PUT_TEXT (att_role_owner_name, /*X.RDB$OWNER_NAME*/
						       isc_99.isc_102);
			put(tdgbl, att_end);
			MISC_terminate (/*X.RDB$ROLE_NAME*/
					isc_99.isc_101, temp, l, sizeof(temp));
			BURP_verbose (249, temp);
			// msg 249 writing SQL role: %s

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}


void write_mapping()
{
   struct isc_78_struct {
          short isc_79;	/* isc_utility */
          short isc_80;	/* RDB$SYSTEM_FLAG */
   } isc_78;
   struct isc_76_struct {
          char  isc_77 [125];	/* RDB$ROLE_NAME */
   } isc_76;
   struct isc_82_struct {
          ISC_QUAD isc_83;	/* RDB$DESCRIPTION */
          short isc_84;	/* isc_utility */
          short isc_85;	/* gds__null_flag */
          short isc_86;	/* gds__null_flag */
          short isc_87;	/* RDB$MAP_TO_TYPE */
          short isc_88;	/* gds__null_flag */
          short isc_89;	/* gds__null_flag */
          short isc_90;	/* gds__null_flag */
          char  isc_91 [125];	/* RDB$MAP_NAME */
          char  isc_92 [5];	/* RDB$MAP_USING */
          char  isc_93 [125];	/* RDB$MAP_PLUGIN */
          char  isc_94 [125];	/* RDB$MAP_DB */
          char  isc_95 [125];	/* RDB$MAP_FROM_TYPE */
          char  isc_96 [1021];	/* RDB$MAP_FROM */
          char  isc_97 [125];	/* RDB$MAP_TO */
   } isc_82;
/**************************************
 *
 *	w r i t e _ m a p p i n g
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each names mapping.
 *
 **************************************/
	isc_req_handle req_handle = 0;
	TEXT temp[GDS_NAME_LEN];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		/*FOR (REQUEST_HANDLE req_handle)
			M IN RDB$AUTH_MAPPING
			WITH M.RDB$SYSTEM_FLAG EQ 0*/
		{
		if (!req_handle)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle, (short) sizeof(isc_81), (char*) isc_81);
		   }
		if (req_handle)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle, (short) 0, (short) 1673, &isc_82, (short) 0);
		   if (!isc_82.isc_84 || isc_status [1]) break;

			put(tdgbl, rec_mapping);
			const SSHORT l = PUT_TEXT(att_map_name, /*M.RDB$MAP_NAME*/
								isc_82.isc_91);
			PUT_TEXT(att_map_using, /*M.RDB$MAP_USING*/
						isc_82.isc_92);

			if (!/*M.RDB$MAP_PLUGIN.NULL*/
			     isc_82.isc_90)
				PUT_TEXT(att_map_plugin, /*M.RDB$MAP_PLUGIN*/
							 isc_82.isc_93);

			if (!/*M.RDB$MAP_DB.NULL*/
			     isc_82.isc_89)
				PUT_TEXT(att_map_db, /*M.RDB$MAP_DB*/
						     isc_82.isc_94);

			PUT_TEXT(att_map_from_type, /*M.RDB$MAP_FROM_TYPE*/
						    isc_82.isc_95);

			if (!/*M.RDB$MAP_FROM.NULL*/
			     isc_82.isc_88)
				PUT_TEXT(att_map_from, /*M.RDB$MAP_FROM*/
						       isc_82.isc_96);

			put_int32(att_map_to_type, /*M.RDB$MAP_TO_TYPE*/
						   isc_82.isc_87);

			if (!/*M.RDB$MAP_TO.NULL*/
			     isc_82.isc_86)
				PUT_TEXT(att_map_to, /*M.RDB$MAP_TO*/
						     isc_82.isc_97);

			if (!/*M.RDB$DESCRIPTION.NULL*/
			     isc_82.isc_85)
				put_source_blob(att_map_description, att_map_description, /*M.RDB$DESCRIPTION*/
											  isc_82.isc_83);

			put(tdgbl, att_end);

			MISC_terminate (/*M.RDB$MAP_NAME*/
					isc_82.isc_91, temp, l, sizeof(temp));
			BURP_verbose (297, temp);
			// msg 297 writing mapping for %s

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else if (tdgbl->runtimeODS >= DB_VERSION_DDL11_2)
	{
		/*FOR (REQUEST_HANDLE req_handle)
			X IN RDB$ROLES
			WITH X.RDB$ROLE_NAME EQ ADMIN_ROLE*/
		{
		if (!req_handle)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle, (short) sizeof(isc_75), (char*) isc_75);
		   }
		isc_vtov ((const char*) ADMIN_ROLE, (char*) isc_76.isc_77, 125);
		if (req_handle)
		   {
		   isc_start_and_send (isc_status, (FB_API_HANDLE*) &req_handle, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_76, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle, (short) 1, (short) 4, &isc_78, (short) 0);
		   if (!isc_78.isc_79 || isc_status [1]) break;

			if (/*X.RDB$SYSTEM_FLAG*/
			    isc_78.isc_80 == 6)		// constant 6 turns on auto admin mapping in FB 2.5
			{
				put(tdgbl, rec_mapping);
				put_text(att_auto_map_role, ADMIN_ROLE, static_cast<SSHORT>(strlen(ADMIN_ROLE) + 1));
				put(tdgbl, att_end);
				BURP_verbose (297, ADMIN_ROLE);
				// msg 297 writing mapping for @1
			}

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle);
}


void write_db_creators()
{
   struct isc_69_struct {
          short isc_70;	/* isc_utility */
          short isc_71;	/* gds__null_flag */
          short isc_72;	/* gds__null_flag */
          short isc_73;	/* RDB$USER_TYPE */
          char  isc_74 [125];	/* RDB$USER */
   } isc_69;
/**************************************
 *
 *	w r i t e _ d b _ c r e a t o r s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each grant to create database.
 *
 **************************************/
	isc_req_handle req_handle = 0;
	TEXT temp[GDS_NAME_LEN];
	bool first = true;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle)
		C IN RDB$DB_CREATORS*/
	{
	if (!req_handle)
	   {
	   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle, (short) sizeof(isc_68), (char*) isc_68);
	   }
	if (req_handle)
	   {
	   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle, (FB_API_HANDLE*) &gds_trans, (short) 0);
	   }
	if (!isc_status [1]) {
	while (1)
	   {
	   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle, (short) 0, (short) 133, &isc_69, (short) 0);
	   if (!isc_69.isc_70 || isc_status [1]) break;

		if (first)
		{
			BURP_verbose(391);
			// msg 391 writing database create grants
			first = false;
		}

		bool fl = true;

		if (!/*C.RDB$USER_TYPE.NULL*/
		     isc_69.isc_72)
		{
			put(tdgbl, rec_db_creator);
			fl = false;
			put_int32(att_dbc_type, /*C.RDB$USER_TYPE*/
						isc_69.isc_73);
		}

		if (!/*C.RDB$USER.NULL*/
		     isc_69.isc_71)
		{
			if (fl)
				put(tdgbl, rec_db_creator);
			fl = false;
			const SSHORT l = PUT_TEXT(att_dbc_user, /*C.RDB$USER*/
								isc_69.isc_74);

			MISC_terminate (/*C.RDB$USER*/
					isc_69.isc_74, temp, l, sizeof(temp));
			BURP_verbose (392, temp);
			// msg 392 writing db creator %s
		}

		if (!fl)
			put(tdgbl, att_end);

	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle);
}


void write_triggers()
{
   struct isc_31_struct {
          ISC_QUAD isc_32;	/* RDB$DESCRIPTION */
          ISC_QUAD isc_33;	/* RDB$TRIGGER_SOURCE */
          ISC_QUAD isc_34;	/* RDB$TRIGGER_BLR */
          ISC_INT64 isc_35;	/* RDB$TRIGGER_TYPE */
          short isc_36;	/* isc_utility */
          short isc_37;	/* gds__null_flag */
          short isc_38;	/* RDB$FLAGS */
          short isc_39;	/* RDB$TRIGGER_INACTIVE */
          short isc_40;	/* RDB$SYSTEM_FLAG */
          short isc_41;	/* RDB$TRIGGER_SEQUENCE */
          short isc_42;	/* gds__null_flag */
          char  isc_43 [125];	/* RDB$TRIGGER_NAME */
          char  isc_44 [125];	/* RDB$RELATION_NAME */
   } isc_31;
   struct isc_46_struct {
          char  isc_47 [256];	/* RDB$ENTRYPOINT */
          ISC_QUAD isc_48;	/* RDB$DEBUG_INFO */
          ISC_QUAD isc_49;	/* RDB$DESCRIPTION */
          ISC_QUAD isc_50;	/* RDB$TRIGGER_SOURCE */
          ISC_QUAD isc_51;	/* RDB$TRIGGER_BLR */
          ISC_INT64 isc_52;	/* RDB$TRIGGER_TYPE */
          short isc_53;	/* isc_utility */
          short isc_54;	/* gds__null_flag */
          short isc_55;	/* gds__null_flag */
          short isc_56;	/* gds__null_flag */
          short isc_57;	/* gds__null_flag */
          short isc_58;	/* RDB$VALID_BLR */
          short isc_59;	/* gds__null_flag */
          short isc_60;	/* RDB$FLAGS */
          short isc_61;	/* RDB$TRIGGER_INACTIVE */
          short isc_62;	/* RDB$SYSTEM_FLAG */
          short isc_63;	/* RDB$TRIGGER_SEQUENCE */
          short isc_64;	/* gds__null_flag */
          char  isc_65 [125];	/* RDB$TRIGGER_NAME */
          char  isc_66 [125];	/* RDB$RELATION_NAME */
          char  isc_67 [125];	/* RDB$ENGINE_NAME */
   } isc_46;
/**************************************
 *
 *	w r i t e _ t r i g g e r s
 *
 **************************************
 *
 * Functional description
 * 	write the triggers in rdb$triggers
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// if we have all capabilities, use the first request to get the
	// most performance out of the latest engine; if we don't
	// have one of the capabilities we must use the second set of
	// requests--this requires more code but it is well worth it
	// for the performance benefits, especially remotely--deej

	if (tdgbl->runtimeODS >= DB_VERSION_DDL11_1)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$TRIGGERS WITH
			X.RDB$SYSTEM_FLAG NE 1 OR
			X.RDB$SYSTEM_FLAG MISSING*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_45), (char*) isc_45);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 695, &isc_46, (short) 0);
		   if (!isc_46.isc_53 || isc_status [1]) break;

			put(tdgbl, rec_trigger);
			const SSHORT l = PUT_TEXT (att_trig_name, /*X.RDB$TRIGGER_NAME*/
								  isc_46.isc_65);
			MISC_terminate (/*X.RDB$TRIGGER_NAME*/
					isc_46.isc_65, temp, l, sizeof(temp));
			BURP_verbose (156, temp);
			// msg 156   writing trigger %s

			if (!/*X.RDB$RELATION_NAME.NULL*/
			     isc_46.isc_64)
				PUT_TEXT (att_trig_relation_name, /*X.RDB$RELATION_NAME*/
								  isc_46.isc_66);

			put_int32 (att_trig_sequence, /*X.RDB$TRIGGER_SEQUENCE*/
						      isc_46.isc_63);

			if (/*X.RDB$TRIGGER_TYPE*/
			    isc_46.isc_52 >= SLONG_MIN && /*X.RDB$TRIGGER_TYPE*/
		 isc_46.isc_52 <= SLONG_MAX)
				put_int32 (att_trig_type, (SLONG) /*X.RDB$TRIGGER_TYPE*/
								  isc_46.isc_52);
			else
				put_int64 (att_trig_type2, /*X.RDB$TRIGGER_TYPE*/
							   isc_46.isc_52);

			put_blr_blob (att_trig_blr, /*X.RDB$TRIGGER_BLR*/
						    isc_46.isc_51);
			put_source_blob (att_trig_source2, att_trig_source, /*X.RDB$TRIGGER_SOURCE*/
									    isc_46.isc_50);
			put_source_blob (att_trig_description2, att_trig_description, /*X.RDB$DESCRIPTION*/
										      isc_46.isc_49);
			put_int32 (att_trig_system_flag, /*X.RDB$SYSTEM_FLAG*/
							 isc_46.isc_62);
			put_int32 (att_trig_inactive, /*X.RDB$TRIGGER_INACTIVE*/
						      isc_46.isc_61);

			if (!/*X.RDB$FLAGS.NULL*/
			     isc_46.isc_59)
				put_int32 (att_trig_flags, /*X.RDB$FLAGS*/
							   isc_46.isc_60);

			if (!/*X.RDB$VALID_BLR.NULL*/
			     isc_46.isc_57)
				put_int32 (att_trig_valid_blr, /*X.RDB$VALID_BLR*/
							       isc_46.isc_58);

			if (!/*X.RDB$DEBUG_INFO.NULL*/
			     isc_46.isc_56)
				put_blr_blob (att_trig_debug_info, /*X.RDB$DEBUG_INFO*/
								   isc_46.isc_48);

			if (!/*X.RDB$ENGINE_NAME.NULL*/
			     isc_46.isc_55)
				PUT_TEXT(att_trig_engine_name, /*X.RDB$ENGINE_NAME*/
							       isc_46.isc_67);

			if (!/*X.RDB$ENTRYPOINT.NULL*/
			     isc_46.isc_54)
				PUT_TEXT(att_trig_entrypoint, /*X.RDB$ENTRYPOINT*/
							      isc_46.isc_47);

			put(tdgbl, att_end);

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$TRIGGERS WITH
			X.RDB$SYSTEM_FLAG NE 1 OR
			X.RDB$SYSTEM_FLAG MISSING*/
		{
		if (!req_handle1)
		   {
		   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_30), (char*) isc_30);
		   }
		if (req_handle1)
		   {
		   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		   }
		if (!isc_status [1]) {
		while (1)
		   {
		   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 296, &isc_31, (short) 0);
		   if (!isc_31.isc_36 || isc_status [1]) break;

			put(tdgbl, rec_trigger);
			const SSHORT l = PUT_TEXT (att_trig_name, /*X.RDB$TRIGGER_NAME*/
								  isc_31.isc_43);
			MISC_terminate (/*X.RDB$TRIGGER_NAME*/
					isc_31.isc_43, temp, l, sizeof(temp));
			BURP_verbose (156, temp);
			// msg 156   writing trigger %s

			if (!/*X.RDB$RELATION_NAME.NULL*/
			     isc_31.isc_42)
				PUT_TEXT (att_trig_relation_name, /*X.RDB$RELATION_NAME*/
								  isc_31.isc_44);

			put_int32 (att_trig_sequence, /*X.RDB$TRIGGER_SEQUENCE*/
						      isc_31.isc_41);
			put_int32 (att_trig_type, /*X.RDB$TRIGGER_TYPE*/
						  isc_31.isc_35);
			put_blr_blob (att_trig_blr, /*X.RDB$TRIGGER_BLR*/
						    isc_31.isc_34);
			put_source_blob (att_trig_source2, att_trig_source, /*X.RDB$TRIGGER_SOURCE*/
									    isc_31.isc_33);
			put_source_blob (att_trig_description2, att_trig_description, /*X.RDB$DESCRIPTION*/
										      isc_31.isc_32);
			put_int32 (att_trig_system_flag, /*X.RDB$SYSTEM_FLAG*/
							 isc_31.isc_40);
			put_int32 (att_trig_inactive, /*X.RDB$TRIGGER_INACTIVE*/
						      isc_31.isc_39);

			if (!/*X.RDB$FLAGS.NULL*/
			     isc_31.isc_37)
				put_int32 (att_trig_flags, /*X.RDB$FLAGS*/
							   isc_31.isc_38);

			put(tdgbl, att_end);

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}


void write_trigger_messages()
{
   struct isc_25_struct {
          char  isc_26 [1024];	/* RDB$MESSAGE */
          short isc_27;	/* isc_utility */
          short isc_28;	/* RDB$MESSAGE_NUMBER */
          char  isc_29 [125];	/* RDB$TRIGGER_NAME */
   } isc_25;
/**************************************
 *
 *	w r i t e _ t r i g g e r _ m e s s a g e s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each trigger message.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		T IN RDB$TRIGGERS CROSS X IN RDB$TRIGGER_MESSAGES
		OVER RDB$TRIGGER_NAME
		WITH T.RDB$SYSTEM_FLAG NE 1 OR T.RDB$SYSTEM_FLAG MISSING*/
	{
	if (!req_handle1)
	   {
	   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_24), (char*) isc_24);
	   }
	if (req_handle1)
	   {
	   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	   }
	if (!isc_status [1]) {
	while (1)
	   {
	   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 1153, &isc_25, (short) 0);
	   if (!isc_25.isc_27 || isc_status [1]) break;

		put(tdgbl, rec_trigger_message);
		const SSHORT l = PUT_TEXT (att_trigmsg_name, /*X.RDB$TRIGGER_NAME*/
							     isc_25.isc_29);
		MISC_terminate (/*X.RDB$TRIGGER_NAME*/
				isc_25.isc_29, temp, l, sizeof(temp));
		BURP_verbose (157, temp);
		// msg 157 writing trigger message for *s
		put_int32 (att_trigmsg_number, /*X.RDB$MESSAGE_NUMBER*/
					       isc_25.isc_28);
		PUT_MESSAGE (att_trigmsg_text, att_end, /*X.RDB$MESSAGE*/
							isc_25.isc_26);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_types()
{
   struct isc_17_struct {
          ISC_QUAD isc_18;	/* RDB$DESCRIPTION */
          short isc_19;	/* isc_utility */
          short isc_20;	/* RDB$SYSTEM_FLAG */
          short isc_21;	/* RDB$TYPE */
          char  isc_22 [125];	/* RDB$TYPE_NAME */
          char  isc_23 [125];	/* RDB$FIELD_NAME */
   } isc_17;
/**************************************
 *
 *	w r i t e _ t y p e s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each type.
 *
 **************************************/
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$TYPES WITH X.RDB$SYSTEM_FLAG NE 1 OR
		X.RDB$SYSTEM_FLAG MISSING*/
	{
	if (!req_handle1)
	   {
	   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_16), (char*) isc_16);
	   }
	if (req_handle1)
	   {
	   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	   }
	if (!isc_status [1]) {
	while (1)
	   {
	   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 264, &isc_17, (short) 0);
	   if (!isc_17.isc_19 || isc_status [1]) break;
		put(tdgbl, rec_system_type);
		PUT_TEXT (att_type_name, /*X.RDB$TYPE_NAME*/
					 isc_17.isc_22);
		PUT_TEXT (att_type_field_name, /*X.RDB$FIELD_NAME*/
					       isc_17.isc_23);
		BURP_verbose (160, SafeArg() << /*X.RDB$TYPE_NAME*/
						isc_17.isc_22 << /*X.RDB$FIELD_NAME*/
    isc_17.isc_23);
		// msg 160 writing type %s for field %s
		put_int32 (att_type_type, /*X.RDB$TYPE*/
					  isc_17.isc_21);
		put_source_blob (att_type_description2, att_type_description, /*X.RDB$DESCRIPTION*/
									      isc_17.isc_18);
		if (/*X.RDB$SYSTEM_FLAG*/
		    isc_17.isc_20)
			put_int32 (att_type_system_flag, /*X.RDB$SYSTEM_FLAG*/
							 isc_17.isc_20);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_user_privileges()
{
   struct isc_5_struct {
          short isc_6;	/* isc_utility */
          short isc_7;	/* RDB$OBJECT_TYPE */
          short isc_8;	/* RDB$USER_TYPE */
          short isc_9;	/* gds__null_flag */
          short isc_10;	/* RDB$GRANT_OPTION */
          char  isc_11 [125];	/* RDB$USER */
          char  isc_12 [125];	/* RDB$GRANTOR */
          char  isc_13 [7];	/* RDB$PRIVILEGE */
          char  isc_14 [125];	/* RDB$RELATION_NAME */
          char  isc_15 [125];	/* RDB$FIELD_NAME */
   } isc_5;
/**************************************
 *
 *	w r i t e _ u s e r _ p r i v i l e g e s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each user privilege.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$USER_PRIVILEGES
		WITH X.RDB$GRANTOR NOT MISSING*/
	{
	if (!req_handle1)
	   {
	   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof(isc_4), (char*) isc_4);
	   }
	if (req_handle1)
	   {
	   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	   }
	if (!isc_status [1]) {
	while (1)
	   {
	   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 517, &isc_5, (short) 0);
	   if (!isc_5.isc_6 || isc_status [1]) break;
		put(tdgbl, rec_user_privilege);
		const SSHORT l = PUT_TEXT (att_priv_user, /*X.RDB$USER*/
							  isc_5.isc_11);
		MISC_terminate (/*X.RDB$USER*/
				isc_5.isc_11, temp, l, sizeof(temp));
		BURP_verbose (152, temp);
		// msg 152 writing privilege for user %s
		PUT_TEXT (att_priv_grantor, /*X.RDB$GRANTOR*/
					    isc_5.isc_12);
		PUT_TEXT (att_priv_privilege, /*X.RDB$PRIVILEGE*/
					      isc_5.isc_13);
		put_int32 (att_priv_grant_option, /*X.RDB$GRANT_OPTION*/
						  isc_5.isc_10);
		PUT_TEXT (att_priv_object_name, /*X.RDB$RELATION_NAME*/
						isc_5.isc_14);
		if (!/*X.RDB$FIELD_NAME.NULL*/
		     isc_5.isc_9)
		   PUT_TEXT (att_priv_field_name, /*X.RDB$FIELD_NAME*/
						  isc_5.isc_15);
		put_int32 (att_priv_user_type, /*X.RDB$USER_TYPE*/
					       isc_5.isc_8);
		put_int32 (att_priv_obj_type, /*X.RDB$OBJECT_TYPE*/
					      isc_5.isc_7);
		put(tdgbl, att_end);
	/*END_FOR*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}

} // namespace

